import { openBlock as N, createElementBlock as O, Fragment as ge, renderList as ve, normalizeClass as Q, createBlock as St, resolveDynamicComponent as Bt, mergeProps as yt, createElementVNode as E, createCommentVNode as Y, createTextVNode as on, resolveComponent as Ze, toDisplayString as Te, createVNode as xe, renderSlot as at, withDirectives as $e, vShow as Ti, pushScopeId as xi, popScopeId as Di, vModelSelect as rn, vModelText as Ai, normalizeProps as Re, vModelDynamic as Ir, guardReactiveProps as Ve, vModelRadio as Mr, vModelCheckbox as Br } from "vue";
const jr = {
  props: {
    only: {
      type: Array,
      required: !1
    },
    except: {
      type: Array,
      required: !1
    },
    orderByOnly: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  methods: {
    subset(s) {
      if (this.only || this.except) {
        let g = Object.keys(s).filter(
          (u) => this.only ? this.only.includes(u) : !this.except.includes(u)
        ).reduce((u, K) => (u[K] = s[K], u), {});
        if (this.orderByOnly && !this.except) {
          let u = {};
          this.only.forEach((K) => {
            u[K] = g[K];
          }), g = u;
        }
        return g;
      }
      return s;
    }
  }
}, Li = {
  mixins: [jr],
  props: {
    columns: {
      type: Number,
      required: !1,
      default: 1,
      validator: function(s) {
        return 12 % s === 0;
      }
    },
    spread: {
      type: Boolean,
      required: !1,
      default: !0
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    colClass: {
      type: String,
      required: !1,
      default: null
    },
    componentClass: {
      type: String,
      required: !1,
      default: null
    }
  },
  methods: {
    rows(s) {
      const g = this.subset(s), u = Object.keys(g), K = u.length, U = Math.ceil(K / this.columns);
      let B = [...Array(U).keys()];
      for (const M in B) {
        let R = [];
        for (let re = M * this.columns; re <= M * this.columns + (this.columns - 1); re++)
          if (u[re]) {
            const ue = { ...g[u[re]] };
            ue.key = u[re], R.push(ue);
          }
        B[M] = R;
      }
      return B;
    },
    colSize(s) {
      let g = 12 / this.columns;
      return s.length < this.columns && this.spread && (g = Math.floor(12 / s.length)), g;
    }
  }
}, Ue = {
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    labelColumnSize: {
      type: Number,
      required: !1,
      default: 6,
      validator: function(s) {
        return s < 12;
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    helperText: {
      type: String,
      required: !1,
      default: ""
    },
    helperTextClass: {
      type: String,
      required: !1,
      default: ""
    }
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        this.setFilterLoadData(this.filter.key, s);
      }
    }
  },
  methods: {
    setFilterLoadData(s, g) {
      this.setFilter(s, g), !this.synchronous && this.pageDefinition.loadData && this.loadData();
    }
  }
};
const _e = (s, g) => {
  const u = s.__vccOpts || s;
  for (const [K, U] of g)
    u[K] = U;
  return u;
}, zr = {
  name: "FilterGrid",
  mixins: [Li, Ue],
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    clearButton: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right", "none"].includes(s);
      }
    }
  },
  methods: {
    initializeDefaultsLoadData() {
      this.initializeDefaults(
        this.subset(this.filters) ? Object.keys(this.subset(this.filters)) : null
      ), !this.synchronous && this.pageDefinition.loadData && this.loadData();
    }
  }
}, $r = ["id"], Vr = {
  key: 0,
  class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow"
}, Wr = /* @__PURE__ */ on(" \xA0 ");
function Qr(s, g, u, K, U, B) {
  return N(), O("div", null, [
    (N(!0), O(ge, null, ve(s.rows(this.filters), (M, R) => (N(), O("div", {
      class: Q("row harness-vue-bootstrap-filtergrid-row " + s.rowClass),
      key: R
    }, [
      (N(!0), O(ge, null, ve(M, (re, ue) => (N(), O("div", {
        class: Q(
          "harness-vue-bootstrap-filtergrid-col col-sm-" + 12 / s.columns + " " + s.colClass
        ),
        key: s.pageDefinition.key + "-" + ue,
        id: re.key + "-col"
      }, [
        (N(), St(Bt(re.component), yt({ filter: re, ...re.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-filtergrid-" + re.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 10, $r))), 128))
    ], 2))), 128)),
    (u.synchronous || u.clearButton) && u.buttonPosition !== "none" ? (N(), O("div", Vr, [
      E("div", {
        class: Q("col-md-12 text-" + u.buttonPosition)
      }, [
        u.synchronous ? (N(), O("button", {
          key: 0,
          class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-applybutton",
          onClick: g[0] || (g[0] = (...M) => s.loadData && s.loadData(...M)),
          role: "button"
        }, " Apply Filters ")) : Y("", !0),
        Wr,
        u.clearButton ? (N(), O("button", {
          key: 1,
          role: "button",
          class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
          onClick: g[1] || (g[1] = (...M) => B.initializeDefaultsLoadData && B.initializeDefaultsLoadData(...M))
        }, " Clear Filters ")) : Y("", !0)
      ], 2)
    ])) : Y("", !0)
  ]);
}
const Kr = /* @__PURE__ */ _e(zr, [["render", Qr], ["__scopeId", "data-v-8954e783"]]), Ur = {
  name: "ChartGrid",
  mixins: [Li],
  computed: {
    chartRows() {
      return this.rows(this.charts);
    }
  }
};
function Gr(s, g, u, K, U, B) {
  return N(), O("div", null, [
    (N(!0), O(ge, null, ve(B.chartRows, (M, R) => (N(), O("div", {
      class: Q("row harness-vue-bootstrap-chartgrid-row " + s.rowClass),
      key: R
    }, [
      (N(!0), O(ge, null, ve(M, (re, ue) => (N(), O("div", {
        class: Q("col-md-" + s.colSize(M) + " " + s.colClass),
        key: ue
      }, [
        (N(), St(Bt(re.component), yt({ chart: re, ...re.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-chartgrid-" + re.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 2))), 128))
    ], 2))), 128))
  ]);
}
const Xr = /* @__PURE__ */ _e(Ur, [["render", Gr]]), Jr = {
  name: "GridWithFilters",
  props: ["columns"]
}, Yr = { class: "display-4" }, Zr = { class: "row" }, es = { class: "col-md-12" }, ts = { class: "card" }, ns = /* @__PURE__ */ E("div", { class: "card-header" }, "Filters", -1), is = { class: "card-body" };
function rs(s, g, u, K, U, B) {
  const M = Ze("FilterGrid"), R = Ze("ChartGrid");
  return N(), O("div", null, [
    E("h1", Yr, Te(s.page.title), 1),
    E("div", Zr, [
      E("div", es, [
        E("div", ts, [
          ns,
          E("div", is, [
            xe(M)
          ])
        ])
      ])
    ]),
    xe(R, { columns: u.columns }, null, 8, ["columns"])
  ]);
}
const ss = /* @__PURE__ */ _e(Jr, [["render", rs]]), qi = {
  props: {
    chart: {
      type: Object,
      required: !0
    },
    tableClass: {
      type: String,
      required: !1,
      default: null
    },
    headerClass: {
      type: String,
      required: !1,
      default: null
    },
    labelClass: {
      type: String,
      required: !1,
      default: null
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    cellClass: {
      type: String,
      required: !1,
      default: null
    },
    rowHeaderCol: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    validatedChartData() {
      return this.validateChartData(this.chartData, this.chart.key);
    }
  }
};
const as = {
  name: "DataTable508",
  mixins: [qi],
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    chartData() {
      let s = this.getChartData(this.chart.key) || null, g = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && g)
        try {
          return g(
            this.chart,
            this.filters,
            s,
            this.pageStore
          );
        } catch (u) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(u)
          );
        }
      return s;
    }
  }
}, os = ["id"], ls = ["innerHTML"], us = ["innerHTML"], cs = ["innerHTML"];
function fs(s, g, u, K, U, B) {
  return s.validatedChartData && s.validatedChartData.length ? (N(), O("div", {
    key: 0,
    id: s.chart.key + "_data_table",
    class: "harness-vue-bootstrap-datatable"
  }, [
    E("table", {
      class: Q("harness-vue-bootstrap-table table " + s.tableClass)
    }, [
      E("thead", {
        class: Q(s.headerClass)
      }, [
        E("tr", null, [
          (N(!0), O(ge, null, ve(B.columnHeaders, (M, R) => (N(), O("th", {
            scope: "col",
            key: R,
            class: Q(s.labelClass),
            innerHTML: M
          }, null, 10, ls))), 128))
        ])
      ], 2),
      E("tbody", null, [
        (N(!0), O(ge, null, ve(s.validatedChartData, (M, R) => (N(), O("tr", {
          key: R,
          class: Q(s.rowClass)
        }, [
          (N(!0), O(ge, null, ve(B.columnHeaders, (re, ue) => (N(), O(ge, null, [
            ue === 0 && s.rowHeaderCol ? (N(), O("th", {
              key: ue,
              class: Q(s.cellClass),
              innerHTML: M[re],
              scope: "row"
            }, null, 10, us)) : (N(), O("td", {
              key: `${ue}-else`,
              class: Q(s.cellClass),
              innerHTML: M[re]
            }, null, 10, cs))
          ], 64))), 256))
        ], 2))), 128))
      ])
    ], 2)
  ], 8, os)) : Y("", !0);
}
const hs = /* @__PURE__ */ _e(as, [["render", fs], ["__scopeId", "data-v-5a510616"]]);
const ds = {
  name: "ChartWithTable",
  props: {
    chart: {
      type: Object,
      required: !0
    },
    chartComponent: {
      type: [Object, Function],
      required: !0
    },
    tableDisplay: {
      type: String,
      required: !1,
      default: "toggle"
    },
    scrollable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    downloadable: {
      type: Boolean,
      required: !1,
      default: !0
    },
    card: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "top"
    },
    saveImageButton: {
      type: Function,
      required: !1
    },
    collapsible: {
      type: Boolean,
      required: !1,
      default: !1
    },
    collapsibleFunc: {
      type: Function,
      required: !1,
      default: () => !0
    },
    startCollapsed: {
      type: Boolean,
      required: !1,
      default: !1
    },
    showTableButtonText: {
      type: String,
      required: !1,
      default: "Show Table"
    },
    showChartButtonText: {
      type: String,
      required: !1,
      default: "Show Chart"
    }
  },
  data: function() {
    return {
      view: "chart",
      chartReady: !1,
      collapsed: this.startCollapsed
    };
  },
  methods: {
    toggleView() {
      switch (this.view) {
        case "chart":
          this.view = "table";
          break;
        case "table":
          this.view = "chart";
          break;
      }
      this.$emit("view", this.view);
    },
    toggleCollapse() {
      this.collapsed = !this.collapsed, this.$emit("collapsed", this.collapsed), this.collapsibleFunc();
    }
  },
  computed: {
    labels() {
      let s = {};
      return this.$attrs.tableColumns && this.$attrs.tableColumnLabels ? (s.tableColumns = this.$attrs.tableColumns, s.tableColumnLabels = this.$attrs.tableColumnLabels) : this.getChartProps(this.chart.key).tableColumns && this.getChartProps(this.chart.key).tableColumnLabels && (s.tableColumns = this.getChartProps(this.chart.key).tableColumns, s.tableColumnLabels = this.getChartProps(
        this.chart.key
      ).tableColumnLabels), s;
    },
    scroll() {
      return this.scrollable ? "height:" + this.getChartProps(this.chart.key).height + "px;overflow-y:auto;" : "";
    }
  }
}, ps = (s) => (xi("data-v-e22bbf85"), s = s(), Di(), s), gs = ["id"], ys = { class: "row" }, ms = { class: "harness-vue-bootstrap-chartwithtable-title" }, vs = ["aria-controls"], bs = { class: "harness-vue-bootstrap-chartwithtable-subtitle" }, ks = {
  key: 0,
  class: "col-md-6"
}, ws = {
  id: "button-container",
  class: "float-right"
}, Cs = ["aria-label"], Ts = ["innerHTML"], _s = ["aria-label"], Ss = ["innerHTML"], xs = ["aria-label"], Ds = ["aria-label"], As = ["id"], Ls = { class: "harness-vue-bootstrap-chartwithtable-abovechart" }, qs = /* @__PURE__ */ ps(() => /* @__PURE__ */ E("br", null, null, -1)), Es = { class: "harness-vue-bootstrap-chartwithtable-belowchart" }, Ns = ["id"], Ps = {
  id: "button-container",
  class: "float-right"
}, Os = ["aria-label"], Hs = ["innerHTML"], Fs = ["aria-label"], Rs = ["innerHTML"], Is = { key: 2 }, Ms = ["aria-label"], Bs = { key: 3 }, js = ["aria-label"];
function zs(s, g, u, K, U, B) {
  const M = Ze("DataTable508");
  return N(), O("div", {
    id: u.chart.key + "_container",
    class: Q((u.card ? "card" : "") + " harness-vue-bootstrap-chartwithtable")
  }, [
    E("div", {
      class: Q(u.card ? "card-header" : "")
    }, [
      E("div", ys, [
        E("div", {
          class: Q(u.buttonPosition === "top" ? "col-md-6" : "col-md-12")
        }, [
          E("h3", {
            class: Q(u.card ? "card-title" : "")
          }, [
            E("div", ms, [
              E("div", null, [
                at(s.$slots, "title", {}, () => [
                  on(Te(u.chart.title), 1)
                ], !0),
                u.collapsible ? (N(), O("button", {
                  key: 0,
                  id: "collapseButton",
                  "data-toggle": "collapse",
                  "aria-expanded": "false",
                  "aria-controls": u.chart.key + "ChartTableBody " + u.chart.key + "Buttons",
                  onClick: g[0] || (g[0] = (...R) => B.toggleCollapse && B.toggleCollapse(...R)),
                  "aria-label": "Toggle Chart"
                }, Te(s.collapsed ? "+" : "-"), 9, vs)) : Y("", !0)
              ]),
              E("div", bs, [
                at(s.$slots, "subtitle", {}, void 0, !0)
              ])
            ])
          ], 2)
        ], 2),
        u.buttonPosition === "top" ? (N(), O("div", ks, [
          E("h3", {
            class: Q(
              "harness-vue-bootstrap-chartwithtable-buttonrow" + (u.card ? " card-title" : "")
            )
          }, [
            E("span", ws, [
              u.tableDisplay == "toggle" && s.view == "chart" ? (N(), O("button", {
                key: 0,
                role: "button",
                "aria-label": "Show Table: " + (u.chart.title || u.chart.key),
                onClick: g[1] || (g[1] = (...R) => B.toggleView && B.toggleView(...R)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
              }, [
                E("span", { innerHTML: u.showTableButtonText }, null, 8, Ts)
              ], 8, Cs)) : Y("", !0),
              u.tableDisplay == "toggle" && s.view == "table" ? (N(), O("button", {
                key: 1,
                role: "button",
                "aria-label": "Show Chart: " + (u.chart.title || u.chart.key),
                onClick: g[2] || (g[2] = (...R) => B.toggleView && B.toggleView(...R)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
              }, [
                E("span", { innerHTML: u.showChartButtonText }, null, 8, Ss)
              ], 8, _s)) : Y("", !0),
              u.downloadable && s.getChartData(u.chart.key) ? (N(), O("button", {
                key: 2,
                role: "button",
                "aria-label": "Download Table: " + (u.chart.title || u.chart.key),
                onClick: g[3] || (g[3] = (R) => s.downloadCSV(u.chart.key)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
              }, " Download CSV ", 8, xs)) : Y("", !0),
              u.saveImageButton && s.getChartData(u.chart.key) ? (N(), O("button", {
                key: 3,
                role: "button",
                "aria-label": "Download Table: " + (u.chart.title || u.chart.key),
                onClick: g[4] || (g[4] = (R) => u.saveImageButton()),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
              }, " Save Image ", 8, Ds)) : Y("", !0),
              at(s.$slots, "additional-buttons", {}, void 0, !0)
            ])
          ], 2)
        ])) : Y("", !0)
      ])
    ], 2),
    E("div", {
      id: u.chart.key + "ChartTableBody",
      class: Q(
        "card-body harness-vue-bootstrap-chartwithtable-body" + (u.collapsible ? " " + u.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show")
      )
    }, [
      E("div", Ls, [
        at(s.$slots, "above-chart", {}, void 0, !0)
      ]),
      $e((N(), St(Bt(u.chartComponent), yt({ chart: u.chart, ...u.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + u.chart.key + "chart"
      }), null, 16)), [
        [Ti, u.tableDisplay != "toggle" || s.view == "chart"]
      ]),
      qs,
      E("div", Es, [
        at(s.$slots, "below-chart", {}, void 0, !0)
      ]),
      $e((N(), St(M, yt({ chart: u.chart, ...u.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + u.chart.key + "table",
        style: B.scroll
      }), null, 16, ["style"])), [
        [Ti, u.tableDisplay != "toggle" || s.view == "table"]
      ])
    ], 10, As),
    u.buttonPosition === "bottom" ? (N(), O("h3", {
      key: 0,
      id: u.chart.key + "Buttons",
      class: Q(
        "harness-vue-bootstrap-chartwithtable-buttonrow" + (u.collapsible ? " " + u.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show") + (u.card ? " card-title" : "")
      )
    }, [
      E("span", Ps, [
        u.tableDisplay == "toggle" && s.view == "chart" ? (N(), O("button", {
          key: 0,
          role: "button",
          "aria-label": "Show Table: " + (u.chart.title || u.chart.key),
          onClick: g[5] || (g[5] = (...R) => B.toggleView && B.toggleView(...R)),
          class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
        }, [
          E("span", { innerHTML: u.showTableButtonText }, null, 8, Hs)
        ], 8, Os)) : Y("", !0),
        u.tableDisplay == "toggle" && s.view == "table" ? (N(), O("button", {
          key: 1,
          role: "button",
          "aria-label": "Show Chart: " + (u.chart.title || u.chart.key),
          onClick: g[6] || (g[6] = (...R) => B.toggleView && B.toggleView(...R)),
          class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
        }, [
          E("span", { innerHTML: u.showChartButtonText }, null, 8, Rs)
        ], 8, Fs)) : Y("", !0),
        u.downloadable && s.getChartData(u.chart.key) ? (N(), O("span", Is, [
          E("button", {
            role: "button",
            "aria-label": "Download Table: " + (u.chart.title || u.chart.key),
            onClick: g[7] || (g[7] = (R) => s.downloadCSV(u.chart.key, B.labels || null)),
            class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
          }, " Download CSV ", 8, Ms)
        ])) : Y("", !0),
        u.saveImageButton && s.getChartData(u.chart.key) ? (N(), O("span", Bs, [
          u.saveImageButton ? (N(), O("button", {
            key: 0,
            role: "button",
            "aria-label": "Download Image: " + (u.chart.title || u.chart.key),
            onClick: g[8] || (g[8] = (R) => u.saveImageButton()),
            class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
          }, " Save Image ", 8, js)) : Y("", !0)
        ])) : Y("", !0),
        at(s.$slots, "additional-buttons", {}, void 0, !0)
      ])
    ], 10, Ns)) : Y("", !0)
  ], 10, gs);
}
const $s = /* @__PURE__ */ _e(ds, [["render", zs], ["__scopeId", "data-v-e22bbf85"]]);
const Vs = {
  name: "InteractiveTable",
  mixins: [qi],
  props: {
    local: {
      type: Object,
      required: !1,
      default: () => {
      }
    },
    numRowOptions: {
      type: Array,
      required: !0
    },
    defaultSortColumn: {
      type: String,
      required: !0
    },
    defaultSortOrder: {
      type: String,
      required: !1,
      default: "asc",
      validator: function(s) {
        return ["asc", "desc"].includes(s);
      }
    },
    numPaginationOptions: {
      type: Number,
      required: !1,
      default: 5
    }
  },
  data() {
    return {
      sortedDescending: this.defaultSortOrder === "desc",
      pageNumber: 1,
      searchQuery: "",
      columnSelector: this.defaultSortColumn,
      columnSort: this.defaultSortOrder,
      paginationAmount: 5
    };
  },
  methods: {
    setColumnFilter(s) {
      s === this.columnSelector && (this.sortedDescending = !this.sortedDescending), this.columnSelector = s, this.columnSort = this.sortedDescending ? "desc" : "asc", this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", [
        {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.sortedDescending ? "desc" : "asc",
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }
      ]), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
    },
    setPageNum(s) {
      this.pageNumber = s, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
        pageNumber: this.pageNumber,
        searchQuery: this.searchQuery,
        columnSelector: this.columnSelector,
        columnSort: this.columnSort,
        paginationAmount: this.paginationAmount,
        numberOfPages: this.numberOfPages
      }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
    },
    isActiveAndDescending(s) {
      return this.columnSort === "desc" && this.columnSelector === s;
    },
    isActiveAndAscending(s) {
      return this.columnSort === "asc" && this.columnSelector === s;
    }
  },
  computed: {
    tableOptions() {
      let s = [];
      return Object.keys(this.filters).includes(this.chart.key + "TableOptions") && (s = this.getOptionsForFilter(this.chart.key + "TableOptions")), s;
    },
    tableAdaptedData() {
      let s = this.getChartData(this.chart.key) || null, g = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && g)
        try {
          s = g(this.chart, this.filters, s);
        } catch (u) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(u)
          );
        }
      return s;
    },
    chartData() {
      let s = this.tableAdaptedData;
      if (s) {
        if (this.isSearchable && (s = s.filter((g) => Object.values(g).reduce((u, K) => u || (K ? K.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1))), this.isSortable && (this.columnSort === "asc" ? s = s.sort((g, u) => g[this.columnSelector].toString().localeCompare(u[this.columnSelector], "en", {
          sensitivity: "base"
        })) : this.columnSort === "desc" && (s = s.sort((g, u) => u[this.columnSelector].toString().localeCompare(g[this.columnSelector], "en", {
          sensitivity: "base"
        })))), this.isPaginated) {
          let g = this.pageNumber, u = s.length, K = parseInt(this.paginationAmount), U = g * K > u ? u : g * K, B = (g - 1) * K;
          s = s.slice(B, U);
        }
        return s;
      }
      return s;
    },
    isSearchable() {
      return this.local ? !this.local.hasOwnProperty("search") || this.local.hasOwnProperty("search") && this.local.search !== !1 : !0;
    },
    isSortable() {
      return this.local ? !this.local.hasOwnProperty("sort") || this.local.hasOwnProperty("sort") && this.local.sort !== !1 : !0;
    },
    isPaginated() {
      return this.local ? !this.local.hasOwnProperty("paginate") || this.local.hasOwnProperty("paginate") && this.local.paginate !== !1 : !0;
    },
    numberOfPages() {
      let s = this.tableAdaptedData;
      s && (s = s.filter((B) => Object.values(B).reduce((M, R) => M || (R ? R.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1)));
      let g = [1], u = parseInt(this.paginationAmount), K = this.validateChartData(s, this.chart.key) ? this.validateChartData(s, this.chart.key).length : 0, U = Math.ceil(K / u);
      for (let B = 2; B <= U; B++)
        g.push(B);
      return g;
    },
    searchText: {
      get() {
        return this.searchQuery;
      },
      set(s) {
        this.searchQuery = s, this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.columnSort,
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
      }
    },
    paginationOptions() {
      return this.pageNumber <= this.numPaginationOptions ? this.numberOfPages.slice(0, this.numPaginationOptions) : this.numberOfPages.slice(
        this.pageNumber - this.numPaginationOptions,
        this.pageNumber
      );
    }
  },
  beforeUpdate() {
    this.pageNumber > this.numberOfPages.length && (this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
      pageNumber: this.pageNumber,
      searchQuery: this.searchQuery,
      columnSelector: this.columnSelector,
      columnSort: this.columnSort,
      paginationAmount: this.paginationAmount,
      numberOfPages: this.numberOfPages
    }), this.loadData());
  }
}, ln = (s) => (xi("data-v-2483a85a"), s = s(), Di(), s), Ws = { class: "row py-2" }, Qs = { class: "col-sm-3" }, Ks = { class: "row form-row" }, Us = { class: "offset-1 col-4" }, Gs = ["id"], Xs = ["value"], Js = { class: "col-sm-4 offset-sm-5 text-right" }, Ys = { class: "row form-row" }, Zs = { class: "offset-4 col-8 pr-4" }, ea = ["id"], ta = ["id"], na = ["onClick"], ia = { class: "harness-vue-bootstrap-interactivetable-column-header" }, ra = {
  key: 0,
  class: /* @__PURE__ */ Q(["activeCol"])
}, sa = {
  key: 1,
  class: /* @__PURE__ */ Q(["activeCol"])
}, aa = ["innerHTML"], oa = ["innerHTML"], la = { class: "row justify-content-center" }, ua = { class: "col-md-2 text-center" }, ca = {
  "aria-label": "Table pagination navigation",
  class: "navigation text-center harness-vue-bootstrap-interactivetable-pagination-navigation"
}, fa = { class: "pagination harness-vue-bootstrap-interactivetable-pagination" }, ha = /* @__PURE__ */ ln(() => /* @__PURE__ */ E("i", { class: "bi-chevron-double-left" }, null, -1)), da = [
  ha
], pa = /* @__PURE__ */ ln(() => /* @__PURE__ */ E("i", { class: "bi-chevron-left" }, null, -1)), ga = [
  pa
], ya = ["onClick"], ma = /* @__PURE__ */ ln(() => /* @__PURE__ */ E("i", { class: "bi-chevron-right" }, null, -1)), va = [
  ma
], ba = /* @__PURE__ */ ln(() => /* @__PURE__ */ E("i", { class: "bi-chevron-double-right" }, null, -1)), ka = [
  ba
];
function wa(s, g, u, K, U, B) {
  return N(), O("div", null, [
    E("div", null, [
      E("div", Ws, [
        E("div", Qs, [
          E("div", Ks, [
            E("div", Us, [
              $e(E("select", {
                class: "form-control harness-vue-bootstrap-interactivetable-select",
                id: s.chart.key + "NumRowsSelect",
                "aria-label": "Amount of rows to paginate by",
                "onUpdate:modelValue": g[0] || (g[0] = (M) => U.paginationAmount = M)
              }, [
                (N(!0), O(ge, null, ve(u.numRowOptions, (M) => (N(), O("option", {
                  key: M,
                  value: M
                }, Te(M), 9, Xs))), 128))
              ], 8, Gs), [
                [rn, U.paginationAmount]
              ])
            ])
          ])
        ]),
        E("div", Js, [
          E("div", Ys, [
            E("div", Zs, [
              $e(E("input", {
                type: "text",
                class: "form-control harness-vue-bootstrap-interactivetable-text-input",
                id: s.chart.key + "SearchQueryInput",
                "aria-label": "Table search",
                "onUpdate:modelValue": g[1] || (g[1] = (M) => B.searchText = M),
                placeholder: "Search..."
              }, null, 8, ea), [
                [Ai, B.searchText]
              ])
            ])
          ])
        ])
      ]),
      s.validatedChartData && s.validatedChartData.length ? (N(), O("div", {
        key: 0,
        id: s.chart.key + "_data_table",
        class: "harness-vue-bootstrap-interactivetable-datatable"
      }, [
        E("table", {
          class: Q("harness-vue-bootstrap-interactivetable-table table " + s.tableClass)
        }, [
          E("thead", {
            class: Q(s.headerClass)
          }, [
            E("tr", null, [
              (N(!0), O(ge, null, ve(s.columnHeaders, (M, R) => (N(), O("th", {
                scope: "col",
                key: R,
                class: Q("table-header " + s.labelClass),
                onClick: (re) => B.setColumnFilter(M)
              }, [
                E("button", ia, Te(M), 1),
                B.isActiveAndDescending(M) ? (N(), O("span", ra, "\u25BC")) : Y("", !0),
                B.isActiveAndAscending(M) ? (N(), O("span", sa, "\u25B2")) : Y("", !0)
              ], 10, na))), 128))
            ])
          ], 2),
          E("tbody", null, [
            (N(!0), O(ge, null, ve(s.validatedChartData, (M, R) => (N(), O("tr", {
              key: R,
              class: Q(s.rowClass)
            }, [
              (N(!0), O(ge, null, ve(s.columnHeaders, (re, ue) => (N(), O(ge, null, [
                ue === 0 && s.rowHeaderCol ? (N(), O("th", {
                  key: ue,
                  class: Q(s.cellClass),
                  innerHTML: M[re],
                  scope: "row"
                }, null, 10, aa)) : (N(), O("td", {
                  key: `${ue}-else`,
                  class: Q(s.cellClass),
                  innerHTML: M[re]
                }, null, 10, oa))
              ], 64))), 256))
            ], 2))), 128))
          ])
        ], 2)
      ], 8, ta)) : Y("", !0)
    ]),
    E("div", la, [
      E("div", ua, [
        E("nav", ca, [
          E("ul", fa, [
            E("li", {
              class: Q(`page-link ${U.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: g[2] || (g[2] = (M) => B.setPageNum(1))
            }, da, 2),
            E("li", {
              class: Q(`page-link ${U.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: g[3] || (g[3] = (M) => U.pageNumber != 1 ? B.setPageNum(U.pageNumber - 1) : "")
            }, ga, 2),
            (N(!0), O(ge, null, ve(B.paginationOptions, (M) => (N(), O("li", {
              key: M,
              class: Q([
                "page-item",
                "harness-vue-bootstrap-interactivetable-pagination-pageitem",
                M === U.pageNumber ? " active" : ""
              ])
            }, [
              E("button", {
                class: Q("page-link"),
                onClick: (R) => B.setPageNum(M)
              }, Te(M), 9, ya)
            ], 2))), 128)),
            E("li", {
              class: Q(`page-link ${U.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: g[4] || (g[4] = (M) => U.pageNumber < B.numberOfPages.length ? B.setPageNum(U.pageNumber + 1) : "")
            }, va, 2),
            E("li", {
              class: Q(`page-link ${U.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: g[5] || (g[5] = (M) => B.setPageNum(B.numberOfPages.length))
            }, ka, 2)
          ])
        ])
      ])
    ])
  ]);
}
const Ca = /* @__PURE__ */ _e(Vs, [["render", wa], ["__scopeId", "data-v-2483a85a"]]), Ta = {
  name: "filter-picker",
  props: {
    validFilters: {
      required: !0,
      type: Array
    },
    removeButtonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right"].includes(s);
      }
    },
    columnSize: {
      type: Number,
      required: !1,
      default: 12,
      validator: function(s) {
        return 12 % s === 0;
      }
    }
  },
  data() {
    return {
      active: []
    };
  },
  computed: {
    inactive() {
      return this.validFilters.filter(
        function(s) {
          return !this.active.includes(s);
        }.bind(this)
      );
    }
  },
  methods: {
    addFilter(s) {
      s.target.value && this.active.push(s.target.value);
    },
    removeFilter(s) {
      s.target.value && (this.active = this.active.filter((g) => g !== s.target.value), this.setFilter(
        s.target.value,
        this.getFilterDefault(s.target.value)
      ), this.loadData());
    }
  }
}, _a = { class: "harness-vue-bootstrap-filterpicker" }, Sa = { class: "row" }, xa = { class: "row harness-vue-bootstrap-filtergrid-row" }, Da = { class: "col" }, Aa = /* @__PURE__ */ on("Add Filter"), La = /* @__PURE__ */ E("option", null, null, -1), qa = ["value"], Ea = { class: "col" }, Na = /* @__PURE__ */ on("Remove Filter"), Pa = /* @__PURE__ */ E("option", null, null, -1), Oa = ["value"], Ha = { class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow pt-3" }, Fa = /* @__PURE__ */ E("hr", null, null, -1);
function Ra(s, g, u, K, U, B) {
  const M = Ze("FilterGrid");
  return N(), O("div", _a, [
    E("div", Sa, [
      E("div", {
        class: Q("col-" + u.columnSize)
      }, [
        E("div", xa, [
          E("div", Da, [
            at(s.$slots, "default", { class: "harness-vue-bootstrap-filterpicker-label" }, () => [
              Aa
            ]),
            E("select", {
              class: "form-control harness-vue-bootstrap-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: g[0] || (g[0] = (...R) => B.addFilter && B.addFilter(...R))
            }, [
              La,
              (N(!0), O(ge, null, ve(B.inactive, (R) => (N(), O("option", {
                key: R,
                value: R
              }, Te(s.getLabel(R)), 9, qa))), 128))
            ], 32)
          ]),
          E("div", Ea, [
            at(s.$slots, "default", { class: "harness-vue-bootstrap-filterpicker-label" }, () => [
              Na
            ]),
            E("select", {
              class: "form-control harness-vue-bootstrap-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: g[1] || (g[1] = (...R) => B.removeFilter && B.removeFilter(...R))
            }, [
              Pa,
              (N(!0), O(ge, null, ve(U.active, (R) => (N(), O("option", {
                key: R,
                value: R
              }, Te(s.getLabel(R)), 9, Oa))), 128))
            ], 32)
          ])
        ]),
        E("div", Ha, [
          E("div", {
            class: Q("col-md-12 text-" + u.removeButtonPosition)
          }, [
            E("button", {
              role: "button",
              class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
              onClick: g[2] || (g[2] = (R) => {
                U.active = [], s.initializeDefaults(), s.loadData();
              })
            }, " Remove All Filters ")
          ], 2)
        ]),
        Fa,
        xe(M, yt({ only: U.active }, { ...s.$attrs }), null, 16, ["only"])
      ], 2)
    ])
  ]);
}
const Ia = /* @__PURE__ */ _e(Ta, [["render", Ra]]), Ma = {
  name: "FiltersAccordion",
  props: {
    validFilters: {
      type: Array,
      required: !0
    },
    mappingFunction: {
      type: Function,
      required: !1
    },
    filterLayout: {
      type: Object,
      required: !1
    }
  },
  computed: {
    filterTypes() {
      return Object.keys(this.filters).reduce((s, g) => (g = this.filters[g], g.props && !s.includes(g.props.filterType) && g.props.filterType !== "internal" && g.props.filterType && s.push(g.props.filterType), s), []);
    }
  },
  methods: {
    subsetFiltersByType(s) {
      return Object.keys(this.filters).filter(
        function(g) {
          if (this.filters[g].props)
            return this.filters[g].props.filterType === s && this.validFilters.includes(g);
        }.bind(this)
      );
    },
    filterMapping(s) {
      return this.mappingFunction ? this.mappingFunction(s) : `${s.replace("_", " ")}s`;
    },
    toggle(s) {
      s.preventDefault();
      let g = s.target.id.split("-")[0], u = document.getElementById(g + "-icon");
      if (u.classList.contains("bi-caret-down-square"))
        u.classList.remove("bi-caret-down-square"), u.classList.add("bi-caret-up-square"), this.filterTypes.filter((K) => K !== g).forEach((K) => {
          let U = document.getElementById(K + "-icon");
          U.classList.contains("bi-caret-up-square") && (U.classList.remove("bi-caret-up-square"), U.classList.add("bi-caret-down-square"));
        });
      else if (u.classList.contains("bi-caret-up-square")) {
        let K = document.getElementById(g + "-icon");
        K.classList.remove("bi-caret-up-square"), K.classList.add("bi-caret-down-square");
      }
    },
    dirtyFilterString(s) {
      return this.subsetFiltersByType(s).filter((g) => this.isFilterDirty(g)).map((g) => this.getLabel(g)).join(", ");
    },
    clearFilterTypeFilters(s) {
      let g = this.subsetFiltersByType(s);
      this.initializeDefaults(g), this.loadData();
    },
    filterGridLayout(s) {
      return this.filterLayout ? this.filterLayout[s] : {
        columns: 4,
        labelPosition: "vertical",
        spread: !0
      };
    }
  }
}, Ba = { class: "row" }, ja = {
  class: "accordion col-12",
  id: "filters-accordion"
}, za = ["id"], $a = ["id", "data-target"], Va = { class: "mb-0" }, Wa = { class: "row" }, Qa = ["id"], Ka = ["id"], Ua = ["id", "aria-controls"], Ga = ["id"], Xa = ["id"], Ja = ["id"], Ya = ["id"], Za = ["id", "aria-labelledby"], eo = { class: "card-body" }, to = { class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow" }, no = { class: "col-md-12 text-center" }, io = ["onClick"];
function ro(s, g, u, K, U, B) {
  const M = Ze("FilterGrid");
  return N(), O("div", Ba, [
    E("div", ja, [
      (N(!0), O(ge, null, ve(B.filterTypes, (R, re) => (N(), O("div", {
        class: "card",
        id: R + "-card",
        key: re
      }, [
        E("div", {
          class: "card-header",
          id: R + "-heading",
          onClick: g[2] || (g[2] = (...ue) => B.toggle && B.toggle(...ue)),
          "data-toggle": "collapse",
          "data-target": "#collapse-" + R
        }, [
          E("h2", Va, [
            E("div", Wa, [
              E("div", {
                class: "col-6",
                id: R + "-col1"
              }, [
                E("i", {
                  class: Q(
                    "bi bi-ui-checks " + (B.dirtyFilterString(R).length ? "active" : "")
                  ),
                  id: R + "-checks"
                }, null, 10, Ka),
                E("button", {
                  class: "btn btn-link",
                  id: R + "-button",
                  type: "button",
                  "aria-expanded": "false",
                  "aria-controls": "collapse-" + R
                }, Te(B.filterMapping(R)), 9, Ua),
                B.dirtyFilterString(R).length ? (N(), O("small", {
                  key: 0,
                  id: R + "-small"
                }, Te(B.dirtyFilterString(R)), 9, Ga)) : Y("", !0)
              ], 8, Qa),
              E("div", {
                class: "col-6 text-right",
                id: R + "-col2"
              }, [
                E("button", {
                  class: "btn btn-link text-right",
                  id: R + "-collapsebutton",
                  onClick: g[1] || (g[1] = (...ue) => B.toggle && B.toggle(...ue))
                }, [
                  E("i", {
                    class: "bi bi-caret-down-square",
                    id: R + "-icon",
                    onClick: g[0] || (g[0] = (...ue) => B.toggle && B.toggle(...ue))
                  }, null, 8, Ya)
                ], 8, Ja)
              ], 8, Xa)
            ])
          ])
        ], 8, $a),
        E("div", {
          id: "collapse-" + R,
          class: "collapse",
          "aria-labelledby": R + "-heading",
          "data-parent": "#filters-accordion"
        }, [
          E("div", eo, [
            xe(M, {
              columns: B.filterGridLayout(R).columns,
              "label-position": B.filterGridLayout(R).labelPosition,
              spread: B.filterGridLayout(R).spread,
              only: B.subsetFiltersByType(R),
              "clear-button": !1
            }, null, 8, ["columns", "label-position", "spread", "only"]),
            E("div", to, [
              E("div", no, [
                E("button", {
                  class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
                  role: "button",
                  onClick: (ue) => B.clearFilterTypeFilters(R)
                }, " Clear Filters ", 8, io)
              ])
            ])
          ])
        ], 8, Za)
      ], 8, za))), 128))
    ])
  ]);
}
const so = /* @__PURE__ */ _e(Ma, [["render", ro]]), et = {
  props: {
    filter: {
      type: Object,
      required: !0,
      validator: function(s) {
        return Object.keys(s).includes("key");
      }
    }
  }
}, ao = {
  name: "InputPartial",
  mixins: [Ue, et],
  props: {
    type: {
      required: !0,
      type: String
    },
    strictError: {
      type: Boolean,
      required: !0
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    inputClearButton: {
      required: !1,
      type: Boolean,
      default: !1
    }
  },
  methods: {
    initDefault() {
      this.INITIALIZE_DEFAULTS([this.filter.key]), this.synchronous || this.loadData();
    }
  }
}, oo = { class: "input-group" }, lo = {
  key: 1,
  class: "input-group-prepend"
}, uo = ["innerHTML"], co = ["type", "placeholder", "id", "aria-labelledby"], fo = {
  key: 3,
  class: "input-group-append"
}, ho = ["innerHTML"], po = /* @__PURE__ */ E("i", { class: "bi bi-x" }, null, -1), go = [
  po
];
function yo(s, g, u, K, U, B) {
  return N(), O("div", oo, [
    u.prependComponent ? (N(), St(Bt(u.prependComponent), Re(yt({ key: 0 }, { ...s.$props, ...s.$attrs, strictError: u.strictError })), null, 16)) : u.prependHTML ? (N(), O("div", lo, [
      E("span", {
        class: "input-group-text",
        innerHTML: u.prependHTML
      }, null, 8, uo)
    ])) : Y("", !0),
    $e(E("input", {
      type: u.type,
      class: Q(`form-control harness-vue-bootstrap-${u.type}-input ${s.isFilterDirty(s.filter.key) ? "dirty-filter-input" : ""} ${u.strictError ? "typeahead-strict-error" : ""}`),
      placeholder: u.placeholder,
      "onUpdate:modelValue": g[0] || (g[0] = (M) => s.boundValue = M),
      id: `${s.filter.key}-${u.type}-input`,
      "aria-labelledby": `${s.filter.key}-label`
    }, null, 10, co), [
      [Ir, s.boundValue]
    ]),
    u.appendComponent ? (N(), St(Bt(u.appendComponent), Re(yt({ key: 2 }, { ...s.$props, ...s.$attrs, strictError: u.strictError })), null, 16)) : u.appendHTML || u.inputClearButton ? (N(), O("div", fo, [
      u.appendHTML ? (N(), O("span", {
        key: 0,
        class: "input-group-text",
        innerHTML: u.appendHTML
      }, null, 8, ho)) : Y("", !0),
      u.inputClearButton ? (N(), O("button", {
        key: 1,
        class: "btn btn-outline-secondary harness-vue-bootstrap-input-group-clear-button",
        onClick: g[1] || (g[1] = (M) => B.initDefault())
      }, go)) : Y("", !0)
    ])) : Y("", !0)
  ]);
}
const mo = /* @__PURE__ */ _e(ao, [["render", yo]]);
var sn = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Pn = { exports: {} };
/*!
 * jQuery JavaScript Library v3.6.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright OpenJS Foundation and other contributors
 * Released under the MIT license
 * https://jquery.org/license
 *
 * Date: 2022-08-26T17:52Z
 */
var _i;
function an() {
  return _i || (_i = 1, function(s) {
    (function(g, u) {
      s.exports = g.document ? u(g, !0) : function(K) {
        if (!K.document)
          throw new Error("jQuery requires a window with a document");
        return u(K);
      };
    })(typeof window < "u" ? window : sn, function(g, u) {
      var K = [], U = Object.getPrototypeOf, B = K.slice, M = K.flat ? function(e) {
        return K.flat.call(e);
      } : function(e) {
        return K.concat.apply([], e);
      }, R = K.push, re = K.indexOf, ue = {}, tt = ue.toString, We = ue.hasOwnProperty, nt = We.toString, v = nt.call(Object), b = {}, f = function(t) {
        return typeof t == "function" && typeof t.nodeType != "number" && typeof t.item != "function";
      }, m = function(t) {
        return t != null && t === t.window;
      }, h = g.document, c = {
        type: !0,
        src: !0,
        nonce: !0,
        noModule: !0
      };
      function o(e, t, i) {
        i = i || h;
        var r, a, l = i.createElement("script");
        if (l.text = e, t)
          for (r in c)
            a = t[r] || t.getAttribute && t.getAttribute(r), a && l.setAttribute(r, a);
        i.head.appendChild(l).parentNode.removeChild(l);
      }
      function p(e) {
        return e == null ? e + "" : typeof e == "object" || typeof e == "function" ? ue[tt.call(e)] || "object" : typeof e;
      }
      var k = "3.6.1", n = function(e, t) {
        return new n.fn.init(e, t);
      };
      n.fn = n.prototype = {
        jquery: k,
        constructor: n,
        length: 0,
        toArray: function() {
          return B.call(this);
        },
        get: function(e) {
          return e == null ? B.call(this) : e < 0 ? this[e + this.length] : this[e];
        },
        pushStack: function(e) {
          var t = n.merge(this.constructor(), e);
          return t.prevObject = this, t;
        },
        each: function(e) {
          return n.each(this, e);
        },
        map: function(e) {
          return this.pushStack(n.map(this, function(t, i) {
            return e.call(t, i, t);
          }));
        },
        slice: function() {
          return this.pushStack(B.apply(this, arguments));
        },
        first: function() {
          return this.eq(0);
        },
        last: function() {
          return this.eq(-1);
        },
        even: function() {
          return this.pushStack(n.grep(this, function(e, t) {
            return (t + 1) % 2;
          }));
        },
        odd: function() {
          return this.pushStack(n.grep(this, function(e, t) {
            return t % 2;
          }));
        },
        eq: function(e) {
          var t = this.length, i = +e + (e < 0 ? t : 0);
          return this.pushStack(i >= 0 && i < t ? [this[i]] : []);
        },
        end: function() {
          return this.prevObject || this.constructor();
        },
        push: R,
        sort: K.sort,
        splice: K.splice
      }, n.extend = n.fn.extend = function() {
        var e, t, i, r, a, l, d = arguments[0] || {}, T = 1, w = arguments.length, D = !1;
        for (typeof d == "boolean" && (D = d, d = arguments[T] || {}, T++), typeof d != "object" && !f(d) && (d = {}), T === w && (d = this, T--); T < w; T++)
          if ((e = arguments[T]) != null)
            for (t in e)
              r = e[t], !(t === "__proto__" || d === r) && (D && r && (n.isPlainObject(r) || (a = Array.isArray(r))) ? (i = d[t], a && !Array.isArray(i) ? l = [] : !a && !n.isPlainObject(i) ? l = {} : l = i, a = !1, d[t] = n.extend(D, l, r)) : r !== void 0 && (d[t] = r));
        return d;
      }, n.extend({
        expando: "jQuery" + (k + Math.random()).replace(/\D/g, ""),
        isReady: !0,
        error: function(e) {
          throw new Error(e);
        },
        noop: function() {
        },
        isPlainObject: function(e) {
          var t, i;
          return !e || tt.call(e) !== "[object Object]" ? !1 : (t = U(e), t ? (i = We.call(t, "constructor") && t.constructor, typeof i == "function" && nt.call(i) === v) : !0);
        },
        isEmptyObject: function(e) {
          var t;
          for (t in e)
            return !1;
          return !0;
        },
        globalEval: function(e, t, i) {
          o(e, { nonce: t && t.nonce }, i);
        },
        each: function(e, t) {
          var i, r = 0;
          if (_(e))
            for (i = e.length; r < i && t.call(e[r], r, e[r]) !== !1; r++)
              ;
          else
            for (r in e)
              if (t.call(e[r], r, e[r]) === !1)
                break;
          return e;
        },
        makeArray: function(e, t) {
          var i = t || [];
          return e != null && (_(Object(e)) ? n.merge(
            i,
            typeof e == "string" ? [e] : e
          ) : R.call(i, e)), i;
        },
        inArray: function(e, t, i) {
          return t == null ? -1 : re.call(t, e, i);
        },
        merge: function(e, t) {
          for (var i = +t.length, r = 0, a = e.length; r < i; r++)
            e[a++] = t[r];
          return e.length = a, e;
        },
        grep: function(e, t, i) {
          for (var r, a = [], l = 0, d = e.length, T = !i; l < d; l++)
            r = !t(e[l], l), r !== T && a.push(e[l]);
          return a;
        },
        map: function(e, t, i) {
          var r, a, l = 0, d = [];
          if (_(e))
            for (r = e.length; l < r; l++)
              a = t(e[l], l, i), a != null && d.push(a);
          else
            for (l in e)
              a = t(e[l], l, i), a != null && d.push(a);
          return M(d);
        },
        guid: 1,
        support: b
      }), typeof Symbol == "function" && (n.fn[Symbol.iterator] = K[Symbol.iterator]), n.each(
        "Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),
        function(e, t) {
          ue["[object " + t + "]"] = t.toLowerCase();
        }
      );
      function _(e) {
        var t = !!e && "length" in e && e.length, i = p(e);
        return f(e) || m(e) ? !1 : i === "array" || t === 0 || typeof t == "number" && t > 0 && t - 1 in e;
      }
      var A = function(e) {
        var t, i, r, a, l, d, T, w, D, q, j, L, P, X, ae, J, we, ke, Pe, he = "sizzle" + 1 * new Date(), se = e.document, qe = 0, ce = 0, me = Zt(), Ft = Zt(), Xt = Zt(), Oe = Zt(), ft = function(y, C) {
          return y === C && (j = !0), 0;
        }, ht = {}.hasOwnProperty, Ee = [], rt = Ee.pop, Me = Ee.push, st = Ee.push, pi = Ee.slice, dt = function(y, C) {
          for (var S = 0, H = y.length; S < H; S++)
            if (y[S] === C)
              return S;
          return -1;
        }, Sn = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped", fe = "[\\x20\\t\\r\\n\\f]", pt = "(?:\\\\[\\da-fA-F]{1,6}" + fe + "?|\\\\[^\\r\\n\\f]|[\\w-]|[^\0-\\x7f])+", gi = "\\[" + fe + "*(" + pt + ")(?:" + fe + "*([*^$|!~]?=)" + fe + `*(?:'((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)"|(` + pt + "))|)" + fe + "*\\]", xn = ":(" + pt + `)(?:\\((('((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)")|((?:\\\\.|[^\\\\()[\\]]|` + gi + ")*)|.*)\\)|)", _r = new RegExp(fe + "+", "g"), Jt = new RegExp("^" + fe + "+|((?:^|[^\\\\])(?:\\\\.)*)" + fe + "+$", "g"), Sr = new RegExp("^" + fe + "*," + fe + "*"), yi = new RegExp("^" + fe + "*([>+~]|" + fe + ")" + fe + "*"), xr = new RegExp(fe + "|>"), Dr = new RegExp(xn), Ar = new RegExp("^" + pt + "$"), Yt = {
          ID: new RegExp("^#(" + pt + ")"),
          CLASS: new RegExp("^\\.(" + pt + ")"),
          TAG: new RegExp("^(" + pt + "|[*])"),
          ATTR: new RegExp("^" + gi),
          PSEUDO: new RegExp("^" + xn),
          CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + fe + "*(even|odd|(([+-]|)(\\d*)n|)" + fe + "*(?:([+-]|)" + fe + "*(\\d+)|))" + fe + "*\\)|)", "i"),
          bool: new RegExp("^(?:" + Sn + ")$", "i"),
          needsContext: new RegExp("^" + fe + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + fe + "*((?:-\\d)?\\d*)" + fe + "*\\)|)(?=[^-]|$)", "i")
        }, Lr = /HTML$/i, qr = /^(?:input|select|textarea|button)$/i, Er = /^h\d$/i, Rt = /^[^{]+\{\s*\[native \w/, Nr = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, Dn = /[+~]/, Je = new RegExp("\\\\[\\da-fA-F]{1,6}" + fe + "?|\\\\([^\\r\\n\\f])", "g"), Ye = function(y, C) {
          var S = "0x" + y.slice(1) - 65536;
          return C || (S < 0 ? String.fromCharCode(S + 65536) : String.fromCharCode(S >> 10 | 55296, S & 1023 | 56320));
        }, mi = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g, vi = function(y, C) {
          return C ? y === "\0" ? "\uFFFD" : y.slice(0, -1) + "\\" + y.charCodeAt(y.length - 1).toString(16) + " " : "\\" + y;
        }, bi = function() {
          L();
        }, Pr = tn(
          function(y) {
            return y.disabled === !0 && y.nodeName.toLowerCase() === "fieldset";
          },
          { dir: "parentNode", next: "legend" }
        );
        try {
          st.apply(
            Ee = pi.call(se.childNodes),
            se.childNodes
          ), Ee[se.childNodes.length].nodeType;
        } catch {
          st = {
            apply: Ee.length ? function(C, S) {
              Me.apply(C, pi.call(S));
            } : function(C, S) {
              for (var H = C.length, x = 0; C[H++] = S[x++]; )
                ;
              C.length = H - 1;
            }
          };
        }
        function de(y, C, S, H) {
          var x, I, z, V, W, te, Z, ie = C && C.ownerDocument, le = C ? C.nodeType : 9;
          if (S = S || [], typeof y != "string" || !y || le !== 1 && le !== 9 && le !== 11)
            return S;
          if (!H && (L(C), C = C || P, ae)) {
            if (le !== 11 && (W = Nr.exec(y)))
              if (x = W[1]) {
                if (le === 9)
                  if (z = C.getElementById(x)) {
                    if (z.id === x)
                      return S.push(z), S;
                  } else
                    return S;
                else if (ie && (z = ie.getElementById(x)) && Pe(C, z) && z.id === x)
                  return S.push(z), S;
              } else {
                if (W[2])
                  return st.apply(S, C.getElementsByTagName(y)), S;
                if ((x = W[3]) && i.getElementsByClassName && C.getElementsByClassName)
                  return st.apply(S, C.getElementsByClassName(x)), S;
              }
            if (i.qsa && !Oe[y + " "] && (!J || !J.test(y)) && (le !== 1 || C.nodeName.toLowerCase() !== "object")) {
              if (Z = y, ie = C, le === 1 && (xr.test(y) || yi.test(y))) {
                for (ie = Dn.test(y) && Ln(C.parentNode) || C, (ie !== C || !i.scope) && ((V = C.getAttribute("id")) ? V = V.replace(mi, vi) : C.setAttribute("id", V = he)), te = d(y), I = te.length; I--; )
                  te[I] = (V ? "#" + V : ":scope") + " " + en(te[I]);
                Z = te.join(",");
              }
              try {
                return st.apply(
                  S,
                  ie.querySelectorAll(Z)
                ), S;
              } catch {
                Oe(y, !0);
              } finally {
                V === he && C.removeAttribute("id");
              }
            }
          }
          return w(y.replace(Jt, "$1"), C, S, H);
        }
        function Zt() {
          var y = [];
          function C(S, H) {
            return y.push(S + " ") > r.cacheLength && delete C[y.shift()], C[S + " "] = H;
          }
          return C;
        }
        function je(y) {
          return y[he] = !0, y;
        }
        function ze(y) {
          var C = P.createElement("fieldset");
          try {
            return !!y(C);
          } catch {
            return !1;
          } finally {
            C.parentNode && C.parentNode.removeChild(C), C = null;
          }
        }
        function An(y, C) {
          for (var S = y.split("|"), H = S.length; H--; )
            r.attrHandle[S[H]] = C;
        }
        function ki(y, C) {
          var S = C && y, H = S && y.nodeType === 1 && C.nodeType === 1 && y.sourceIndex - C.sourceIndex;
          if (H)
            return H;
          if (S) {
            for (; S = S.nextSibling; )
              if (S === C)
                return -1;
          }
          return y ? 1 : -1;
        }
        function Or(y) {
          return function(C) {
            var S = C.nodeName.toLowerCase();
            return S === "input" && C.type === y;
          };
        }
        function Hr(y) {
          return function(C) {
            var S = C.nodeName.toLowerCase();
            return (S === "input" || S === "button") && C.type === y;
          };
        }
        function wi(y) {
          return function(C) {
            return "form" in C ? C.parentNode && C.disabled === !1 ? "label" in C ? "label" in C.parentNode ? C.parentNode.disabled === y : C.disabled === y : C.isDisabled === y || C.isDisabled !== !y && Pr(C) === y : C.disabled === y : "label" in C ? C.disabled === y : !1;
          };
        }
        function gt(y) {
          return je(function(C) {
            return C = +C, je(function(S, H) {
              for (var x, I = y([], S.length, C), z = I.length; z--; )
                S[x = I[z]] && (S[x] = !(H[x] = S[x]));
            });
          });
        }
        function Ln(y) {
          return y && typeof y.getElementsByTagName < "u" && y;
        }
        i = de.support = {}, l = de.isXML = function(y) {
          var C = y && y.namespaceURI, S = y && (y.ownerDocument || y).documentElement;
          return !Lr.test(C || S && S.nodeName || "HTML");
        }, L = de.setDocument = function(y) {
          var C, S, H = y ? y.ownerDocument || y : se;
          return H == P || H.nodeType !== 9 || !H.documentElement || (P = H, X = P.documentElement, ae = !l(P), se != P && (S = P.defaultView) && S.top !== S && (S.addEventListener ? S.addEventListener("unload", bi, !1) : S.attachEvent && S.attachEvent("onunload", bi)), i.scope = ze(function(x) {
            return X.appendChild(x).appendChild(P.createElement("div")), typeof x.querySelectorAll < "u" && !x.querySelectorAll(":scope fieldset div").length;
          }), i.attributes = ze(function(x) {
            return x.className = "i", !x.getAttribute("className");
          }), i.getElementsByTagName = ze(function(x) {
            return x.appendChild(P.createComment("")), !x.getElementsByTagName("*").length;
          }), i.getElementsByClassName = Rt.test(P.getElementsByClassName), i.getById = ze(function(x) {
            return X.appendChild(x).id = he, !P.getElementsByName || !P.getElementsByName(he).length;
          }), i.getById ? (r.filter.ID = function(x) {
            var I = x.replace(Je, Ye);
            return function(z) {
              return z.getAttribute("id") === I;
            };
          }, r.find.ID = function(x, I) {
            if (typeof I.getElementById < "u" && ae) {
              var z = I.getElementById(x);
              return z ? [z] : [];
            }
          }) : (r.filter.ID = function(x) {
            var I = x.replace(Je, Ye);
            return function(z) {
              var V = typeof z.getAttributeNode < "u" && z.getAttributeNode("id");
              return V && V.value === I;
            };
          }, r.find.ID = function(x, I) {
            if (typeof I.getElementById < "u" && ae) {
              var z, V, W, te = I.getElementById(x);
              if (te) {
                if (z = te.getAttributeNode("id"), z && z.value === x)
                  return [te];
                for (W = I.getElementsByName(x), V = 0; te = W[V++]; )
                  if (z = te.getAttributeNode("id"), z && z.value === x)
                    return [te];
              }
              return [];
            }
          }), r.find.TAG = i.getElementsByTagName ? function(x, I) {
            if (typeof I.getElementsByTagName < "u")
              return I.getElementsByTagName(x);
            if (i.qsa)
              return I.querySelectorAll(x);
          } : function(x, I) {
            var z, V = [], W = 0, te = I.getElementsByTagName(x);
            if (x === "*") {
              for (; z = te[W++]; )
                z.nodeType === 1 && V.push(z);
              return V;
            }
            return te;
          }, r.find.CLASS = i.getElementsByClassName && function(x, I) {
            if (typeof I.getElementsByClassName < "u" && ae)
              return I.getElementsByClassName(x);
          }, we = [], J = [], (i.qsa = Rt.test(P.querySelectorAll)) && (ze(function(x) {
            var I;
            X.appendChild(x).innerHTML = "<a id='" + he + "'></a><select id='" + he + "-\r\\' msallowcapture=''><option selected=''></option></select>", x.querySelectorAll("[msallowcapture^='']").length && J.push("[*^$]=" + fe + `*(?:''|"")`), x.querySelectorAll("[selected]").length || J.push("\\[" + fe + "*(?:value|" + Sn + ")"), x.querySelectorAll("[id~=" + he + "-]").length || J.push("~="), I = P.createElement("input"), I.setAttribute("name", ""), x.appendChild(I), x.querySelectorAll("[name='']").length || J.push("\\[" + fe + "*name" + fe + "*=" + fe + `*(?:''|"")`), x.querySelectorAll(":checked").length || J.push(":checked"), x.querySelectorAll("a#" + he + "+*").length || J.push(".#.+[+~]"), x.querySelectorAll("\\\f"), J.push("[\\r\\n\\f]");
          }), ze(function(x) {
            x.innerHTML = "<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";
            var I = P.createElement("input");
            I.setAttribute("type", "hidden"), x.appendChild(I).setAttribute("name", "D"), x.querySelectorAll("[name=d]").length && J.push("name" + fe + "*[*^$|!~]?="), x.querySelectorAll(":enabled").length !== 2 && J.push(":enabled", ":disabled"), X.appendChild(x).disabled = !0, x.querySelectorAll(":disabled").length !== 2 && J.push(":enabled", ":disabled"), x.querySelectorAll("*,:x"), J.push(",.*:");
          })), (i.matchesSelector = Rt.test(ke = X.matches || X.webkitMatchesSelector || X.mozMatchesSelector || X.oMatchesSelector || X.msMatchesSelector)) && ze(function(x) {
            i.disconnectedMatch = ke.call(x, "*"), ke.call(x, "[s!='']:x"), we.push("!=", xn);
          }), J = J.length && new RegExp(J.join("|")), we = we.length && new RegExp(we.join("|")), C = Rt.test(X.compareDocumentPosition), Pe = C || Rt.test(X.contains) ? function(x, I) {
            var z = x.nodeType === 9 ? x.documentElement : x, V = I && I.parentNode;
            return x === V || !!(V && V.nodeType === 1 && (z.contains ? z.contains(V) : x.compareDocumentPosition && x.compareDocumentPosition(V) & 16));
          } : function(x, I) {
            if (I) {
              for (; I = I.parentNode; )
                if (I === x)
                  return !0;
            }
            return !1;
          }, ft = C ? function(x, I) {
            if (x === I)
              return j = !0, 0;
            var z = !x.compareDocumentPosition - !I.compareDocumentPosition;
            return z || (z = (x.ownerDocument || x) == (I.ownerDocument || I) ? x.compareDocumentPosition(I) : 1, z & 1 || !i.sortDetached && I.compareDocumentPosition(x) === z ? x == P || x.ownerDocument == se && Pe(se, x) ? -1 : I == P || I.ownerDocument == se && Pe(se, I) ? 1 : q ? dt(q, x) - dt(q, I) : 0 : z & 4 ? -1 : 1);
          } : function(x, I) {
            if (x === I)
              return j = !0, 0;
            var z, V = 0, W = x.parentNode, te = I.parentNode, Z = [x], ie = [I];
            if (!W || !te)
              return x == P ? -1 : I == P ? 1 : W ? -1 : te ? 1 : q ? dt(q, x) - dt(q, I) : 0;
            if (W === te)
              return ki(x, I);
            for (z = x; z = z.parentNode; )
              Z.unshift(z);
            for (z = I; z = z.parentNode; )
              ie.unshift(z);
            for (; Z[V] === ie[V]; )
              V++;
            return V ? ki(Z[V], ie[V]) : Z[V] == se ? -1 : ie[V] == se ? 1 : 0;
          }), P;
        }, de.matches = function(y, C) {
          return de(y, null, null, C);
        }, de.matchesSelector = function(y, C) {
          if (L(y), i.matchesSelector && ae && !Oe[C + " "] && (!we || !we.test(C)) && (!J || !J.test(C)))
            try {
              var S = ke.call(y, C);
              if (S || i.disconnectedMatch || y.document && y.document.nodeType !== 11)
                return S;
            } catch {
              Oe(C, !0);
            }
          return de(C, P, null, [y]).length > 0;
        }, de.contains = function(y, C) {
          return (y.ownerDocument || y) != P && L(y), Pe(y, C);
        }, de.attr = function(y, C) {
          (y.ownerDocument || y) != P && L(y);
          var S = r.attrHandle[C.toLowerCase()], H = S && ht.call(r.attrHandle, C.toLowerCase()) ? S(y, C, !ae) : void 0;
          return H !== void 0 ? H : i.attributes || !ae ? y.getAttribute(C) : (H = y.getAttributeNode(C)) && H.specified ? H.value : null;
        }, de.escape = function(y) {
          return (y + "").replace(mi, vi);
        }, de.error = function(y) {
          throw new Error("Syntax error, unrecognized expression: " + y);
        }, de.uniqueSort = function(y) {
          var C, S = [], H = 0, x = 0;
          if (j = !i.detectDuplicates, q = !i.sortStable && y.slice(0), y.sort(ft), j) {
            for (; C = y[x++]; )
              C === y[x] && (H = S.push(x));
            for (; H--; )
              y.splice(S[H], 1);
          }
          return q = null, y;
        }, a = de.getText = function(y) {
          var C, S = "", H = 0, x = y.nodeType;
          if (x) {
            if (x === 1 || x === 9 || x === 11) {
              if (typeof y.textContent == "string")
                return y.textContent;
              for (y = y.firstChild; y; y = y.nextSibling)
                S += a(y);
            } else if (x === 3 || x === 4)
              return y.nodeValue;
          } else
            for (; C = y[H++]; )
              S += a(C);
          return S;
        }, r = de.selectors = {
          cacheLength: 50,
          createPseudo: je,
          match: Yt,
          attrHandle: {},
          find: {},
          relative: {
            ">": { dir: "parentNode", first: !0 },
            " ": { dir: "parentNode" },
            "+": { dir: "previousSibling", first: !0 },
            "~": { dir: "previousSibling" }
          },
          preFilter: {
            ATTR: function(y) {
              return y[1] = y[1].replace(Je, Ye), y[3] = (y[3] || y[4] || y[5] || "").replace(Je, Ye), y[2] === "~=" && (y[3] = " " + y[3] + " "), y.slice(0, 4);
            },
            CHILD: function(y) {
              return y[1] = y[1].toLowerCase(), y[1].slice(0, 3) === "nth" ? (y[3] || de.error(y[0]), y[4] = +(y[4] ? y[5] + (y[6] || 1) : 2 * (y[3] === "even" || y[3] === "odd")), y[5] = +(y[7] + y[8] || y[3] === "odd")) : y[3] && de.error(y[0]), y;
            },
            PSEUDO: function(y) {
              var C, S = !y[6] && y[2];
              return Yt.CHILD.test(y[0]) ? null : (y[3] ? y[2] = y[4] || y[5] || "" : S && Dr.test(S) && (C = d(S, !0)) && (C = S.indexOf(")", S.length - C) - S.length) && (y[0] = y[0].slice(0, C), y[2] = S.slice(0, C)), y.slice(0, 3));
            }
          },
          filter: {
            TAG: function(y) {
              var C = y.replace(Je, Ye).toLowerCase();
              return y === "*" ? function() {
                return !0;
              } : function(S) {
                return S.nodeName && S.nodeName.toLowerCase() === C;
              };
            },
            CLASS: function(y) {
              var C = me[y + " "];
              return C || (C = new RegExp("(^|" + fe + ")" + y + "(" + fe + "|$)")) && me(
                y,
                function(S) {
                  return C.test(
                    typeof S.className == "string" && S.className || typeof S.getAttribute < "u" && S.getAttribute("class") || ""
                  );
                }
              );
            },
            ATTR: function(y, C, S) {
              return function(H) {
                var x = de.attr(H, y);
                return x == null ? C === "!=" : C ? (x += "", C === "=" ? x === S : C === "!=" ? x !== S : C === "^=" ? S && x.indexOf(S) === 0 : C === "*=" ? S && x.indexOf(S) > -1 : C === "$=" ? S && x.slice(-S.length) === S : C === "~=" ? (" " + x.replace(_r, " ") + " ").indexOf(S) > -1 : C === "|=" ? x === S || x.slice(0, S.length + 1) === S + "-" : !1) : !0;
              };
            },
            CHILD: function(y, C, S, H, x) {
              var I = y.slice(0, 3) !== "nth", z = y.slice(-4) !== "last", V = C === "of-type";
              return H === 1 && x === 0 ? function(W) {
                return !!W.parentNode;
              } : function(W, te, Z) {
                var ie, le, pe, ne, Ce, Se, He = I !== z ? "nextSibling" : "previousSibling", ye = W.parentNode, It = V && W.nodeName.toLowerCase(), Mt = !Z && !V, Fe = !1;
                if (ye) {
                  if (I) {
                    for (; He; ) {
                      for (ne = W; ne = ne[He]; )
                        if (V ? ne.nodeName.toLowerCase() === It : ne.nodeType === 1)
                          return !1;
                      Se = He = y === "only" && !Se && "nextSibling";
                    }
                    return !0;
                  }
                  if (Se = [z ? ye.firstChild : ye.lastChild], z && Mt) {
                    for (ne = ye, pe = ne[he] || (ne[he] = {}), le = pe[ne.uniqueID] || (pe[ne.uniqueID] = {}), ie = le[y] || [], Ce = ie[0] === qe && ie[1], Fe = Ce && ie[2], ne = Ce && ye.childNodes[Ce]; ne = ++Ce && ne && ne[He] || (Fe = Ce = 0) || Se.pop(); )
                      if (ne.nodeType === 1 && ++Fe && ne === W) {
                        le[y] = [qe, Ce, Fe];
                        break;
                      }
                  } else if (Mt && (ne = W, pe = ne[he] || (ne[he] = {}), le = pe[ne.uniqueID] || (pe[ne.uniqueID] = {}), ie = le[y] || [], Ce = ie[0] === qe && ie[1], Fe = Ce), Fe === !1)
                    for (; (ne = ++Ce && ne && ne[He] || (Fe = Ce = 0) || Se.pop()) && !((V ? ne.nodeName.toLowerCase() === It : ne.nodeType === 1) && ++Fe && (Mt && (pe = ne[he] || (ne[he] = {}), le = pe[ne.uniqueID] || (pe[ne.uniqueID] = {}), le[y] = [qe, Fe]), ne === W)); )
                      ;
                  return Fe -= x, Fe === H || Fe % H === 0 && Fe / H >= 0;
                }
              };
            },
            PSEUDO: function(y, C) {
              var S, H = r.pseudos[y] || r.setFilters[y.toLowerCase()] || de.error("unsupported pseudo: " + y);
              return H[he] ? H(C) : H.length > 1 ? (S = [y, y, "", C], r.setFilters.hasOwnProperty(y.toLowerCase()) ? je(function(x, I) {
                for (var z, V = H(x, C), W = V.length; W--; )
                  z = dt(x, V[W]), x[z] = !(I[z] = V[W]);
              }) : function(x) {
                return H(x, 0, S);
              }) : H;
            }
          },
          pseudos: {
            not: je(function(y) {
              var C = [], S = [], H = T(y.replace(Jt, "$1"));
              return H[he] ? je(function(x, I, z, V) {
                for (var W, te = H(x, null, V, []), Z = x.length; Z--; )
                  (W = te[Z]) && (x[Z] = !(I[Z] = W));
              }) : function(x, I, z) {
                return C[0] = x, H(C, null, z, S), C[0] = null, !S.pop();
              };
            }),
            has: je(function(y) {
              return function(C) {
                return de(y, C).length > 0;
              };
            }),
            contains: je(function(y) {
              return y = y.replace(Je, Ye), function(C) {
                return (C.textContent || a(C)).indexOf(y) > -1;
              };
            }),
            lang: je(function(y) {
              return Ar.test(y || "") || de.error("unsupported lang: " + y), y = y.replace(Je, Ye).toLowerCase(), function(C) {
                var S;
                do
                  if (S = ae ? C.lang : C.getAttribute("xml:lang") || C.getAttribute("lang"))
                    return S = S.toLowerCase(), S === y || S.indexOf(y + "-") === 0;
                while ((C = C.parentNode) && C.nodeType === 1);
                return !1;
              };
            }),
            target: function(y) {
              var C = e.location && e.location.hash;
              return C && C.slice(1) === y.id;
            },
            root: function(y) {
              return y === X;
            },
            focus: function(y) {
              return y === P.activeElement && (!P.hasFocus || P.hasFocus()) && !!(y.type || y.href || ~y.tabIndex);
            },
            enabled: wi(!1),
            disabled: wi(!0),
            checked: function(y) {
              var C = y.nodeName.toLowerCase();
              return C === "input" && !!y.checked || C === "option" && !!y.selected;
            },
            selected: function(y) {
              return y.parentNode && y.parentNode.selectedIndex, y.selected === !0;
            },
            empty: function(y) {
              for (y = y.firstChild; y; y = y.nextSibling)
                if (y.nodeType < 6)
                  return !1;
              return !0;
            },
            parent: function(y) {
              return !r.pseudos.empty(y);
            },
            header: function(y) {
              return Er.test(y.nodeName);
            },
            input: function(y) {
              return qr.test(y.nodeName);
            },
            button: function(y) {
              var C = y.nodeName.toLowerCase();
              return C === "input" && y.type === "button" || C === "button";
            },
            text: function(y) {
              var C;
              return y.nodeName.toLowerCase() === "input" && y.type === "text" && ((C = y.getAttribute("type")) == null || C.toLowerCase() === "text");
            },
            first: gt(function() {
              return [0];
            }),
            last: gt(function(y, C) {
              return [C - 1];
            }),
            eq: gt(function(y, C, S) {
              return [S < 0 ? S + C : S];
            }),
            even: gt(function(y, C) {
              for (var S = 0; S < C; S += 2)
                y.push(S);
              return y;
            }),
            odd: gt(function(y, C) {
              for (var S = 1; S < C; S += 2)
                y.push(S);
              return y;
            }),
            lt: gt(function(y, C, S) {
              for (var H = S < 0 ? S + C : S > C ? C : S; --H >= 0; )
                y.push(H);
              return y;
            }),
            gt: gt(function(y, C, S) {
              for (var H = S < 0 ? S + C : S; ++H < C; )
                y.push(H);
              return y;
            })
          }
        }, r.pseudos.nth = r.pseudos.eq;
        for (t in { radio: !0, checkbox: !0, file: !0, password: !0, image: !0 })
          r.pseudos[t] = Or(t);
        for (t in { submit: !0, reset: !0 })
          r.pseudos[t] = Hr(t);
        function Ci() {
        }
        Ci.prototype = r.filters = r.pseudos, r.setFilters = new Ci(), d = de.tokenize = function(y, C) {
          var S, H, x, I, z, V, W, te = Ft[y + " "];
          if (te)
            return C ? 0 : te.slice(0);
          for (z = y, V = [], W = r.preFilter; z; ) {
            (!S || (H = Sr.exec(z))) && (H && (z = z.slice(H[0].length) || z), V.push(x = [])), S = !1, (H = yi.exec(z)) && (S = H.shift(), x.push({
              value: S,
              type: H[0].replace(Jt, " ")
            }), z = z.slice(S.length));
            for (I in r.filter)
              (H = Yt[I].exec(z)) && (!W[I] || (H = W[I](H))) && (S = H.shift(), x.push({
                value: S,
                type: I,
                matches: H
              }), z = z.slice(S.length));
            if (!S)
              break;
          }
          return C ? z.length : z ? de.error(y) : Ft(y, V).slice(0);
        };
        function en(y) {
          for (var C = 0, S = y.length, H = ""; C < S; C++)
            H += y[C].value;
          return H;
        }
        function tn(y, C, S) {
          var H = C.dir, x = C.next, I = x || H, z = S && I === "parentNode", V = ce++;
          return C.first ? function(W, te, Z) {
            for (; W = W[H]; )
              if (W.nodeType === 1 || z)
                return y(W, te, Z);
            return !1;
          } : function(W, te, Z) {
            var ie, le, pe, ne = [qe, V];
            if (Z) {
              for (; W = W[H]; )
                if ((W.nodeType === 1 || z) && y(W, te, Z))
                  return !0;
            } else
              for (; W = W[H]; )
                if (W.nodeType === 1 || z)
                  if (pe = W[he] || (W[he] = {}), le = pe[W.uniqueID] || (pe[W.uniqueID] = {}), x && x === W.nodeName.toLowerCase())
                    W = W[H] || W;
                  else {
                    if ((ie = le[I]) && ie[0] === qe && ie[1] === V)
                      return ne[2] = ie[2];
                    if (le[I] = ne, ne[2] = y(W, te, Z))
                      return !0;
                  }
            return !1;
          };
        }
        function qn(y) {
          return y.length > 1 ? function(C, S, H) {
            for (var x = y.length; x--; )
              if (!y[x](C, S, H))
                return !1;
            return !0;
          } : y[0];
        }
        function Fr(y, C, S) {
          for (var H = 0, x = C.length; H < x; H++)
            de(y, C[H], S);
          return S;
        }
        function nn(y, C, S, H, x) {
          for (var I, z = [], V = 0, W = y.length, te = C != null; V < W; V++)
            (I = y[V]) && (!S || S(I, H, x)) && (z.push(I), te && C.push(V));
          return z;
        }
        function En(y, C, S, H, x, I) {
          return H && !H[he] && (H = En(H)), x && !x[he] && (x = En(x, I)), je(function(z, V, W, te) {
            var Z, ie, le, pe = [], ne = [], Ce = V.length, Se = z || Fr(
              C || "*",
              W.nodeType ? [W] : W,
              []
            ), He = y && (z || !C) ? nn(Se, pe, y, W, te) : Se, ye = S ? x || (z ? y : Ce || H) ? [] : V : He;
            if (S && S(He, ye, W, te), H)
              for (Z = nn(ye, ne), H(Z, [], W, te), ie = Z.length; ie--; )
                (le = Z[ie]) && (ye[ne[ie]] = !(He[ne[ie]] = le));
            if (z) {
              if (x || y) {
                if (x) {
                  for (Z = [], ie = ye.length; ie--; )
                    (le = ye[ie]) && Z.push(He[ie] = le);
                  x(null, ye = [], Z, te);
                }
                for (ie = ye.length; ie--; )
                  (le = ye[ie]) && (Z = x ? dt(z, le) : pe[ie]) > -1 && (z[Z] = !(V[Z] = le));
              }
            } else
              ye = nn(
                ye === V ? ye.splice(Ce, ye.length) : ye
              ), x ? x(null, V, ye, te) : st.apply(V, ye);
          });
        }
        function Nn(y) {
          for (var C, S, H, x = y.length, I = r.relative[y[0].type], z = I || r.relative[" "], V = I ? 1 : 0, W = tn(function(ie) {
            return ie === C;
          }, z, !0), te = tn(function(ie) {
            return dt(C, ie) > -1;
          }, z, !0), Z = [function(ie, le, pe) {
            var ne = !I && (pe || le !== D) || ((C = le).nodeType ? W(ie, le, pe) : te(ie, le, pe));
            return C = null, ne;
          }]; V < x; V++)
            if (S = r.relative[y[V].type])
              Z = [tn(qn(Z), S)];
            else {
              if (S = r.filter[y[V].type].apply(null, y[V].matches), S[he]) {
                for (H = ++V; H < x && !r.relative[y[H].type]; H++)
                  ;
                return En(
                  V > 1 && qn(Z),
                  V > 1 && en(
                    y.slice(0, V - 1).concat({ value: y[V - 2].type === " " ? "*" : "" })
                  ).replace(Jt, "$1"),
                  S,
                  V < H && Nn(y.slice(V, H)),
                  H < x && Nn(y = y.slice(H)),
                  H < x && en(y)
                );
              }
              Z.push(S);
            }
          return qn(Z);
        }
        function Rr(y, C) {
          var S = C.length > 0, H = y.length > 0, x = function(I, z, V, W, te) {
            var Z, ie, le, pe = 0, ne = "0", Ce = I && [], Se = [], He = D, ye = I || H && r.find.TAG("*", te), It = qe += He == null ? 1 : Math.random() || 0.1, Mt = ye.length;
            for (te && (D = z == P || z || te); ne !== Mt && (Z = ye[ne]) != null; ne++) {
              if (H && Z) {
                for (ie = 0, !z && Z.ownerDocument != P && (L(Z), V = !ae); le = y[ie++]; )
                  if (le(Z, z || P, V)) {
                    W.push(Z);
                    break;
                  }
                te && (qe = It);
              }
              S && ((Z = !le && Z) && pe--, I && Ce.push(Z));
            }
            if (pe += ne, S && ne !== pe) {
              for (ie = 0; le = C[ie++]; )
                le(Ce, Se, z, V);
              if (I) {
                if (pe > 0)
                  for (; ne--; )
                    Ce[ne] || Se[ne] || (Se[ne] = rt.call(W));
                Se = nn(Se);
              }
              st.apply(W, Se), te && !I && Se.length > 0 && pe + C.length > 1 && de.uniqueSort(W);
            }
            return te && (qe = It, D = He), Ce;
          };
          return S ? je(x) : x;
        }
        return T = de.compile = function(y, C) {
          var S, H = [], x = [], I = Xt[y + " "];
          if (!I) {
            for (C || (C = d(y)), S = C.length; S--; )
              I = Nn(C[S]), I[he] ? H.push(I) : x.push(I);
            I = Xt(
              y,
              Rr(x, H)
            ), I.selector = y;
          }
          return I;
        }, w = de.select = function(y, C, S, H) {
          var x, I, z, V, W, te = typeof y == "function" && y, Z = !H && d(y = te.selector || y);
          if (S = S || [], Z.length === 1) {
            if (I = Z[0] = Z[0].slice(0), I.length > 2 && (z = I[0]).type === "ID" && C.nodeType === 9 && ae && r.relative[I[1].type]) {
              if (C = (r.find.ID(z.matches[0].replace(Je, Ye), C) || [])[0], C)
                te && (C = C.parentNode);
              else
                return S;
              y = y.slice(I.shift().value.length);
            }
            for (x = Yt.needsContext.test(y) ? 0 : I.length; x-- && (z = I[x], !r.relative[V = z.type]); )
              if ((W = r.find[V]) && (H = W(
                z.matches[0].replace(Je, Ye),
                Dn.test(I[0].type) && Ln(C.parentNode) || C
              ))) {
                if (I.splice(x, 1), y = H.length && en(I), !y)
                  return st.apply(S, H), S;
                break;
              }
          }
          return (te || T(y, Z))(
            H,
            C,
            !ae,
            S,
            !C || Dn.test(y) && Ln(C.parentNode) || C
          ), S;
        }, i.sortStable = he.split("").sort(ft).join("") === he, i.detectDuplicates = !!j, L(), i.sortDetached = ze(function(y) {
          return y.compareDocumentPosition(P.createElement("fieldset")) & 1;
        }), ze(function(y) {
          return y.innerHTML = "<a href='#'></a>", y.firstChild.getAttribute("href") === "#";
        }) || An("type|href|height|width", function(y, C, S) {
          if (!S)
            return y.getAttribute(C, C.toLowerCase() === "type" ? 1 : 2);
        }), (!i.attributes || !ze(function(y) {
          return y.innerHTML = "<input/>", y.firstChild.setAttribute("value", ""), y.firstChild.getAttribute("value") === "";
        })) && An("value", function(y, C, S) {
          if (!S && y.nodeName.toLowerCase() === "input")
            return y.defaultValue;
        }), ze(function(y) {
          return y.getAttribute("disabled") == null;
        }) || An(Sn, function(y, C, S) {
          var H;
          if (!S)
            return y[C] === !0 ? C.toLowerCase() : (H = y.getAttributeNode(C)) && H.specified ? H.value : null;
        }), de;
      }(g);
      n.find = A, n.expr = A.selectors, n.expr[":"] = n.expr.pseudos, n.uniqueSort = n.unique = A.uniqueSort, n.text = A.getText, n.isXMLDoc = A.isXML, n.contains = A.contains, n.escapeSelector = A.escape;
      var F = function(e, t, i) {
        for (var r = [], a = i !== void 0; (e = e[t]) && e.nodeType !== 9; )
          if (e.nodeType === 1) {
            if (a && n(e).is(i))
              break;
            r.push(e);
          }
        return r;
      }, $ = function(e, t) {
        for (var i = []; e; e = e.nextSibling)
          e.nodeType === 1 && e !== t && i.push(e);
        return i;
      }, G = n.expr.match.needsContext;
      function oe(e, t) {
        return e.nodeName && e.nodeName.toLowerCase() === t.toLowerCase();
      }
      var be = /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;
      function Qe(e, t, i) {
        return f(t) ? n.grep(e, function(r, a) {
          return !!t.call(r, a, r) !== i;
        }) : t.nodeType ? n.grep(e, function(r) {
          return r === t !== i;
        }) : typeof t != "string" ? n.grep(e, function(r) {
          return re.call(t, r) > -1 !== i;
        }) : n.filter(t, e, i);
      }
      n.filter = function(e, t, i) {
        var r = t[0];
        return i && (e = ":not(" + e + ")"), t.length === 1 && r.nodeType === 1 ? n.find.matchesSelector(r, e) ? [r] : [] : n.find.matches(e, n.grep(t, function(a) {
          return a.nodeType === 1;
        }));
      }, n.fn.extend({
        find: function(e) {
          var t, i, r = this.length, a = this;
          if (typeof e != "string")
            return this.pushStack(n(e).filter(function() {
              for (t = 0; t < r; t++)
                if (n.contains(a[t], this))
                  return !0;
            }));
          for (i = this.pushStack([]), t = 0; t < r; t++)
            n.find(e, a[t], i);
          return r > 1 ? n.uniqueSort(i) : i;
        },
        filter: function(e) {
          return this.pushStack(Qe(this, e || [], !1));
        },
        not: function(e) {
          return this.pushStack(Qe(this, e || [], !0));
        },
        is: function(e) {
          return !!Qe(
            this,
            typeof e == "string" && G.test(e) ? n(e) : e || [],
            !1
          ).length;
        }
      });
      var it, ot = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/, jt = n.fn.init = function(e, t, i) {
        var r, a;
        if (!e)
          return this;
        if (i = i || it, typeof e == "string")
          if (e[0] === "<" && e[e.length - 1] === ">" && e.length >= 3 ? r = [null, e, null] : r = ot.exec(e), r && (r[1] || !t))
            if (r[1]) {
              if (t = t instanceof n ? t[0] : t, n.merge(this, n.parseHTML(
                r[1],
                t && t.nodeType ? t.ownerDocument || t : h,
                !0
              )), be.test(r[1]) && n.isPlainObject(t))
                for (r in t)
                  f(this[r]) ? this[r](t[r]) : this.attr(r, t[r]);
              return this;
            } else
              return a = h.getElementById(r[2]), a && (this[0] = a, this.length = 1), this;
          else
            return !t || t.jquery ? (t || i).find(e) : this.constructor(t).find(e);
        else {
          if (e.nodeType)
            return this[0] = e, this.length = 1, this;
          if (f(e))
            return i.ready !== void 0 ? i.ready(e) : e(n);
        }
        return n.makeArray(e, this);
      };
      jt.prototype = n.fn, it = n(h);
      var zt = /^(?:parents|prev(?:Until|All))/, xt = {
        children: !0,
        contents: !0,
        next: !0,
        prev: !0
      };
      n.fn.extend({
        has: function(e) {
          var t = n(e, this), i = t.length;
          return this.filter(function() {
            for (var r = 0; r < i; r++)
              if (n.contains(this, t[r]))
                return !0;
          });
        },
        closest: function(e, t) {
          var i, r = 0, a = this.length, l = [], d = typeof e != "string" && n(e);
          if (!G.test(e)) {
            for (; r < a; r++)
              for (i = this[r]; i && i !== t; i = i.parentNode)
                if (i.nodeType < 11 && (d ? d.index(i) > -1 : i.nodeType === 1 && n.find.matchesSelector(i, e))) {
                  l.push(i);
                  break;
                }
          }
          return this.pushStack(l.length > 1 ? n.uniqueSort(l) : l);
        },
        index: function(e) {
          return e ? typeof e == "string" ? re.call(n(e), this[0]) : re.call(
            this,
            e.jquery ? e[0] : e
          ) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
        },
        add: function(e, t) {
          return this.pushStack(
            n.uniqueSort(
              n.merge(this.get(), n(e, t))
            )
          );
        },
        addBack: function(e) {
          return this.add(
            e == null ? this.prevObject : this.prevObject.filter(e)
          );
        }
      });
      function Dt(e, t) {
        for (; (e = e[t]) && e.nodeType !== 1; )
          ;
        return e;
      }
      n.each({
        parent: function(e) {
          var t = e.parentNode;
          return t && t.nodeType !== 11 ? t : null;
        },
        parents: function(e) {
          return F(e, "parentNode");
        },
        parentsUntil: function(e, t, i) {
          return F(e, "parentNode", i);
        },
        next: function(e) {
          return Dt(e, "nextSibling");
        },
        prev: function(e) {
          return Dt(e, "previousSibling");
        },
        nextAll: function(e) {
          return F(e, "nextSibling");
        },
        prevAll: function(e) {
          return F(e, "previousSibling");
        },
        nextUntil: function(e, t, i) {
          return F(e, "nextSibling", i);
        },
        prevUntil: function(e, t, i) {
          return F(e, "previousSibling", i);
        },
        siblings: function(e) {
          return $((e.parentNode || {}).firstChild, e);
        },
        children: function(e) {
          return $(e.firstChild);
        },
        contents: function(e) {
          return e.contentDocument != null && U(e.contentDocument) ? e.contentDocument : (oe(e, "template") && (e = e.content || e), n.merge([], e.childNodes));
        }
      }, function(e, t) {
        n.fn[e] = function(i, r) {
          var a = n.map(this, t, i);
          return e.slice(-5) !== "Until" && (r = i), r && typeof r == "string" && (a = n.filter(r, a)), this.length > 1 && (xt[e] || n.uniqueSort(a), zt.test(e) && a.reverse()), this.pushStack(a);
        };
      });
      var Ne = /[^\x20\t\r\n\f]+/g;
      function un(e) {
        var t = {};
        return n.each(e.match(Ne) || [], function(i, r) {
          t[r] = !0;
        }), t;
      }
      n.Callbacks = function(e) {
        e = typeof e == "string" ? un(e) : n.extend({}, e);
        var t, i, r, a, l = [], d = [], T = -1, w = function() {
          for (a = a || e.once, r = t = !0; d.length; T = -1)
            for (i = d.shift(); ++T < l.length; )
              l[T].apply(i[0], i[1]) === !1 && e.stopOnFalse && (T = l.length, i = !1);
          e.memory || (i = !1), t = !1, a && (i ? l = [] : l = "");
        }, D = {
          add: function() {
            return l && (i && !t && (T = l.length - 1, d.push(i)), function q(j) {
              n.each(j, function(L, P) {
                f(P) ? (!e.unique || !D.has(P)) && l.push(P) : P && P.length && p(P) !== "string" && q(P);
              });
            }(arguments), i && !t && w()), this;
          },
          remove: function() {
            return n.each(arguments, function(q, j) {
              for (var L; (L = n.inArray(j, l, L)) > -1; )
                l.splice(L, 1), L <= T && T--;
            }), this;
          },
          has: function(q) {
            return q ? n.inArray(q, l) > -1 : l.length > 0;
          },
          empty: function() {
            return l && (l = []), this;
          },
          disable: function() {
            return a = d = [], l = i = "", this;
          },
          disabled: function() {
            return !l;
          },
          lock: function() {
            return a = d = [], !i && !t && (l = i = ""), this;
          },
          locked: function() {
            return !!a;
          },
          fireWith: function(q, j) {
            return a || (j = j || [], j = [q, j.slice ? j.slice() : j], d.push(j), t || w()), this;
          },
          fire: function() {
            return D.fireWith(this, arguments), this;
          },
          fired: function() {
            return !!r;
          }
        };
        return D;
      };
      function mt(e) {
        return e;
      }
      function $t(e) {
        throw e;
      }
      function Hn(e, t, i, r) {
        var a;
        try {
          e && f(a = e.promise) ? a.call(e).done(t).fail(i) : e && f(a = e.then) ? a.call(e, t, i) : t.apply(void 0, [e].slice(r));
        } catch (l) {
          i.apply(void 0, [l]);
        }
      }
      n.extend({
        Deferred: function(e) {
          var t = [
            [
              "notify",
              "progress",
              n.Callbacks("memory"),
              n.Callbacks("memory"),
              2
            ],
            [
              "resolve",
              "done",
              n.Callbacks("once memory"),
              n.Callbacks("once memory"),
              0,
              "resolved"
            ],
            [
              "reject",
              "fail",
              n.Callbacks("once memory"),
              n.Callbacks("once memory"),
              1,
              "rejected"
            ]
          ], i = "pending", r = {
            state: function() {
              return i;
            },
            always: function() {
              return a.done(arguments).fail(arguments), this;
            },
            catch: function(l) {
              return r.then(null, l);
            },
            pipe: function() {
              var l = arguments;
              return n.Deferred(function(d) {
                n.each(t, function(T, w) {
                  var D = f(l[w[4]]) && l[w[4]];
                  a[w[1]](function() {
                    var q = D && D.apply(this, arguments);
                    q && f(q.promise) ? q.promise().progress(d.notify).done(d.resolve).fail(d.reject) : d[w[0] + "With"](
                      this,
                      D ? [q] : arguments
                    );
                  });
                }), l = null;
              }).promise();
            },
            then: function(l, d, T) {
              var w = 0;
              function D(q, j, L, P) {
                return function() {
                  var X = this, ae = arguments, J = function() {
                    var ke, Pe;
                    if (!(q < w)) {
                      if (ke = L.apply(X, ae), ke === j.promise())
                        throw new TypeError("Thenable self-resolution");
                      Pe = ke && (typeof ke == "object" || typeof ke == "function") && ke.then, f(Pe) ? P ? Pe.call(
                        ke,
                        D(w, j, mt, P),
                        D(w, j, $t, P)
                      ) : (w++, Pe.call(
                        ke,
                        D(w, j, mt, P),
                        D(w, j, $t, P),
                        D(
                          w,
                          j,
                          mt,
                          j.notifyWith
                        )
                      )) : (L !== mt && (X = void 0, ae = [ke]), (P || j.resolveWith)(X, ae));
                    }
                  }, we = P ? J : function() {
                    try {
                      J();
                    } catch (ke) {
                      n.Deferred.exceptionHook && n.Deferred.exceptionHook(
                        ke,
                        we.stackTrace
                      ), q + 1 >= w && (L !== $t && (X = void 0, ae = [ke]), j.rejectWith(X, ae));
                    }
                  };
                  q ? we() : (n.Deferred.getStackHook && (we.stackTrace = n.Deferred.getStackHook()), g.setTimeout(we));
                };
              }
              return n.Deferred(function(q) {
                t[0][3].add(
                  D(
                    0,
                    q,
                    f(T) ? T : mt,
                    q.notifyWith
                  )
                ), t[1][3].add(
                  D(
                    0,
                    q,
                    f(l) ? l : mt
                  )
                ), t[2][3].add(
                  D(
                    0,
                    q,
                    f(d) ? d : $t
                  )
                );
              }).promise();
            },
            promise: function(l) {
              return l != null ? n.extend(l, r) : r;
            }
          }, a = {};
          return n.each(t, function(l, d) {
            var T = d[2], w = d[5];
            r[d[1]] = T.add, w && T.add(
              function() {
                i = w;
              },
              t[3 - l][2].disable,
              t[3 - l][3].disable,
              t[0][2].lock,
              t[0][3].lock
            ), T.add(d[3].fire), a[d[0]] = function() {
              return a[d[0] + "With"](this === a ? void 0 : this, arguments), this;
            }, a[d[0] + "With"] = T.fireWith;
          }), r.promise(a), e && e.call(a, a), a;
        },
        when: function(e) {
          var t = arguments.length, i = t, r = Array(i), a = B.call(arguments), l = n.Deferred(), d = function(T) {
            return function(w) {
              r[T] = this, a[T] = arguments.length > 1 ? B.call(arguments) : w, --t || l.resolveWith(r, a);
            };
          };
          if (t <= 1 && (Hn(
            e,
            l.done(d(i)).resolve,
            l.reject,
            !t
          ), l.state() === "pending" || f(a[i] && a[i].then)))
            return l.then();
          for (; i--; )
            Hn(a[i], d(i), l.reject);
          return l.promise();
        }
      });
      var Ni = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;
      n.Deferred.exceptionHook = function(e, t) {
        g.console && g.console.warn && e && Ni.test(e.name) && g.console.warn("jQuery.Deferred exception: " + e.message, e.stack, t);
      }, n.readyException = function(e) {
        g.setTimeout(function() {
          throw e;
        });
      };
      var cn = n.Deferred();
      n.fn.ready = function(e) {
        return cn.then(e).catch(function(t) {
          n.readyException(t);
        }), this;
      }, n.extend({
        isReady: !1,
        readyWait: 1,
        ready: function(e) {
          (e === !0 ? --n.readyWait : n.isReady) || (n.isReady = !0, !(e !== !0 && --n.readyWait > 0) && cn.resolveWith(h, [n]));
        }
      }), n.ready.then = cn.then;
      function Vt() {
        h.removeEventListener("DOMContentLoaded", Vt), g.removeEventListener("load", Vt), n.ready();
      }
      h.readyState === "complete" || h.readyState !== "loading" && !h.documentElement.doScroll ? g.setTimeout(n.ready) : (h.addEventListener("DOMContentLoaded", Vt), g.addEventListener("load", Vt));
      var Ge = function(e, t, i, r, a, l, d) {
        var T = 0, w = e.length, D = i == null;
        if (p(i) === "object") {
          a = !0;
          for (T in i)
            Ge(e, t, T, i[T], !0, l, d);
        } else if (r !== void 0 && (a = !0, f(r) || (d = !0), D && (d ? (t.call(e, r), t = null) : (D = t, t = function(q, j, L) {
          return D.call(n(q), L);
        })), t))
          for (; T < w; T++)
            t(
              e[T],
              i,
              d ? r : r.call(e[T], T, t(e[T], i))
            );
        return a ? e : D ? t.call(e) : w ? t(e[0], i) : l;
      }, Pi = /^-ms-/, Oi = /-([a-z])/g;
      function Hi(e, t) {
        return t.toUpperCase();
      }
      function Ke(e) {
        return e.replace(Pi, "ms-").replace(Oi, Hi);
      }
      var At = function(e) {
        return e.nodeType === 1 || e.nodeType === 9 || !+e.nodeType;
      };
      function Lt() {
        this.expando = n.expando + Lt.uid++;
      }
      Lt.uid = 1, Lt.prototype = {
        cache: function(e) {
          var t = e[this.expando];
          return t || (t = {}, At(e) && (e.nodeType ? e[this.expando] = t : Object.defineProperty(e, this.expando, {
            value: t,
            configurable: !0
          }))), t;
        },
        set: function(e, t, i) {
          var r, a = this.cache(e);
          if (typeof t == "string")
            a[Ke(t)] = i;
          else
            for (r in t)
              a[Ke(r)] = t[r];
          return a;
        },
        get: function(e, t) {
          return t === void 0 ? this.cache(e) : e[this.expando] && e[this.expando][Ke(t)];
        },
        access: function(e, t, i) {
          return t === void 0 || t && typeof t == "string" && i === void 0 ? this.get(e, t) : (this.set(e, t, i), i !== void 0 ? i : t);
        },
        remove: function(e, t) {
          var i, r = e[this.expando];
          if (r !== void 0) {
            if (t !== void 0)
              for (Array.isArray(t) ? t = t.map(Ke) : (t = Ke(t), t = t in r ? [t] : t.match(Ne) || []), i = t.length; i--; )
                delete r[t[i]];
            (t === void 0 || n.isEmptyObject(r)) && (e.nodeType ? e[this.expando] = void 0 : delete e[this.expando]);
          }
        },
        hasData: function(e) {
          var t = e[this.expando];
          return t !== void 0 && !n.isEmptyObject(t);
        }
      };
      var ee = new Lt(), De = new Lt(), Fi = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/, Ri = /[A-Z]/g;
      function Ii(e) {
        return e === "true" ? !0 : e === "false" ? !1 : e === "null" ? null : e === +e + "" ? +e : Fi.test(e) ? JSON.parse(e) : e;
      }
      function Fn(e, t, i) {
        var r;
        if (i === void 0 && e.nodeType === 1)
          if (r = "data-" + t.replace(Ri, "-$&").toLowerCase(), i = e.getAttribute(r), typeof i == "string") {
            try {
              i = Ii(i);
            } catch {
            }
            De.set(e, t, i);
          } else
            i = void 0;
        return i;
      }
      n.extend({
        hasData: function(e) {
          return De.hasData(e) || ee.hasData(e);
        },
        data: function(e, t, i) {
          return De.access(e, t, i);
        },
        removeData: function(e, t) {
          De.remove(e, t);
        },
        _data: function(e, t, i) {
          return ee.access(e, t, i);
        },
        _removeData: function(e, t) {
          ee.remove(e, t);
        }
      }), n.fn.extend({
        data: function(e, t) {
          var i, r, a, l = this[0], d = l && l.attributes;
          if (e === void 0) {
            if (this.length && (a = De.get(l), l.nodeType === 1 && !ee.get(l, "hasDataAttrs"))) {
              for (i = d.length; i--; )
                d[i] && (r = d[i].name, r.indexOf("data-") === 0 && (r = Ke(r.slice(5)), Fn(l, r, a[r])));
              ee.set(l, "hasDataAttrs", !0);
            }
            return a;
          }
          return typeof e == "object" ? this.each(function() {
            De.set(this, e);
          }) : Ge(this, function(T) {
            var w;
            if (l && T === void 0)
              return w = De.get(l, e), w !== void 0 || (w = Fn(l, e), w !== void 0) ? w : void 0;
            this.each(function() {
              De.set(this, e, T);
            });
          }, null, t, arguments.length > 1, null, !0);
        },
        removeData: function(e) {
          return this.each(function() {
            De.remove(this, e);
          });
        }
      }), n.extend({
        queue: function(e, t, i) {
          var r;
          if (e)
            return t = (t || "fx") + "queue", r = ee.get(e, t), i && (!r || Array.isArray(i) ? r = ee.access(e, t, n.makeArray(i)) : r.push(i)), r || [];
        },
        dequeue: function(e, t) {
          t = t || "fx";
          var i = n.queue(e, t), r = i.length, a = i.shift(), l = n._queueHooks(e, t), d = function() {
            n.dequeue(e, t);
          };
          a === "inprogress" && (a = i.shift(), r--), a && (t === "fx" && i.unshift("inprogress"), delete l.stop, a.call(e, d, l)), !r && l && l.empty.fire();
        },
        _queueHooks: function(e, t) {
          var i = t + "queueHooks";
          return ee.get(e, i) || ee.access(e, i, {
            empty: n.Callbacks("once memory").add(function() {
              ee.remove(e, [t + "queue", i]);
            })
          });
        }
      }), n.fn.extend({
        queue: function(e, t) {
          var i = 2;
          return typeof e != "string" && (t = e, e = "fx", i--), arguments.length < i ? n.queue(this[0], e) : t === void 0 ? this : this.each(function() {
            var r = n.queue(this, e, t);
            n._queueHooks(this, e), e === "fx" && r[0] !== "inprogress" && n.dequeue(this, e);
          });
        },
        dequeue: function(e) {
          return this.each(function() {
            n.dequeue(this, e);
          });
        },
        clearQueue: function(e) {
          return this.queue(e || "fx", []);
        },
        promise: function(e, t) {
          var i, r = 1, a = n.Deferred(), l = this, d = this.length, T = function() {
            --r || a.resolveWith(l, [l]);
          };
          for (typeof e != "string" && (t = e, e = void 0), e = e || "fx"; d--; )
            i = ee.get(l[d], e + "queueHooks"), i && i.empty && (r++, i.empty.add(T));
          return T(), a.promise(t);
        }
      });
      var Rn = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source, qt = new RegExp("^(?:([+-])=|)(" + Rn + ")([a-z%]*)$", "i"), Xe = ["Top", "Right", "Bottom", "Left"], lt = h.documentElement, vt = function(e) {
        return n.contains(e.ownerDocument, e);
      }, Mi = { composed: !0 };
      lt.getRootNode && (vt = function(e) {
        return n.contains(e.ownerDocument, e) || e.getRootNode(Mi) === e.ownerDocument;
      });
      var Wt = function(e, t) {
        return e = t || e, e.style.display === "none" || e.style.display === "" && vt(e) && n.css(e, "display") === "none";
      };
      function In(e, t, i, r) {
        var a, l, d = 20, T = r ? function() {
          return r.cur();
        } : function() {
          return n.css(e, t, "");
        }, w = T(), D = i && i[3] || (n.cssNumber[t] ? "" : "px"), q = e.nodeType && (n.cssNumber[t] || D !== "px" && +w) && qt.exec(n.css(e, t));
        if (q && q[3] !== D) {
          for (w = w / 2, D = D || q[3], q = +w || 1; d--; )
            n.style(e, t, q + D), (1 - l) * (1 - (l = T() / w || 0.5)) <= 0 && (d = 0), q = q / l;
          q = q * 2, n.style(e, t, q + D), i = i || [];
        }
        return i && (q = +q || +w || 0, a = i[1] ? q + (i[1] + 1) * i[2] : +i[2], r && (r.unit = D, r.start = q, r.end = a)), a;
      }
      var Mn = {};
      function Bi(e) {
        var t, i = e.ownerDocument, r = e.nodeName, a = Mn[r];
        return a || (t = i.body.appendChild(i.createElement(r)), a = n.css(t, "display"), t.parentNode.removeChild(t), a === "none" && (a = "block"), Mn[r] = a, a);
      }
      function bt(e, t) {
        for (var i, r, a = [], l = 0, d = e.length; l < d; l++)
          r = e[l], r.style && (i = r.style.display, t ? (i === "none" && (a[l] = ee.get(r, "display") || null, a[l] || (r.style.display = "")), r.style.display === "" && Wt(r) && (a[l] = Bi(r))) : i !== "none" && (a[l] = "none", ee.set(r, "display", i)));
        for (l = 0; l < d; l++)
          a[l] != null && (e[l].style.display = a[l]);
        return e;
      }
      n.fn.extend({
        show: function() {
          return bt(this, !0);
        },
        hide: function() {
          return bt(this);
        },
        toggle: function(e) {
          return typeof e == "boolean" ? e ? this.show() : this.hide() : this.each(function() {
            Wt(this) ? n(this).show() : n(this).hide();
          });
        }
      });
      var Et = /^(?:checkbox|radio)$/i, Bn = /<([a-z][^\/\0>\x20\t\r\n\f]*)/i, jn = /^$|^module$|\/(?:java|ecma)script/i;
      (function() {
        var e = h.createDocumentFragment(), t = e.appendChild(h.createElement("div")), i = h.createElement("input");
        i.setAttribute("type", "radio"), i.setAttribute("checked", "checked"), i.setAttribute("name", "t"), t.appendChild(i), b.checkClone = t.cloneNode(!0).cloneNode(!0).lastChild.checked, t.innerHTML = "<textarea>x</textarea>", b.noCloneChecked = !!t.cloneNode(!0).lastChild.defaultValue, t.innerHTML = "<option></option>", b.option = !!t.lastChild;
      })();
      var Ie = {
        thead: [1, "<table>", "</table>"],
        col: [2, "<table><colgroup>", "</colgroup></table>"],
        tr: [2, "<table><tbody>", "</tbody></table>"],
        td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
        _default: [0, "", ""]
      };
      Ie.tbody = Ie.tfoot = Ie.colgroup = Ie.caption = Ie.thead, Ie.th = Ie.td, b.option || (Ie.optgroup = Ie.option = [1, "<select multiple='multiple'>", "</select>"]);
      function Ae(e, t) {
        var i;
        return typeof e.getElementsByTagName < "u" ? i = e.getElementsByTagName(t || "*") : typeof e.querySelectorAll < "u" ? i = e.querySelectorAll(t || "*") : i = [], t === void 0 || t && oe(e, t) ? n.merge([e], i) : i;
      }
      function fn(e, t) {
        for (var i = 0, r = e.length; i < r; i++)
          ee.set(
            e[i],
            "globalEval",
            !t || ee.get(t[i], "globalEval")
          );
      }
      var ji = /<|&#?\w+;/;
      function zn(e, t, i, r, a) {
        for (var l, d, T, w, D, q, j = t.createDocumentFragment(), L = [], P = 0, X = e.length; P < X; P++)
          if (l = e[P], l || l === 0)
            if (p(l) === "object")
              n.merge(L, l.nodeType ? [l] : l);
            else if (!ji.test(l))
              L.push(t.createTextNode(l));
            else {
              for (d = d || j.appendChild(t.createElement("div")), T = (Bn.exec(l) || ["", ""])[1].toLowerCase(), w = Ie[T] || Ie._default, d.innerHTML = w[1] + n.htmlPrefilter(l) + w[2], q = w[0]; q--; )
                d = d.lastChild;
              n.merge(L, d.childNodes), d = j.firstChild, d.textContent = "";
            }
        for (j.textContent = "", P = 0; l = L[P++]; ) {
          if (r && n.inArray(l, r) > -1) {
            a && a.push(l);
            continue;
          }
          if (D = vt(l), d = Ae(j.appendChild(l), "script"), D && fn(d), i)
            for (q = 0; l = d[q++]; )
              jn.test(l.type || "") && i.push(l);
        }
        return j;
      }
      var $n = /^([^.]*)(?:\.(.+)|)/;
      function kt() {
        return !0;
      }
      function wt() {
        return !1;
      }
      function zi(e, t) {
        return e === $i() == (t === "focus");
      }
      function $i() {
        try {
          return h.activeElement;
        } catch {
        }
      }
      function hn(e, t, i, r, a, l) {
        var d, T;
        if (typeof t == "object") {
          typeof i != "string" && (r = r || i, i = void 0);
          for (T in t)
            hn(e, T, i, r, t[T], l);
          return e;
        }
        if (r == null && a == null ? (a = i, r = i = void 0) : a == null && (typeof i == "string" ? (a = r, r = void 0) : (a = r, r = i, i = void 0)), a === !1)
          a = wt;
        else if (!a)
          return e;
        return l === 1 && (d = a, a = function(w) {
          return n().off(w), d.apply(this, arguments);
        }, a.guid = d.guid || (d.guid = n.guid++)), e.each(function() {
          n.event.add(this, t, a, r, i);
        });
      }
      n.event = {
        global: {},
        add: function(e, t, i, r, a) {
          var l, d, T, w, D, q, j, L, P, X, ae, J = ee.get(e);
          if (!!At(e))
            for (i.handler && (l = i, i = l.handler, a = l.selector), a && n.find.matchesSelector(lt, a), i.guid || (i.guid = n.guid++), (w = J.events) || (w = J.events = /* @__PURE__ */ Object.create(null)), (d = J.handle) || (d = J.handle = function(we) {
              return typeof n < "u" && n.event.triggered !== we.type ? n.event.dispatch.apply(e, arguments) : void 0;
            }), t = (t || "").match(Ne) || [""], D = t.length; D--; )
              T = $n.exec(t[D]) || [], P = ae = T[1], X = (T[2] || "").split(".").sort(), P && (j = n.event.special[P] || {}, P = (a ? j.delegateType : j.bindType) || P, j = n.event.special[P] || {}, q = n.extend({
                type: P,
                origType: ae,
                data: r,
                handler: i,
                guid: i.guid,
                selector: a,
                needsContext: a && n.expr.match.needsContext.test(a),
                namespace: X.join(".")
              }, l), (L = w[P]) || (L = w[P] = [], L.delegateCount = 0, (!j.setup || j.setup.call(e, r, X, d) === !1) && e.addEventListener && e.addEventListener(P, d)), j.add && (j.add.call(e, q), q.handler.guid || (q.handler.guid = i.guid)), a ? L.splice(L.delegateCount++, 0, q) : L.push(q), n.event.global[P] = !0);
        },
        remove: function(e, t, i, r, a) {
          var l, d, T, w, D, q, j, L, P, X, ae, J = ee.hasData(e) && ee.get(e);
          if (!(!J || !(w = J.events))) {
            for (t = (t || "").match(Ne) || [""], D = t.length; D--; ) {
              if (T = $n.exec(t[D]) || [], P = ae = T[1], X = (T[2] || "").split(".").sort(), !P) {
                for (P in w)
                  n.event.remove(e, P + t[D], i, r, !0);
                continue;
              }
              for (j = n.event.special[P] || {}, P = (r ? j.delegateType : j.bindType) || P, L = w[P] || [], T = T[2] && new RegExp("(^|\\.)" + X.join("\\.(?:.*\\.|)") + "(\\.|$)"), d = l = L.length; l--; )
                q = L[l], (a || ae === q.origType) && (!i || i.guid === q.guid) && (!T || T.test(q.namespace)) && (!r || r === q.selector || r === "**" && q.selector) && (L.splice(l, 1), q.selector && L.delegateCount--, j.remove && j.remove.call(e, q));
              d && !L.length && ((!j.teardown || j.teardown.call(e, X, J.handle) === !1) && n.removeEvent(e, P, J.handle), delete w[P]);
            }
            n.isEmptyObject(w) && ee.remove(e, "handle events");
          }
        },
        dispatch: function(e) {
          var t, i, r, a, l, d, T = new Array(arguments.length), w = n.event.fix(e), D = (ee.get(this, "events") || /* @__PURE__ */ Object.create(null))[w.type] || [], q = n.event.special[w.type] || {};
          for (T[0] = w, t = 1; t < arguments.length; t++)
            T[t] = arguments[t];
          if (w.delegateTarget = this, !(q.preDispatch && q.preDispatch.call(this, w) === !1)) {
            for (d = n.event.handlers.call(this, w, D), t = 0; (a = d[t++]) && !w.isPropagationStopped(); )
              for (w.currentTarget = a.elem, i = 0; (l = a.handlers[i++]) && !w.isImmediatePropagationStopped(); )
                (!w.rnamespace || l.namespace === !1 || w.rnamespace.test(l.namespace)) && (w.handleObj = l, w.data = l.data, r = ((n.event.special[l.origType] || {}).handle || l.handler).apply(a.elem, T), r !== void 0 && (w.result = r) === !1 && (w.preventDefault(), w.stopPropagation()));
            return q.postDispatch && q.postDispatch.call(this, w), w.result;
          }
        },
        handlers: function(e, t) {
          var i, r, a, l, d, T = [], w = t.delegateCount, D = e.target;
          if (w && D.nodeType && !(e.type === "click" && e.button >= 1)) {
            for (; D !== this; D = D.parentNode || this)
              if (D.nodeType === 1 && !(e.type === "click" && D.disabled === !0)) {
                for (l = [], d = {}, i = 0; i < w; i++)
                  r = t[i], a = r.selector + " ", d[a] === void 0 && (d[a] = r.needsContext ? n(a, this).index(D) > -1 : n.find(a, this, null, [D]).length), d[a] && l.push(r);
                l.length && T.push({ elem: D, handlers: l });
              }
          }
          return D = this, w < t.length && T.push({ elem: D, handlers: t.slice(w) }), T;
        },
        addProp: function(e, t) {
          Object.defineProperty(n.Event.prototype, e, {
            enumerable: !0,
            configurable: !0,
            get: f(t) ? function() {
              if (this.originalEvent)
                return t(this.originalEvent);
            } : function() {
              if (this.originalEvent)
                return this.originalEvent[e];
            },
            set: function(i) {
              Object.defineProperty(this, e, {
                enumerable: !0,
                configurable: !0,
                writable: !0,
                value: i
              });
            }
          });
        },
        fix: function(e) {
          return e[n.expando] ? e : new n.Event(e);
        },
        special: {
          load: {
            noBubble: !0
          },
          click: {
            setup: function(e) {
              var t = this || e;
              return Et.test(t.type) && t.click && oe(t, "input") && Qt(t, "click", kt), !1;
            },
            trigger: function(e) {
              var t = this || e;
              return Et.test(t.type) && t.click && oe(t, "input") && Qt(t, "click"), !0;
            },
            _default: function(e) {
              var t = e.target;
              return Et.test(t.type) && t.click && oe(t, "input") && ee.get(t, "click") || oe(t, "a");
            }
          },
          beforeunload: {
            postDispatch: function(e) {
              e.result !== void 0 && e.originalEvent && (e.originalEvent.returnValue = e.result);
            }
          }
        }
      };
      function Qt(e, t, i) {
        if (!i) {
          ee.get(e, t) === void 0 && n.event.add(e, t, kt);
          return;
        }
        ee.set(e, t, !1), n.event.add(e, t, {
          namespace: !1,
          handler: function(r) {
            var a, l, d = ee.get(this, t);
            if (r.isTrigger & 1 && this[t]) {
              if (d.length)
                (n.event.special[t] || {}).delegateType && r.stopPropagation();
              else if (d = B.call(arguments), ee.set(this, t, d), a = i(this, t), this[t](), l = ee.get(this, t), d !== l || a ? ee.set(this, t, !1) : l = {}, d !== l)
                return r.stopImmediatePropagation(), r.preventDefault(), l && l.value;
            } else
              d.length && (ee.set(this, t, {
                value: n.event.trigger(
                  n.extend(d[0], n.Event.prototype),
                  d.slice(1),
                  this
                )
              }), r.stopImmediatePropagation());
          }
        });
      }
      n.removeEvent = function(e, t, i) {
        e.removeEventListener && e.removeEventListener(t, i);
      }, n.Event = function(e, t) {
        if (!(this instanceof n.Event))
          return new n.Event(e, t);
        e && e.type ? (this.originalEvent = e, this.type = e.type, this.isDefaultPrevented = e.defaultPrevented || e.defaultPrevented === void 0 && e.returnValue === !1 ? kt : wt, this.target = e.target && e.target.nodeType === 3 ? e.target.parentNode : e.target, this.currentTarget = e.currentTarget, this.relatedTarget = e.relatedTarget) : this.type = e, t && n.extend(this, t), this.timeStamp = e && e.timeStamp || Date.now(), this[n.expando] = !0;
      }, n.Event.prototype = {
        constructor: n.Event,
        isDefaultPrevented: wt,
        isPropagationStopped: wt,
        isImmediatePropagationStopped: wt,
        isSimulated: !1,
        preventDefault: function() {
          var e = this.originalEvent;
          this.isDefaultPrevented = kt, e && !this.isSimulated && e.preventDefault();
        },
        stopPropagation: function() {
          var e = this.originalEvent;
          this.isPropagationStopped = kt, e && !this.isSimulated && e.stopPropagation();
        },
        stopImmediatePropagation: function() {
          var e = this.originalEvent;
          this.isImmediatePropagationStopped = kt, e && !this.isSimulated && e.stopImmediatePropagation(), this.stopPropagation();
        }
      }, n.each({
        altKey: !0,
        bubbles: !0,
        cancelable: !0,
        changedTouches: !0,
        ctrlKey: !0,
        detail: !0,
        eventPhase: !0,
        metaKey: !0,
        pageX: !0,
        pageY: !0,
        shiftKey: !0,
        view: !0,
        char: !0,
        code: !0,
        charCode: !0,
        key: !0,
        keyCode: !0,
        button: !0,
        buttons: !0,
        clientX: !0,
        clientY: !0,
        offsetX: !0,
        offsetY: !0,
        pointerId: !0,
        pointerType: !0,
        screenX: !0,
        screenY: !0,
        targetTouches: !0,
        toElement: !0,
        touches: !0,
        which: !0
      }, n.event.addProp), n.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
        n.event.special[e] = {
          setup: function() {
            return Qt(this, e, zi), !1;
          },
          trigger: function() {
            return Qt(this, e), !0;
          },
          _default: function(i) {
            return ee.get(i.target, e);
          },
          delegateType: t
        };
      }), n.each({
        mouseenter: "mouseover",
        mouseleave: "mouseout",
        pointerenter: "pointerover",
        pointerleave: "pointerout"
      }, function(e, t) {
        n.event.special[e] = {
          delegateType: t,
          bindType: t,
          handle: function(i) {
            var r, a = this, l = i.relatedTarget, d = i.handleObj;
            return (!l || l !== a && !n.contains(a, l)) && (i.type = d.origType, r = d.handler.apply(this, arguments), i.type = t), r;
          }
        };
      }), n.fn.extend({
        on: function(e, t, i, r) {
          return hn(this, e, t, i, r);
        },
        one: function(e, t, i, r) {
          return hn(this, e, t, i, r, 1);
        },
        off: function(e, t, i) {
          var r, a;
          if (e && e.preventDefault && e.handleObj)
            return r = e.handleObj, n(e.delegateTarget).off(
              r.namespace ? r.origType + "." + r.namespace : r.origType,
              r.selector,
              r.handler
            ), this;
          if (typeof e == "object") {
            for (a in e)
              this.off(a, t, e[a]);
            return this;
          }
          return (t === !1 || typeof t == "function") && (i = t, t = void 0), i === !1 && (i = wt), this.each(function() {
            n.event.remove(this, e, i, t);
          });
        }
      });
      var Vi = /<script|<style|<link/i, Wi = /checked\s*(?:[^=]|=\s*.checked.)/i, Qi = /^\s*<!\[CDATA\[|\]\]>\s*$/g;
      function Vn(e, t) {
        return oe(e, "table") && oe(t.nodeType !== 11 ? t : t.firstChild, "tr") && n(e).children("tbody")[0] || e;
      }
      function Ki(e) {
        return e.type = (e.getAttribute("type") !== null) + "/" + e.type, e;
      }
      function Ui(e) {
        return (e.type || "").slice(0, 5) === "true/" ? e.type = e.type.slice(5) : e.removeAttribute("type"), e;
      }
      function Wn(e, t) {
        var i, r, a, l, d, T, w;
        if (t.nodeType === 1) {
          if (ee.hasData(e) && (l = ee.get(e), w = l.events, w)) {
            ee.remove(t, "handle events");
            for (a in w)
              for (i = 0, r = w[a].length; i < r; i++)
                n.event.add(t, a, w[a][i]);
          }
          De.hasData(e) && (d = De.access(e), T = n.extend({}, d), De.set(t, T));
        }
      }
      function Gi(e, t) {
        var i = t.nodeName.toLowerCase();
        i === "input" && Et.test(e.type) ? t.checked = e.checked : (i === "input" || i === "textarea") && (t.defaultValue = e.defaultValue);
      }
      function Ct(e, t, i, r) {
        t = M(t);
        var a, l, d, T, w, D, q = 0, j = e.length, L = j - 1, P = t[0], X = f(P);
        if (X || j > 1 && typeof P == "string" && !b.checkClone && Wi.test(P))
          return e.each(function(ae) {
            var J = e.eq(ae);
            X && (t[0] = P.call(this, ae, J.html())), Ct(J, t, i, r);
          });
        if (j && (a = zn(t, e[0].ownerDocument, !1, e, r), l = a.firstChild, a.childNodes.length === 1 && (a = l), l || r)) {
          for (d = n.map(Ae(a, "script"), Ki), T = d.length; q < j; q++)
            w = a, q !== L && (w = n.clone(w, !0, !0), T && n.merge(d, Ae(w, "script"))), i.call(e[q], w, q);
          if (T)
            for (D = d[d.length - 1].ownerDocument, n.map(d, Ui), q = 0; q < T; q++)
              w = d[q], jn.test(w.type || "") && !ee.access(w, "globalEval") && n.contains(D, w) && (w.src && (w.type || "").toLowerCase() !== "module" ? n._evalUrl && !w.noModule && n._evalUrl(w.src, {
                nonce: w.nonce || w.getAttribute("nonce")
              }, D) : o(w.textContent.replace(Qi, ""), w, D));
        }
        return e;
      }
      function Qn(e, t, i) {
        for (var r, a = t ? n.filter(t, e) : e, l = 0; (r = a[l]) != null; l++)
          !i && r.nodeType === 1 && n.cleanData(Ae(r)), r.parentNode && (i && vt(r) && fn(Ae(r, "script")), r.parentNode.removeChild(r));
        return e;
      }
      n.extend({
        htmlPrefilter: function(e) {
          return e;
        },
        clone: function(e, t, i) {
          var r, a, l, d, T = e.cloneNode(!0), w = vt(e);
          if (!b.noCloneChecked && (e.nodeType === 1 || e.nodeType === 11) && !n.isXMLDoc(e))
            for (d = Ae(T), l = Ae(e), r = 0, a = l.length; r < a; r++)
              Gi(l[r], d[r]);
          if (t)
            if (i)
              for (l = l || Ae(e), d = d || Ae(T), r = 0, a = l.length; r < a; r++)
                Wn(l[r], d[r]);
            else
              Wn(e, T);
          return d = Ae(T, "script"), d.length > 0 && fn(d, !w && Ae(e, "script")), T;
        },
        cleanData: function(e) {
          for (var t, i, r, a = n.event.special, l = 0; (i = e[l]) !== void 0; l++)
            if (At(i)) {
              if (t = i[ee.expando]) {
                if (t.events)
                  for (r in t.events)
                    a[r] ? n.event.remove(i, r) : n.removeEvent(i, r, t.handle);
                i[ee.expando] = void 0;
              }
              i[De.expando] && (i[De.expando] = void 0);
            }
        }
      }), n.fn.extend({
        detach: function(e) {
          return Qn(this, e, !0);
        },
        remove: function(e) {
          return Qn(this, e);
        },
        text: function(e) {
          return Ge(this, function(t) {
            return t === void 0 ? n.text(this) : this.empty().each(function() {
              (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) && (this.textContent = t);
            });
          }, null, e, arguments.length);
        },
        append: function() {
          return Ct(this, arguments, function(e) {
            if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
              var t = Vn(this, e);
              t.appendChild(e);
            }
          });
        },
        prepend: function() {
          return Ct(this, arguments, function(e) {
            if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
              var t = Vn(this, e);
              t.insertBefore(e, t.firstChild);
            }
          });
        },
        before: function() {
          return Ct(this, arguments, function(e) {
            this.parentNode && this.parentNode.insertBefore(e, this);
          });
        },
        after: function() {
          return Ct(this, arguments, function(e) {
            this.parentNode && this.parentNode.insertBefore(e, this.nextSibling);
          });
        },
        empty: function() {
          for (var e, t = 0; (e = this[t]) != null; t++)
            e.nodeType === 1 && (n.cleanData(Ae(e, !1)), e.textContent = "");
          return this;
        },
        clone: function(e, t) {
          return e = e == null ? !1 : e, t = t == null ? e : t, this.map(function() {
            return n.clone(this, e, t);
          });
        },
        html: function(e) {
          return Ge(this, function(t) {
            var i = this[0] || {}, r = 0, a = this.length;
            if (t === void 0 && i.nodeType === 1)
              return i.innerHTML;
            if (typeof t == "string" && !Vi.test(t) && !Ie[(Bn.exec(t) || ["", ""])[1].toLowerCase()]) {
              t = n.htmlPrefilter(t);
              try {
                for (; r < a; r++)
                  i = this[r] || {}, i.nodeType === 1 && (n.cleanData(Ae(i, !1)), i.innerHTML = t);
                i = 0;
              } catch {
              }
            }
            i && this.empty().append(t);
          }, null, e, arguments.length);
        },
        replaceWith: function() {
          var e = [];
          return Ct(this, arguments, function(t) {
            var i = this.parentNode;
            n.inArray(this, e) < 0 && (n.cleanData(Ae(this)), i && i.replaceChild(t, this));
          }, e);
        }
      }), n.each({
        appendTo: "append",
        prependTo: "prepend",
        insertBefore: "before",
        insertAfter: "after",
        replaceAll: "replaceWith"
      }, function(e, t) {
        n.fn[e] = function(i) {
          for (var r, a = [], l = n(i), d = l.length - 1, T = 0; T <= d; T++)
            r = T === d ? this : this.clone(!0), n(l[T])[t](r), R.apply(a, r.get());
          return this.pushStack(a);
        };
      });
      var dn = new RegExp("^(" + Rn + ")(?!px)[a-z%]+$", "i"), pn = /^--/, Kt = function(e) {
        var t = e.ownerDocument.defaultView;
        return (!t || !t.opener) && (t = g), t.getComputedStyle(e);
      }, Kn = function(e, t, i) {
        var r, a, l = {};
        for (a in t)
          l[a] = e.style[a], e.style[a] = t[a];
        r = i.call(e);
        for (a in t)
          e.style[a] = l[a];
        return r;
      }, Xi = new RegExp(Xe.join("|"), "i"), Un = "[\\x20\\t\\r\\n\\f]", Ji = new RegExp(
        "^" + Un + "+|((?:^|[^\\\\])(?:\\\\.)*)" + Un + "+$",
        "g"
      );
      (function() {
        function e() {
          if (!!D) {
            w.style.cssText = "position:absolute;left:-11111px;width:60px;margin-top:1px;padding:0;border:0", D.style.cssText = "position:relative;display:block;box-sizing:border-box;overflow:scroll;margin:auto;border:1px;padding:1px;width:60%;top:1%", lt.appendChild(w).appendChild(D);
            var q = g.getComputedStyle(D);
            i = q.top !== "1%", T = t(q.marginLeft) === 12, D.style.right = "60%", l = t(q.right) === 36, r = t(q.width) === 36, D.style.position = "absolute", a = t(D.offsetWidth / 3) === 12, lt.removeChild(w), D = null;
          }
        }
        function t(q) {
          return Math.round(parseFloat(q));
        }
        var i, r, a, l, d, T, w = h.createElement("div"), D = h.createElement("div");
        !D.style || (D.style.backgroundClip = "content-box", D.cloneNode(!0).style.backgroundClip = "", b.clearCloneStyle = D.style.backgroundClip === "content-box", n.extend(b, {
          boxSizingReliable: function() {
            return e(), r;
          },
          pixelBoxStyles: function() {
            return e(), l;
          },
          pixelPosition: function() {
            return e(), i;
          },
          reliableMarginLeft: function() {
            return e(), T;
          },
          scrollboxSize: function() {
            return e(), a;
          },
          reliableTrDimensions: function() {
            var q, j, L, P;
            return d == null && (q = h.createElement("table"), j = h.createElement("tr"), L = h.createElement("div"), q.style.cssText = "position:absolute;left:-11111px;border-collapse:separate", j.style.cssText = "border:1px solid", j.style.height = "1px", L.style.height = "9px", L.style.display = "block", lt.appendChild(q).appendChild(j).appendChild(L), P = g.getComputedStyle(j), d = parseInt(P.height, 10) + parseInt(P.borderTopWidth, 10) + parseInt(P.borderBottomWidth, 10) === j.offsetHeight, lt.removeChild(q)), d;
          }
        }));
      })();
      function Nt(e, t, i) {
        var r, a, l, d, T = pn.test(t), w = e.style;
        return i = i || Kt(e), i && (d = i.getPropertyValue(t) || i[t], T && (d = d.replace(Ji, "$1")), d === "" && !vt(e) && (d = n.style(e, t)), !b.pixelBoxStyles() && dn.test(d) && Xi.test(t) && (r = w.width, a = w.minWidth, l = w.maxWidth, w.minWidth = w.maxWidth = w.width = d, d = i.width, w.width = r, w.minWidth = a, w.maxWidth = l)), d !== void 0 ? d + "" : d;
      }
      function Gn(e, t) {
        return {
          get: function() {
            if (e()) {
              delete this.get;
              return;
            }
            return (this.get = t).apply(this, arguments);
          }
        };
      }
      var Xn = ["Webkit", "Moz", "ms"], Jn = h.createElement("div").style, Yn = {};
      function Yi(e) {
        for (var t = e[0].toUpperCase() + e.slice(1), i = Xn.length; i--; )
          if (e = Xn[i] + t, e in Jn)
            return e;
      }
      function gn(e) {
        var t = n.cssProps[e] || Yn[e];
        return t || (e in Jn ? e : Yn[e] = Yi(e) || e);
      }
      var Zi = /^(none|table(?!-c[ea]).+)/, er = { position: "absolute", visibility: "hidden", display: "block" }, Zn = {
        letterSpacing: "0",
        fontWeight: "400"
      };
      function ei(e, t, i) {
        var r = qt.exec(t);
        return r ? Math.max(0, r[2] - (i || 0)) + (r[3] || "px") : t;
      }
      function yn(e, t, i, r, a, l) {
        var d = t === "width" ? 1 : 0, T = 0, w = 0;
        if (i === (r ? "border" : "content"))
          return 0;
        for (; d < 4; d += 2)
          i === "margin" && (w += n.css(e, i + Xe[d], !0, a)), r ? (i === "content" && (w -= n.css(e, "padding" + Xe[d], !0, a)), i !== "margin" && (w -= n.css(e, "border" + Xe[d] + "Width", !0, a))) : (w += n.css(e, "padding" + Xe[d], !0, a), i !== "padding" ? w += n.css(e, "border" + Xe[d] + "Width", !0, a) : T += n.css(e, "border" + Xe[d] + "Width", !0, a));
        return !r && l >= 0 && (w += Math.max(0, Math.ceil(
          e["offset" + t[0].toUpperCase() + t.slice(1)] - l - w - T - 0.5
        )) || 0), w;
      }
      function ti(e, t, i) {
        var r = Kt(e), a = !b.boxSizingReliable() || i, l = a && n.css(e, "boxSizing", !1, r) === "border-box", d = l, T = Nt(e, t, r), w = "offset" + t[0].toUpperCase() + t.slice(1);
        if (dn.test(T)) {
          if (!i)
            return T;
          T = "auto";
        }
        return (!b.boxSizingReliable() && l || !b.reliableTrDimensions() && oe(e, "tr") || T === "auto" || !parseFloat(T) && n.css(e, "display", !1, r) === "inline") && e.getClientRects().length && (l = n.css(e, "boxSizing", !1, r) === "border-box", d = w in e, d && (T = e[w])), T = parseFloat(T) || 0, T + yn(
          e,
          t,
          i || (l ? "border" : "content"),
          d,
          r,
          T
        ) + "px";
      }
      n.extend({
        cssHooks: {
          opacity: {
            get: function(e, t) {
              if (t) {
                var i = Nt(e, "opacity");
                return i === "" ? "1" : i;
              }
            }
          }
        },
        cssNumber: {
          animationIterationCount: !0,
          columnCount: !0,
          fillOpacity: !0,
          flexGrow: !0,
          flexShrink: !0,
          fontWeight: !0,
          gridArea: !0,
          gridColumn: !0,
          gridColumnEnd: !0,
          gridColumnStart: !0,
          gridRow: !0,
          gridRowEnd: !0,
          gridRowStart: !0,
          lineHeight: !0,
          opacity: !0,
          order: !0,
          orphans: !0,
          widows: !0,
          zIndex: !0,
          zoom: !0
        },
        cssProps: {},
        style: function(e, t, i, r) {
          if (!(!e || e.nodeType === 3 || e.nodeType === 8 || !e.style)) {
            var a, l, d, T = Ke(t), w = pn.test(t), D = e.style;
            if (w || (t = gn(T)), d = n.cssHooks[t] || n.cssHooks[T], i !== void 0) {
              if (l = typeof i, l === "string" && (a = qt.exec(i)) && a[1] && (i = In(e, t, a), l = "number"), i == null || i !== i)
                return;
              l === "number" && !w && (i += a && a[3] || (n.cssNumber[T] ? "" : "px")), !b.clearCloneStyle && i === "" && t.indexOf("background") === 0 && (D[t] = "inherit"), (!d || !("set" in d) || (i = d.set(e, i, r)) !== void 0) && (w ? D.setProperty(t, i) : D[t] = i);
            } else
              return d && "get" in d && (a = d.get(e, !1, r)) !== void 0 ? a : D[t];
          }
        },
        css: function(e, t, i, r) {
          var a, l, d, T = Ke(t), w = pn.test(t);
          return w || (t = gn(T)), d = n.cssHooks[t] || n.cssHooks[T], d && "get" in d && (a = d.get(e, !0, i)), a === void 0 && (a = Nt(e, t, r)), a === "normal" && t in Zn && (a = Zn[t]), i === "" || i ? (l = parseFloat(a), i === !0 || isFinite(l) ? l || 0 : a) : a;
        }
      }), n.each(["height", "width"], function(e, t) {
        n.cssHooks[t] = {
          get: function(i, r, a) {
            if (r)
              return Zi.test(n.css(i, "display")) && (!i.getClientRects().length || !i.getBoundingClientRect().width) ? Kn(i, er, function() {
                return ti(i, t, a);
              }) : ti(i, t, a);
          },
          set: function(i, r, a) {
            var l, d = Kt(i), T = !b.scrollboxSize() && d.position === "absolute", w = T || a, D = w && n.css(i, "boxSizing", !1, d) === "border-box", q = a ? yn(
              i,
              t,
              a,
              D,
              d
            ) : 0;
            return D && T && (q -= Math.ceil(
              i["offset" + t[0].toUpperCase() + t.slice(1)] - parseFloat(d[t]) - yn(i, t, "border", !1, d) - 0.5
            )), q && (l = qt.exec(r)) && (l[3] || "px") !== "px" && (i.style[t] = r, r = n.css(i, t)), ei(i, r, q);
          }
        };
      }), n.cssHooks.marginLeft = Gn(
        b.reliableMarginLeft,
        function(e, t) {
          if (t)
            return (parseFloat(Nt(e, "marginLeft")) || e.getBoundingClientRect().left - Kn(e, { marginLeft: 0 }, function() {
              return e.getBoundingClientRect().left;
            })) + "px";
        }
      ), n.each({
        margin: "",
        padding: "",
        border: "Width"
      }, function(e, t) {
        n.cssHooks[e + t] = {
          expand: function(i) {
            for (var r = 0, a = {}, l = typeof i == "string" ? i.split(" ") : [i]; r < 4; r++)
              a[e + Xe[r] + t] = l[r] || l[r - 2] || l[0];
            return a;
          }
        }, e !== "margin" && (n.cssHooks[e + t].set = ei);
      }), n.fn.extend({
        css: function(e, t) {
          return Ge(this, function(i, r, a) {
            var l, d, T = {}, w = 0;
            if (Array.isArray(r)) {
              for (l = Kt(i), d = r.length; w < d; w++)
                T[r[w]] = n.css(i, r[w], !1, l);
              return T;
            }
            return a !== void 0 ? n.style(i, r, a) : n.css(i, r);
          }, e, t, arguments.length > 1);
        }
      });
      function Le(e, t, i, r, a) {
        return new Le.prototype.init(e, t, i, r, a);
      }
      n.Tween = Le, Le.prototype = {
        constructor: Le,
        init: function(e, t, i, r, a, l) {
          this.elem = e, this.prop = i, this.easing = a || n.easing._default, this.options = t, this.start = this.now = this.cur(), this.end = r, this.unit = l || (n.cssNumber[i] ? "" : "px");
        },
        cur: function() {
          var e = Le.propHooks[this.prop];
          return e && e.get ? e.get(this) : Le.propHooks._default.get(this);
        },
        run: function(e) {
          var t, i = Le.propHooks[this.prop];
          return this.options.duration ? this.pos = t = n.easing[this.easing](
            e,
            this.options.duration * e,
            0,
            1,
            this.options.duration
          ) : this.pos = t = e, this.now = (this.end - this.start) * t + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), i && i.set ? i.set(this) : Le.propHooks._default.set(this), this;
        }
      }, Le.prototype.init.prototype = Le.prototype, Le.propHooks = {
        _default: {
          get: function(e) {
            var t;
            return e.elem.nodeType !== 1 || e.elem[e.prop] != null && e.elem.style[e.prop] == null ? e.elem[e.prop] : (t = n.css(e.elem, e.prop, ""), !t || t === "auto" ? 0 : t);
          },
          set: function(e) {
            n.fx.step[e.prop] ? n.fx.step[e.prop](e) : e.elem.nodeType === 1 && (n.cssHooks[e.prop] || e.elem.style[gn(e.prop)] != null) ? n.style(e.elem, e.prop, e.now + e.unit) : e.elem[e.prop] = e.now;
          }
        }
      }, Le.propHooks.scrollTop = Le.propHooks.scrollLeft = {
        set: function(e) {
          e.elem.nodeType && e.elem.parentNode && (e.elem[e.prop] = e.now);
        }
      }, n.easing = {
        linear: function(e) {
          return e;
        },
        swing: function(e) {
          return 0.5 - Math.cos(e * Math.PI) / 2;
        },
        _default: "swing"
      }, n.fx = Le.prototype.init, n.fx.step = {};
      var Tt, Ut, tr = /^(?:toggle|show|hide)$/, nr = /queueHooks$/;
      function mn() {
        Ut && (h.hidden === !1 && g.requestAnimationFrame ? g.requestAnimationFrame(mn) : g.setTimeout(mn, n.fx.interval), n.fx.tick());
      }
      function ni() {
        return g.setTimeout(function() {
          Tt = void 0;
        }), Tt = Date.now();
      }
      function Gt(e, t) {
        var i, r = 0, a = { height: e };
        for (t = t ? 1 : 0; r < 4; r += 2 - t)
          i = Xe[r], a["margin" + i] = a["padding" + i] = e;
        return t && (a.opacity = a.width = e), a;
      }
      function ii(e, t, i) {
        for (var r, a = (Be.tweeners[t] || []).concat(Be.tweeners["*"]), l = 0, d = a.length; l < d; l++)
          if (r = a[l].call(i, t, e))
            return r;
      }
      function ir(e, t, i) {
        var r, a, l, d, T, w, D, q, j = "width" in t || "height" in t, L = this, P = {}, X = e.style, ae = e.nodeType && Wt(e), J = ee.get(e, "fxshow");
        i.queue || (d = n._queueHooks(e, "fx"), d.unqueued == null && (d.unqueued = 0, T = d.empty.fire, d.empty.fire = function() {
          d.unqueued || T();
        }), d.unqueued++, L.always(function() {
          L.always(function() {
            d.unqueued--, n.queue(e, "fx").length || d.empty.fire();
          });
        }));
        for (r in t)
          if (a = t[r], tr.test(a)) {
            if (delete t[r], l = l || a === "toggle", a === (ae ? "hide" : "show"))
              if (a === "show" && J && J[r] !== void 0)
                ae = !0;
              else
                continue;
            P[r] = J && J[r] || n.style(e, r);
          }
        if (w = !n.isEmptyObject(t), !(!w && n.isEmptyObject(P))) {
          j && e.nodeType === 1 && (i.overflow = [X.overflow, X.overflowX, X.overflowY], D = J && J.display, D == null && (D = ee.get(e, "display")), q = n.css(e, "display"), q === "none" && (D ? q = D : (bt([e], !0), D = e.style.display || D, q = n.css(e, "display"), bt([e]))), (q === "inline" || q === "inline-block" && D != null) && n.css(e, "float") === "none" && (w || (L.done(function() {
            X.display = D;
          }), D == null && (q = X.display, D = q === "none" ? "" : q)), X.display = "inline-block")), i.overflow && (X.overflow = "hidden", L.always(function() {
            X.overflow = i.overflow[0], X.overflowX = i.overflow[1], X.overflowY = i.overflow[2];
          })), w = !1;
          for (r in P)
            w || (J ? "hidden" in J && (ae = J.hidden) : J = ee.access(e, "fxshow", { display: D }), l && (J.hidden = !ae), ae && bt([e], !0), L.done(function() {
              ae || bt([e]), ee.remove(e, "fxshow");
              for (r in P)
                n.style(e, r, P[r]);
            })), w = ii(ae ? J[r] : 0, r, L), r in J || (J[r] = w.start, ae && (w.end = w.start, w.start = 0));
        }
      }
      function rr(e, t) {
        var i, r, a, l, d;
        for (i in e)
          if (r = Ke(i), a = t[r], l = e[i], Array.isArray(l) && (a = l[1], l = e[i] = l[0]), i !== r && (e[r] = l, delete e[i]), d = n.cssHooks[r], d && "expand" in d) {
            l = d.expand(l), delete e[r];
            for (i in l)
              i in e || (e[i] = l[i], t[i] = a);
          } else
            t[r] = a;
      }
      function Be(e, t, i) {
        var r, a, l = 0, d = Be.prefilters.length, T = n.Deferred().always(function() {
          delete w.elem;
        }), w = function() {
          if (a)
            return !1;
          for (var j = Tt || ni(), L = Math.max(0, D.startTime + D.duration - j), P = L / D.duration || 0, X = 1 - P, ae = 0, J = D.tweens.length; ae < J; ae++)
            D.tweens[ae].run(X);
          return T.notifyWith(e, [D, X, L]), X < 1 && J ? L : (J || T.notifyWith(e, [D, 1, 0]), T.resolveWith(e, [D]), !1);
        }, D = T.promise({
          elem: e,
          props: n.extend({}, t),
          opts: n.extend(!0, {
            specialEasing: {},
            easing: n.easing._default
          }, i),
          originalProperties: t,
          originalOptions: i,
          startTime: Tt || ni(),
          duration: i.duration,
          tweens: [],
          createTween: function(j, L) {
            var P = n.Tween(
              e,
              D.opts,
              j,
              L,
              D.opts.specialEasing[j] || D.opts.easing
            );
            return D.tweens.push(P), P;
          },
          stop: function(j) {
            var L = 0, P = j ? D.tweens.length : 0;
            if (a)
              return this;
            for (a = !0; L < P; L++)
              D.tweens[L].run(1);
            return j ? (T.notifyWith(e, [D, 1, 0]), T.resolveWith(e, [D, j])) : T.rejectWith(e, [D, j]), this;
          }
        }), q = D.props;
        for (rr(q, D.opts.specialEasing); l < d; l++)
          if (r = Be.prefilters[l].call(D, e, q, D.opts), r)
            return f(r.stop) && (n._queueHooks(D.elem, D.opts.queue).stop = r.stop.bind(r)), r;
        return n.map(q, ii, D), f(D.opts.start) && D.opts.start.call(e, D), D.progress(D.opts.progress).done(D.opts.done, D.opts.complete).fail(D.opts.fail).always(D.opts.always), n.fx.timer(
          n.extend(w, {
            elem: e,
            anim: D,
            queue: D.opts.queue
          })
        ), D;
      }
      n.Animation = n.extend(Be, {
        tweeners: {
          "*": [function(e, t) {
            var i = this.createTween(e, t);
            return In(i.elem, e, qt.exec(t), i), i;
          }]
        },
        tweener: function(e, t) {
          f(e) ? (t = e, e = ["*"]) : e = e.match(Ne);
          for (var i, r = 0, a = e.length; r < a; r++)
            i = e[r], Be.tweeners[i] = Be.tweeners[i] || [], Be.tweeners[i].unshift(t);
        },
        prefilters: [ir],
        prefilter: function(e, t) {
          t ? Be.prefilters.unshift(e) : Be.prefilters.push(e);
        }
      }), n.speed = function(e, t, i) {
        var r = e && typeof e == "object" ? n.extend({}, e) : {
          complete: i || !i && t || f(e) && e,
          duration: e,
          easing: i && t || t && !f(t) && t
        };
        return n.fx.off ? r.duration = 0 : typeof r.duration != "number" && (r.duration in n.fx.speeds ? r.duration = n.fx.speeds[r.duration] : r.duration = n.fx.speeds._default), (r.queue == null || r.queue === !0) && (r.queue = "fx"), r.old = r.complete, r.complete = function() {
          f(r.old) && r.old.call(this), r.queue && n.dequeue(this, r.queue);
        }, r;
      }, n.fn.extend({
        fadeTo: function(e, t, i, r) {
          return this.filter(Wt).css("opacity", 0).show().end().animate({ opacity: t }, e, i, r);
        },
        animate: function(e, t, i, r) {
          var a = n.isEmptyObject(e), l = n.speed(t, i, r), d = function() {
            var T = Be(this, n.extend({}, e), l);
            (a || ee.get(this, "finish")) && T.stop(!0);
          };
          return d.finish = d, a || l.queue === !1 ? this.each(d) : this.queue(l.queue, d);
        },
        stop: function(e, t, i) {
          var r = function(a) {
            var l = a.stop;
            delete a.stop, l(i);
          };
          return typeof e != "string" && (i = t, t = e, e = void 0), t && this.queue(e || "fx", []), this.each(function() {
            var a = !0, l = e != null && e + "queueHooks", d = n.timers, T = ee.get(this);
            if (l)
              T[l] && T[l].stop && r(T[l]);
            else
              for (l in T)
                T[l] && T[l].stop && nr.test(l) && r(T[l]);
            for (l = d.length; l--; )
              d[l].elem === this && (e == null || d[l].queue === e) && (d[l].anim.stop(i), a = !1, d.splice(l, 1));
            (a || !i) && n.dequeue(this, e);
          });
        },
        finish: function(e) {
          return e !== !1 && (e = e || "fx"), this.each(function() {
            var t, i = ee.get(this), r = i[e + "queue"], a = i[e + "queueHooks"], l = n.timers, d = r ? r.length : 0;
            for (i.finish = !0, n.queue(this, e, []), a && a.stop && a.stop.call(this, !0), t = l.length; t--; )
              l[t].elem === this && l[t].queue === e && (l[t].anim.stop(!0), l.splice(t, 1));
            for (t = 0; t < d; t++)
              r[t] && r[t].finish && r[t].finish.call(this);
            delete i.finish;
          });
        }
      }), n.each(["toggle", "show", "hide"], function(e, t) {
        var i = n.fn[t];
        n.fn[t] = function(r, a, l) {
          return r == null || typeof r == "boolean" ? i.apply(this, arguments) : this.animate(Gt(t, !0), r, a, l);
        };
      }), n.each({
        slideDown: Gt("show"),
        slideUp: Gt("hide"),
        slideToggle: Gt("toggle"),
        fadeIn: { opacity: "show" },
        fadeOut: { opacity: "hide" },
        fadeToggle: { opacity: "toggle" }
      }, function(e, t) {
        n.fn[e] = function(i, r, a) {
          return this.animate(t, i, r, a);
        };
      }), n.timers = [], n.fx.tick = function() {
        var e, t = 0, i = n.timers;
        for (Tt = Date.now(); t < i.length; t++)
          e = i[t], !e() && i[t] === e && i.splice(t--, 1);
        i.length || n.fx.stop(), Tt = void 0;
      }, n.fx.timer = function(e) {
        n.timers.push(e), n.fx.start();
      }, n.fx.interval = 13, n.fx.start = function() {
        Ut || (Ut = !0, mn());
      }, n.fx.stop = function() {
        Ut = null;
      }, n.fx.speeds = {
        slow: 600,
        fast: 200,
        _default: 400
      }, n.fn.delay = function(e, t) {
        return e = n.fx && n.fx.speeds[e] || e, t = t || "fx", this.queue(t, function(i, r) {
          var a = g.setTimeout(i, e);
          r.stop = function() {
            g.clearTimeout(a);
          };
        });
      }, function() {
        var e = h.createElement("input"), t = h.createElement("select"), i = t.appendChild(h.createElement("option"));
        e.type = "checkbox", b.checkOn = e.value !== "", b.optSelected = i.selected, e = h.createElement("input"), e.value = "t", e.type = "radio", b.radioValue = e.value === "t";
      }();
      var ri, Pt = n.expr.attrHandle;
      n.fn.extend({
        attr: function(e, t) {
          return Ge(this, n.attr, e, t, arguments.length > 1);
        },
        removeAttr: function(e) {
          return this.each(function() {
            n.removeAttr(this, e);
          });
        }
      }), n.extend({
        attr: function(e, t, i) {
          var r, a, l = e.nodeType;
          if (!(l === 3 || l === 8 || l === 2)) {
            if (typeof e.getAttribute > "u")
              return n.prop(e, t, i);
            if ((l !== 1 || !n.isXMLDoc(e)) && (a = n.attrHooks[t.toLowerCase()] || (n.expr.match.bool.test(t) ? ri : void 0)), i !== void 0) {
              if (i === null) {
                n.removeAttr(e, t);
                return;
              }
              return a && "set" in a && (r = a.set(e, i, t)) !== void 0 ? r : (e.setAttribute(t, i + ""), i);
            }
            return a && "get" in a && (r = a.get(e, t)) !== null ? r : (r = n.find.attr(e, t), r == null ? void 0 : r);
          }
        },
        attrHooks: {
          type: {
            set: function(e, t) {
              if (!b.radioValue && t === "radio" && oe(e, "input")) {
                var i = e.value;
                return e.setAttribute("type", t), i && (e.value = i), t;
              }
            }
          }
        },
        removeAttr: function(e, t) {
          var i, r = 0, a = t && t.match(Ne);
          if (a && e.nodeType === 1)
            for (; i = a[r++]; )
              e.removeAttribute(i);
        }
      }), ri = {
        set: function(e, t, i) {
          return t === !1 ? n.removeAttr(e, i) : e.setAttribute(i, i), i;
        }
      }, n.each(n.expr.match.bool.source.match(/\w+/g), function(e, t) {
        var i = Pt[t] || n.find.attr;
        Pt[t] = function(r, a, l) {
          var d, T, w = a.toLowerCase();
          return l || (T = Pt[w], Pt[w] = d, d = i(r, a, l) != null ? w : null, Pt[w] = T), d;
        };
      });
      var sr = /^(?:input|select|textarea|button)$/i, ar = /^(?:a|area)$/i;
      n.fn.extend({
        prop: function(e, t) {
          return Ge(this, n.prop, e, t, arguments.length > 1);
        },
        removeProp: function(e) {
          return this.each(function() {
            delete this[n.propFix[e] || e];
          });
        }
      }), n.extend({
        prop: function(e, t, i) {
          var r, a, l = e.nodeType;
          if (!(l === 3 || l === 8 || l === 2))
            return (l !== 1 || !n.isXMLDoc(e)) && (t = n.propFix[t] || t, a = n.propHooks[t]), i !== void 0 ? a && "set" in a && (r = a.set(e, i, t)) !== void 0 ? r : e[t] = i : a && "get" in a && (r = a.get(e, t)) !== null ? r : e[t];
        },
        propHooks: {
          tabIndex: {
            get: function(e) {
              var t = n.find.attr(e, "tabindex");
              return t ? parseInt(t, 10) : sr.test(e.nodeName) || ar.test(e.nodeName) && e.href ? 0 : -1;
            }
          }
        },
        propFix: {
          for: "htmlFor",
          class: "className"
        }
      }), b.optSelected || (n.propHooks.selected = {
        get: function(e) {
          var t = e.parentNode;
          return t && t.parentNode && t.parentNode.selectedIndex, null;
        },
        set: function(e) {
          var t = e.parentNode;
          t && (t.selectedIndex, t.parentNode && t.parentNode.selectedIndex);
        }
      }), n.each([
        "tabIndex",
        "readOnly",
        "maxLength",
        "cellSpacing",
        "cellPadding",
        "rowSpan",
        "colSpan",
        "useMap",
        "frameBorder",
        "contentEditable"
      ], function() {
        n.propFix[this.toLowerCase()] = this;
      });
      function ut(e) {
        var t = e.match(Ne) || [];
        return t.join(" ");
      }
      function ct(e) {
        return e.getAttribute && e.getAttribute("class") || "";
      }
      function vn(e) {
        return Array.isArray(e) ? e : typeof e == "string" ? e.match(Ne) || [] : [];
      }
      n.fn.extend({
        addClass: function(e) {
          var t, i, r, a, l, d;
          return f(e) ? this.each(function(T) {
            n(this).addClass(e.call(this, T, ct(this)));
          }) : (t = vn(e), t.length ? this.each(function() {
            if (r = ct(this), i = this.nodeType === 1 && " " + ut(r) + " ", i) {
              for (l = 0; l < t.length; l++)
                a = t[l], i.indexOf(" " + a + " ") < 0 && (i += a + " ");
              d = ut(i), r !== d && this.setAttribute("class", d);
            }
          }) : this);
        },
        removeClass: function(e) {
          var t, i, r, a, l, d;
          return f(e) ? this.each(function(T) {
            n(this).removeClass(e.call(this, T, ct(this)));
          }) : arguments.length ? (t = vn(e), t.length ? this.each(function() {
            if (r = ct(this), i = this.nodeType === 1 && " " + ut(r) + " ", i) {
              for (l = 0; l < t.length; l++)
                for (a = t[l]; i.indexOf(" " + a + " ") > -1; )
                  i = i.replace(" " + a + " ", " ");
              d = ut(i), r !== d && this.setAttribute("class", d);
            }
          }) : this) : this.attr("class", "");
        },
        toggleClass: function(e, t) {
          var i, r, a, l, d = typeof e, T = d === "string" || Array.isArray(e);
          return f(e) ? this.each(function(w) {
            n(this).toggleClass(
              e.call(this, w, ct(this), t),
              t
            );
          }) : typeof t == "boolean" && T ? t ? this.addClass(e) : this.removeClass(e) : (i = vn(e), this.each(function() {
            if (T)
              for (l = n(this), a = 0; a < i.length; a++)
                r = i[a], l.hasClass(r) ? l.removeClass(r) : l.addClass(r);
            else
              (e === void 0 || d === "boolean") && (r = ct(this), r && ee.set(this, "__className__", r), this.setAttribute && this.setAttribute(
                "class",
                r || e === !1 ? "" : ee.get(this, "__className__") || ""
              ));
          }));
        },
        hasClass: function(e) {
          var t, i, r = 0;
          for (t = " " + e + " "; i = this[r++]; )
            if (i.nodeType === 1 && (" " + ut(ct(i)) + " ").indexOf(t) > -1)
              return !0;
          return !1;
        }
      });
      var or = /\r/g;
      n.fn.extend({
        val: function(e) {
          var t, i, r, a = this[0];
          return arguments.length ? (r = f(e), this.each(function(l) {
            var d;
            this.nodeType === 1 && (r ? d = e.call(this, l, n(this).val()) : d = e, d == null ? d = "" : typeof d == "number" ? d += "" : Array.isArray(d) && (d = n.map(d, function(T) {
              return T == null ? "" : T + "";
            })), t = n.valHooks[this.type] || n.valHooks[this.nodeName.toLowerCase()], (!t || !("set" in t) || t.set(this, d, "value") === void 0) && (this.value = d));
          })) : a ? (t = n.valHooks[a.type] || n.valHooks[a.nodeName.toLowerCase()], t && "get" in t && (i = t.get(a, "value")) !== void 0 ? i : (i = a.value, typeof i == "string" ? i.replace(or, "") : i == null ? "" : i)) : void 0;
        }
      }), n.extend({
        valHooks: {
          option: {
            get: function(e) {
              var t = n.find.attr(e, "value");
              return t != null ? t : ut(n.text(e));
            }
          },
          select: {
            get: function(e) {
              var t, i, r, a = e.options, l = e.selectedIndex, d = e.type === "select-one", T = d ? null : [], w = d ? l + 1 : a.length;
              for (l < 0 ? r = w : r = d ? l : 0; r < w; r++)
                if (i = a[r], (i.selected || r === l) && !i.disabled && (!i.parentNode.disabled || !oe(i.parentNode, "optgroup"))) {
                  if (t = n(i).val(), d)
                    return t;
                  T.push(t);
                }
              return T;
            },
            set: function(e, t) {
              for (var i, r, a = e.options, l = n.makeArray(t), d = a.length; d--; )
                r = a[d], (r.selected = n.inArray(n.valHooks.option.get(r), l) > -1) && (i = !0);
              return i || (e.selectedIndex = -1), l;
            }
          }
        }
      }), n.each(["radio", "checkbox"], function() {
        n.valHooks[this] = {
          set: function(e, t) {
            if (Array.isArray(t))
              return e.checked = n.inArray(n(e).val(), t) > -1;
          }
        }, b.checkOn || (n.valHooks[this].get = function(e) {
          return e.getAttribute("value") === null ? "on" : e.value;
        });
      }), b.focusin = "onfocusin" in g;
      var si = /^(?:focusinfocus|focusoutblur)$/, ai = function(e) {
        e.stopPropagation();
      };
      n.extend(n.event, {
        trigger: function(e, t, i, r) {
          var a, l, d, T, w, D, q, j, L = [i || h], P = We.call(e, "type") ? e.type : e, X = We.call(e, "namespace") ? e.namespace.split(".") : [];
          if (l = j = d = i = i || h, !(i.nodeType === 3 || i.nodeType === 8) && !si.test(P + n.event.triggered) && (P.indexOf(".") > -1 && (X = P.split("."), P = X.shift(), X.sort()), w = P.indexOf(":") < 0 && "on" + P, e = e[n.expando] ? e : new n.Event(P, typeof e == "object" && e), e.isTrigger = r ? 2 : 3, e.namespace = X.join("."), e.rnamespace = e.namespace ? new RegExp("(^|\\.)" + X.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, e.result = void 0, e.target || (e.target = i), t = t == null ? [e] : n.makeArray(t, [e]), q = n.event.special[P] || {}, !(!r && q.trigger && q.trigger.apply(i, t) === !1))) {
            if (!r && !q.noBubble && !m(i)) {
              for (T = q.delegateType || P, si.test(T + P) || (l = l.parentNode); l; l = l.parentNode)
                L.push(l), d = l;
              d === (i.ownerDocument || h) && L.push(d.defaultView || d.parentWindow || g);
            }
            for (a = 0; (l = L[a++]) && !e.isPropagationStopped(); )
              j = l, e.type = a > 1 ? T : q.bindType || P, D = (ee.get(l, "events") || /* @__PURE__ */ Object.create(null))[e.type] && ee.get(l, "handle"), D && D.apply(l, t), D = w && l[w], D && D.apply && At(l) && (e.result = D.apply(l, t), e.result === !1 && e.preventDefault());
            return e.type = P, !r && !e.isDefaultPrevented() && (!q._default || q._default.apply(L.pop(), t) === !1) && At(i) && w && f(i[P]) && !m(i) && (d = i[w], d && (i[w] = null), n.event.triggered = P, e.isPropagationStopped() && j.addEventListener(P, ai), i[P](), e.isPropagationStopped() && j.removeEventListener(P, ai), n.event.triggered = void 0, d && (i[w] = d)), e.result;
          }
        },
        simulate: function(e, t, i) {
          var r = n.extend(
            new n.Event(),
            i,
            {
              type: e,
              isSimulated: !0
            }
          );
          n.event.trigger(r, null, t);
        }
      }), n.fn.extend({
        trigger: function(e, t) {
          return this.each(function() {
            n.event.trigger(e, t, this);
          });
        },
        triggerHandler: function(e, t) {
          var i = this[0];
          if (i)
            return n.event.trigger(e, t, i, !0);
        }
      }), b.focusin || n.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
        var i = function(r) {
          n.event.simulate(t, r.target, n.event.fix(r));
        };
        n.event.special[t] = {
          setup: function() {
            var r = this.ownerDocument || this.document || this, a = ee.access(r, t);
            a || r.addEventListener(e, i, !0), ee.access(r, t, (a || 0) + 1);
          },
          teardown: function() {
            var r = this.ownerDocument || this.document || this, a = ee.access(r, t) - 1;
            a ? ee.access(r, t, a) : (r.removeEventListener(e, i, !0), ee.remove(r, t));
          }
        };
      });
      var Ot = g.location, oi = { guid: Date.now() }, bn = /\?/;
      n.parseXML = function(e) {
        var t, i;
        if (!e || typeof e != "string")
          return null;
        try {
          t = new g.DOMParser().parseFromString(e, "text/xml");
        } catch {
        }
        return i = t && t.getElementsByTagName("parsererror")[0], (!t || i) && n.error("Invalid XML: " + (i ? n.map(i.childNodes, function(r) {
          return r.textContent;
        }).join(`
`) : e)), t;
      };
      var lr = /\[\]$/, li = /\r?\n/g, ur = /^(?:submit|button|image|reset|file)$/i, cr = /^(?:input|select|textarea|keygen)/i;
      function kn(e, t, i, r) {
        var a;
        if (Array.isArray(t))
          n.each(t, function(l, d) {
            i || lr.test(e) ? r(e, d) : kn(
              e + "[" + (typeof d == "object" && d != null ? l : "") + "]",
              d,
              i,
              r
            );
          });
        else if (!i && p(t) === "object")
          for (a in t)
            kn(e + "[" + a + "]", t[a], i, r);
        else
          r(e, t);
      }
      n.param = function(e, t) {
        var i, r = [], a = function(l, d) {
          var T = f(d) ? d() : d;
          r[r.length] = encodeURIComponent(l) + "=" + encodeURIComponent(T == null ? "" : T);
        };
        if (e == null)
          return "";
        if (Array.isArray(e) || e.jquery && !n.isPlainObject(e))
          n.each(e, function() {
            a(this.name, this.value);
          });
        else
          for (i in e)
            kn(i, e[i], t, a);
        return r.join("&");
      }, n.fn.extend({
        serialize: function() {
          return n.param(this.serializeArray());
        },
        serializeArray: function() {
          return this.map(function() {
            var e = n.prop(this, "elements");
            return e ? n.makeArray(e) : this;
          }).filter(function() {
            var e = this.type;
            return this.name && !n(this).is(":disabled") && cr.test(this.nodeName) && !ur.test(e) && (this.checked || !Et.test(e));
          }).map(function(e, t) {
            var i = n(this).val();
            return i == null ? null : Array.isArray(i) ? n.map(i, function(r) {
              return { name: t.name, value: r.replace(li, `\r
`) };
            }) : { name: t.name, value: i.replace(li, `\r
`) };
          }).get();
        }
      });
      var fr = /%20/g, hr = /#.*$/, dr = /([?&])_=[^&]*/, pr = /^(.*?):[ \t]*([^\r\n]*)$/mg, gr = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/, yr = /^(?:GET|HEAD)$/, mr = /^\/\//, ui = {}, wn = {}, ci = "*/".concat("*"), Cn = h.createElement("a");
      Cn.href = Ot.href;
      function fi(e) {
        return function(t, i) {
          typeof t != "string" && (i = t, t = "*");
          var r, a = 0, l = t.toLowerCase().match(Ne) || [];
          if (f(i))
            for (; r = l[a++]; )
              r[0] === "+" ? (r = r.slice(1) || "*", (e[r] = e[r] || []).unshift(i)) : (e[r] = e[r] || []).push(i);
        };
      }
      function hi(e, t, i, r) {
        var a = {}, l = e === wn;
        function d(T) {
          var w;
          return a[T] = !0, n.each(e[T] || [], function(D, q) {
            var j = q(t, i, r);
            if (typeof j == "string" && !l && !a[j])
              return t.dataTypes.unshift(j), d(j), !1;
            if (l)
              return !(w = j);
          }), w;
        }
        return d(t.dataTypes[0]) || !a["*"] && d("*");
      }
      function Tn(e, t) {
        var i, r, a = n.ajaxSettings.flatOptions || {};
        for (i in t)
          t[i] !== void 0 && ((a[i] ? e : r || (r = {}))[i] = t[i]);
        return r && n.extend(!0, e, r), e;
      }
      function vr(e, t, i) {
        for (var r, a, l, d, T = e.contents, w = e.dataTypes; w[0] === "*"; )
          w.shift(), r === void 0 && (r = e.mimeType || t.getResponseHeader("Content-Type"));
        if (r) {
          for (a in T)
            if (T[a] && T[a].test(r)) {
              w.unshift(a);
              break;
            }
        }
        if (w[0] in i)
          l = w[0];
        else {
          for (a in i) {
            if (!w[0] || e.converters[a + " " + w[0]]) {
              l = a;
              break;
            }
            d || (d = a);
          }
          l = l || d;
        }
        if (l)
          return l !== w[0] && w.unshift(l), i[l];
      }
      function br(e, t, i, r) {
        var a, l, d, T, w, D = {}, q = e.dataTypes.slice();
        if (q[1])
          for (d in e.converters)
            D[d.toLowerCase()] = e.converters[d];
        for (l = q.shift(); l; )
          if (e.responseFields[l] && (i[e.responseFields[l]] = t), !w && r && e.dataFilter && (t = e.dataFilter(t, e.dataType)), w = l, l = q.shift(), l) {
            if (l === "*")
              l = w;
            else if (w !== "*" && w !== l) {
              if (d = D[w + " " + l] || D["* " + l], !d) {
                for (a in D)
                  if (T = a.split(" "), T[1] === l && (d = D[w + " " + T[0]] || D["* " + T[0]], d)) {
                    d === !0 ? d = D[a] : D[a] !== !0 && (l = T[0], q.unshift(T[1]));
                    break;
                  }
              }
              if (d !== !0)
                if (d && e.throws)
                  t = d(t);
                else
                  try {
                    t = d(t);
                  } catch (j) {
                    return {
                      state: "parsererror",
                      error: d ? j : "No conversion from " + w + " to " + l
                    };
                  }
            }
          }
        return { state: "success", data: t };
      }
      n.extend({
        active: 0,
        lastModified: {},
        etag: {},
        ajaxSettings: {
          url: Ot.href,
          type: "GET",
          isLocal: gr.test(Ot.protocol),
          global: !0,
          processData: !0,
          async: !0,
          contentType: "application/x-www-form-urlencoded; charset=UTF-8",
          accepts: {
            "*": ci,
            text: "text/plain",
            html: "text/html",
            xml: "application/xml, text/xml",
            json: "application/json, text/javascript"
          },
          contents: {
            xml: /\bxml\b/,
            html: /\bhtml/,
            json: /\bjson\b/
          },
          responseFields: {
            xml: "responseXML",
            text: "responseText",
            json: "responseJSON"
          },
          converters: {
            "* text": String,
            "text html": !0,
            "text json": JSON.parse,
            "text xml": n.parseXML
          },
          flatOptions: {
            url: !0,
            context: !0
          }
        },
        ajaxSetup: function(e, t) {
          return t ? Tn(Tn(e, n.ajaxSettings), t) : Tn(n.ajaxSettings, e);
        },
        ajaxPrefilter: fi(ui),
        ajaxTransport: fi(wn),
        ajax: function(e, t) {
          typeof e == "object" && (t = e, e = void 0), t = t || {};
          var i, r, a, l, d, T, w, D, q, j, L = n.ajaxSetup({}, t), P = L.context || L, X = L.context && (P.nodeType || P.jquery) ? n(P) : n.event, ae = n.Deferred(), J = n.Callbacks("once memory"), we = L.statusCode || {}, ke = {}, Pe = {}, he = "canceled", se = {
            readyState: 0,
            getResponseHeader: function(ce) {
              var me;
              if (w) {
                if (!l)
                  for (l = {}; me = pr.exec(a); )
                    l[me[1].toLowerCase() + " "] = (l[me[1].toLowerCase() + " "] || []).concat(me[2]);
                me = l[ce.toLowerCase() + " "];
              }
              return me == null ? null : me.join(", ");
            },
            getAllResponseHeaders: function() {
              return w ? a : null;
            },
            setRequestHeader: function(ce, me) {
              return w == null && (ce = Pe[ce.toLowerCase()] = Pe[ce.toLowerCase()] || ce, ke[ce] = me), this;
            },
            overrideMimeType: function(ce) {
              return w == null && (L.mimeType = ce), this;
            },
            statusCode: function(ce) {
              var me;
              if (ce)
                if (w)
                  se.always(ce[se.status]);
                else
                  for (me in ce)
                    we[me] = [we[me], ce[me]];
              return this;
            },
            abort: function(ce) {
              var me = ce || he;
              return i && i.abort(me), qe(0, me), this;
            }
          };
          if (ae.promise(se), L.url = ((e || L.url || Ot.href) + "").replace(mr, Ot.protocol + "//"), L.type = t.method || t.type || L.method || L.type, L.dataTypes = (L.dataType || "*").toLowerCase().match(Ne) || [""], L.crossDomain == null) {
            T = h.createElement("a");
            try {
              T.href = L.url, T.href = T.href, L.crossDomain = Cn.protocol + "//" + Cn.host != T.protocol + "//" + T.host;
            } catch {
              L.crossDomain = !0;
            }
          }
          if (L.data && L.processData && typeof L.data != "string" && (L.data = n.param(L.data, L.traditional)), hi(ui, L, t, se), w)
            return se;
          D = n.event && L.global, D && n.active++ === 0 && n.event.trigger("ajaxStart"), L.type = L.type.toUpperCase(), L.hasContent = !yr.test(L.type), r = L.url.replace(hr, ""), L.hasContent ? L.data && L.processData && (L.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && (L.data = L.data.replace(fr, "+")) : (j = L.url.slice(r.length), L.data && (L.processData || typeof L.data == "string") && (r += (bn.test(r) ? "&" : "?") + L.data, delete L.data), L.cache === !1 && (r = r.replace(dr, "$1"), j = (bn.test(r) ? "&" : "?") + "_=" + oi.guid++ + j), L.url = r + j), L.ifModified && (n.lastModified[r] && se.setRequestHeader("If-Modified-Since", n.lastModified[r]), n.etag[r] && se.setRequestHeader("If-None-Match", n.etag[r])), (L.data && L.hasContent && L.contentType !== !1 || t.contentType) && se.setRequestHeader("Content-Type", L.contentType), se.setRequestHeader(
            "Accept",
            L.dataTypes[0] && L.accepts[L.dataTypes[0]] ? L.accepts[L.dataTypes[0]] + (L.dataTypes[0] !== "*" ? ", " + ci + "; q=0.01" : "") : L.accepts["*"]
          );
          for (q in L.headers)
            se.setRequestHeader(q, L.headers[q]);
          if (L.beforeSend && (L.beforeSend.call(P, se, L) === !1 || w))
            return se.abort();
          if (he = "abort", J.add(L.complete), se.done(L.success), se.fail(L.error), i = hi(wn, L, t, se), !i)
            qe(-1, "No Transport");
          else {
            if (se.readyState = 1, D && X.trigger("ajaxSend", [se, L]), w)
              return se;
            L.async && L.timeout > 0 && (d = g.setTimeout(function() {
              se.abort("timeout");
            }, L.timeout));
            try {
              w = !1, i.send(ke, qe);
            } catch (ce) {
              if (w)
                throw ce;
              qe(-1, ce);
            }
          }
          function qe(ce, me, Ft, Xt) {
            var Oe, ft, ht, Ee, rt, Me = me;
            w || (w = !0, d && g.clearTimeout(d), i = void 0, a = Xt || "", se.readyState = ce > 0 ? 4 : 0, Oe = ce >= 200 && ce < 300 || ce === 304, Ft && (Ee = vr(L, se, Ft)), !Oe && n.inArray("script", L.dataTypes) > -1 && n.inArray("json", L.dataTypes) < 0 && (L.converters["text script"] = function() {
            }), Ee = br(L, Ee, se, Oe), Oe ? (L.ifModified && (rt = se.getResponseHeader("Last-Modified"), rt && (n.lastModified[r] = rt), rt = se.getResponseHeader("etag"), rt && (n.etag[r] = rt)), ce === 204 || L.type === "HEAD" ? Me = "nocontent" : ce === 304 ? Me = "notmodified" : (Me = Ee.state, ft = Ee.data, ht = Ee.error, Oe = !ht)) : (ht = Me, (ce || !Me) && (Me = "error", ce < 0 && (ce = 0))), se.status = ce, se.statusText = (me || Me) + "", Oe ? ae.resolveWith(P, [ft, Me, se]) : ae.rejectWith(P, [se, Me, ht]), se.statusCode(we), we = void 0, D && X.trigger(
              Oe ? "ajaxSuccess" : "ajaxError",
              [se, L, Oe ? ft : ht]
            ), J.fireWith(P, [se, Me]), D && (X.trigger("ajaxComplete", [se, L]), --n.active || n.event.trigger("ajaxStop")));
          }
          return se;
        },
        getJSON: function(e, t, i) {
          return n.get(e, t, i, "json");
        },
        getScript: function(e, t) {
          return n.get(e, void 0, t, "script");
        }
      }), n.each(["get", "post"], function(e, t) {
        n[t] = function(i, r, a, l) {
          return f(r) && (l = l || a, a = r, r = void 0), n.ajax(n.extend({
            url: i,
            type: t,
            dataType: l,
            data: r,
            success: a
          }, n.isPlainObject(i) && i));
        };
      }), n.ajaxPrefilter(function(e) {
        var t;
        for (t in e.headers)
          t.toLowerCase() === "content-type" && (e.contentType = e.headers[t] || "");
      }), n._evalUrl = function(e, t, i) {
        return n.ajax({
          url: e,
          type: "GET",
          dataType: "script",
          cache: !0,
          async: !1,
          global: !1,
          converters: {
            "text script": function() {
            }
          },
          dataFilter: function(r) {
            n.globalEval(r, t, i);
          }
        });
      }, n.fn.extend({
        wrapAll: function(e) {
          var t;
          return this[0] && (f(e) && (e = e.call(this[0])), t = n(e, this[0].ownerDocument).eq(0).clone(!0), this[0].parentNode && t.insertBefore(this[0]), t.map(function() {
            for (var i = this; i.firstElementChild; )
              i = i.firstElementChild;
            return i;
          }).append(this)), this;
        },
        wrapInner: function(e) {
          return f(e) ? this.each(function(t) {
            n(this).wrapInner(e.call(this, t));
          }) : this.each(function() {
            var t = n(this), i = t.contents();
            i.length ? i.wrapAll(e) : t.append(e);
          });
        },
        wrap: function(e) {
          var t = f(e);
          return this.each(function(i) {
            n(this).wrapAll(t ? e.call(this, i) : e);
          });
        },
        unwrap: function(e) {
          return this.parent(e).not("body").each(function() {
            n(this).replaceWith(this.childNodes);
          }), this;
        }
      }), n.expr.pseudos.hidden = function(e) {
        return !n.expr.pseudos.visible(e);
      }, n.expr.pseudos.visible = function(e) {
        return !!(e.offsetWidth || e.offsetHeight || e.getClientRects().length);
      }, n.ajaxSettings.xhr = function() {
        try {
          return new g.XMLHttpRequest();
        } catch {
        }
      };
      var kr = {
        0: 200,
        1223: 204
      }, Ht = n.ajaxSettings.xhr();
      b.cors = !!Ht && "withCredentials" in Ht, b.ajax = Ht = !!Ht, n.ajaxTransport(function(e) {
        var t, i;
        if (b.cors || Ht && !e.crossDomain)
          return {
            send: function(r, a) {
              var l, d = e.xhr();
              if (d.open(
                e.type,
                e.url,
                e.async,
                e.username,
                e.password
              ), e.xhrFields)
                for (l in e.xhrFields)
                  d[l] = e.xhrFields[l];
              e.mimeType && d.overrideMimeType && d.overrideMimeType(e.mimeType), !e.crossDomain && !r["X-Requested-With"] && (r["X-Requested-With"] = "XMLHttpRequest");
              for (l in r)
                d.setRequestHeader(l, r[l]);
              t = function(T) {
                return function() {
                  t && (t = i = d.onload = d.onerror = d.onabort = d.ontimeout = d.onreadystatechange = null, T === "abort" ? d.abort() : T === "error" ? typeof d.status != "number" ? a(0, "error") : a(
                    d.status,
                    d.statusText
                  ) : a(
                    kr[d.status] || d.status,
                    d.statusText,
                    (d.responseType || "text") !== "text" || typeof d.responseText != "string" ? { binary: d.response } : { text: d.responseText },
                    d.getAllResponseHeaders()
                  ));
                };
              }, d.onload = t(), i = d.onerror = d.ontimeout = t("error"), d.onabort !== void 0 ? d.onabort = i : d.onreadystatechange = function() {
                d.readyState === 4 && g.setTimeout(function() {
                  t && i();
                });
              }, t = t("abort");
              try {
                d.send(e.hasContent && e.data || null);
              } catch (T) {
                if (t)
                  throw T;
              }
            },
            abort: function() {
              t && t();
            }
          };
      }), n.ajaxPrefilter(function(e) {
        e.crossDomain && (e.contents.script = !1);
      }), n.ajaxSetup({
        accepts: {
          script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
        },
        contents: {
          script: /\b(?:java|ecma)script\b/
        },
        converters: {
          "text script": function(e) {
            return n.globalEval(e), e;
          }
        }
      }), n.ajaxPrefilter("script", function(e) {
        e.cache === void 0 && (e.cache = !1), e.crossDomain && (e.type = "GET");
      }), n.ajaxTransport("script", function(e) {
        if (e.crossDomain || e.scriptAttrs) {
          var t, i;
          return {
            send: function(r, a) {
              t = n("<script>").attr(e.scriptAttrs || {}).prop({ charset: e.scriptCharset, src: e.url }).on("load error", i = function(l) {
                t.remove(), i = null, l && a(l.type === "error" ? 404 : 200, l.type);
              }), h.head.appendChild(t[0]);
            },
            abort: function() {
              i && i();
            }
          };
        }
      });
      var di = [], _n = /(=)\?(?=&|$)|\?\?/;
      n.ajaxSetup({
        jsonp: "callback",
        jsonpCallback: function() {
          var e = di.pop() || n.expando + "_" + oi.guid++;
          return this[e] = !0, e;
        }
      }), n.ajaxPrefilter("json jsonp", function(e, t, i) {
        var r, a, l, d = e.jsonp !== !1 && (_n.test(e.url) ? "url" : typeof e.data == "string" && (e.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && _n.test(e.data) && "data");
        if (d || e.dataTypes[0] === "jsonp")
          return r = e.jsonpCallback = f(e.jsonpCallback) ? e.jsonpCallback() : e.jsonpCallback, d ? e[d] = e[d].replace(_n, "$1" + r) : e.jsonp !== !1 && (e.url += (bn.test(e.url) ? "&" : "?") + e.jsonp + "=" + r), e.converters["script json"] = function() {
            return l || n.error(r + " was not called"), l[0];
          }, e.dataTypes[0] = "json", a = g[r], g[r] = function() {
            l = arguments;
          }, i.always(function() {
            a === void 0 ? n(g).removeProp(r) : g[r] = a, e[r] && (e.jsonpCallback = t.jsonpCallback, di.push(r)), l && f(a) && a(l[0]), l = a = void 0;
          }), "script";
      }), b.createHTMLDocument = function() {
        var e = h.implementation.createHTMLDocument("").body;
        return e.innerHTML = "<form></form><form></form>", e.childNodes.length === 2;
      }(), n.parseHTML = function(e, t, i) {
        if (typeof e != "string")
          return [];
        typeof t == "boolean" && (i = t, t = !1);
        var r, a, l;
        return t || (b.createHTMLDocument ? (t = h.implementation.createHTMLDocument(""), r = t.createElement("base"), r.href = h.location.href, t.head.appendChild(r)) : t = h), a = be.exec(e), l = !i && [], a ? [t.createElement(a[1])] : (a = zn([e], t, l), l && l.length && n(l).remove(), n.merge([], a.childNodes));
      }, n.fn.load = function(e, t, i) {
        var r, a, l, d = this, T = e.indexOf(" ");
        return T > -1 && (r = ut(e.slice(T)), e = e.slice(0, T)), f(t) ? (i = t, t = void 0) : t && typeof t == "object" && (a = "POST"), d.length > 0 && n.ajax({
          url: e,
          type: a || "GET",
          dataType: "html",
          data: t
        }).done(function(w) {
          l = arguments, d.html(r ? n("<div>").append(n.parseHTML(w)).find(r) : w);
        }).always(i && function(w, D) {
          d.each(function() {
            i.apply(this, l || [w.responseText, D, w]);
          });
        }), this;
      }, n.expr.pseudos.animated = function(e) {
        return n.grep(n.timers, function(t) {
          return e === t.elem;
        }).length;
      }, n.offset = {
        setOffset: function(e, t, i) {
          var r, a, l, d, T, w, D, q = n.css(e, "position"), j = n(e), L = {};
          q === "static" && (e.style.position = "relative"), T = j.offset(), l = n.css(e, "top"), w = n.css(e, "left"), D = (q === "absolute" || q === "fixed") && (l + w).indexOf("auto") > -1, D ? (r = j.position(), d = r.top, a = r.left) : (d = parseFloat(l) || 0, a = parseFloat(w) || 0), f(t) && (t = t.call(e, i, n.extend({}, T))), t.top != null && (L.top = t.top - T.top + d), t.left != null && (L.left = t.left - T.left + a), "using" in t ? t.using.call(e, L) : j.css(L);
        }
      }, n.fn.extend({
        offset: function(e) {
          if (arguments.length)
            return e === void 0 ? this : this.each(function(a) {
              n.offset.setOffset(this, e, a);
            });
          var t, i, r = this[0];
          if (!!r)
            return r.getClientRects().length ? (t = r.getBoundingClientRect(), i = r.ownerDocument.defaultView, {
              top: t.top + i.pageYOffset,
              left: t.left + i.pageXOffset
            }) : { top: 0, left: 0 };
        },
        position: function() {
          if (!!this[0]) {
            var e, t, i, r = this[0], a = { top: 0, left: 0 };
            if (n.css(r, "position") === "fixed")
              t = r.getBoundingClientRect();
            else {
              for (t = this.offset(), i = r.ownerDocument, e = r.offsetParent || i.documentElement; e && (e === i.body || e === i.documentElement) && n.css(e, "position") === "static"; )
                e = e.parentNode;
              e && e !== r && e.nodeType === 1 && (a = n(e).offset(), a.top += n.css(e, "borderTopWidth", !0), a.left += n.css(e, "borderLeftWidth", !0));
            }
            return {
              top: t.top - a.top - n.css(r, "marginTop", !0),
              left: t.left - a.left - n.css(r, "marginLeft", !0)
            };
          }
        },
        offsetParent: function() {
          return this.map(function() {
            for (var e = this.offsetParent; e && n.css(e, "position") === "static"; )
              e = e.offsetParent;
            return e || lt;
          });
        }
      }), n.each({ scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function(e, t) {
        var i = t === "pageYOffset";
        n.fn[e] = function(r) {
          return Ge(this, function(a, l, d) {
            var T;
            if (m(a) ? T = a : a.nodeType === 9 && (T = a.defaultView), d === void 0)
              return T ? T[t] : a[l];
            T ? T.scrollTo(
              i ? T.pageXOffset : d,
              i ? d : T.pageYOffset
            ) : a[l] = d;
          }, e, r, arguments.length);
        };
      }), n.each(["top", "left"], function(e, t) {
        n.cssHooks[t] = Gn(
          b.pixelPosition,
          function(i, r) {
            if (r)
              return r = Nt(i, t), dn.test(r) ? n(i).position()[t] + "px" : r;
          }
        );
      }), n.each({ Height: "height", Width: "width" }, function(e, t) {
        n.each({
          padding: "inner" + e,
          content: t,
          "": "outer" + e
        }, function(i, r) {
          n.fn[r] = function(a, l) {
            var d = arguments.length && (i || typeof a != "boolean"), T = i || (a === !0 || l === !0 ? "margin" : "border");
            return Ge(this, function(w, D, q) {
              var j;
              return m(w) ? r.indexOf("outer") === 0 ? w["inner" + e] : w.document.documentElement["client" + e] : w.nodeType === 9 ? (j = w.documentElement, Math.max(
                w.body["scroll" + e],
                j["scroll" + e],
                w.body["offset" + e],
                j["offset" + e],
                j["client" + e]
              )) : q === void 0 ? n.css(w, D, T) : n.style(w, D, q, T);
            }, t, d ? a : void 0, d);
          };
        });
      }), n.each([
        "ajaxStart",
        "ajaxStop",
        "ajaxComplete",
        "ajaxError",
        "ajaxSuccess",
        "ajaxSend"
      ], function(e, t) {
        n.fn[t] = function(i) {
          return this.on(t, i);
        };
      }), n.fn.extend({
        bind: function(e, t, i) {
          return this.on(e, null, t, i);
        },
        unbind: function(e, t) {
          return this.off(e, null, t);
        },
        delegate: function(e, t, i, r) {
          return this.on(t, e, i, r);
        },
        undelegate: function(e, t, i) {
          return arguments.length === 1 ? this.off(e, "**") : this.off(t, e || "**", i);
        },
        hover: function(e, t) {
          return this.mouseenter(e).mouseleave(t || e);
        }
      }), n.each(
        "blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),
        function(e, t) {
          n.fn[t] = function(i, r) {
            return arguments.length > 0 ? this.on(t, null, i, r) : this.trigger(t);
          };
        }
      );
      var wr = /^[\s\uFEFF\xA0]+|([^\s\uFEFF\xA0])[\s\uFEFF\xA0]+$/g;
      n.proxy = function(e, t) {
        var i, r, a;
        if (typeof t == "string" && (i = e[t], t = e, e = i), !!f(e))
          return r = B.call(arguments, 2), a = function() {
            return e.apply(t || this, r.concat(B.call(arguments)));
          }, a.guid = e.guid = e.guid || n.guid++, a;
      }, n.holdReady = function(e) {
        e ? n.readyWait++ : n.ready(!0);
      }, n.isArray = Array.isArray, n.parseJSON = JSON.parse, n.nodeName = oe, n.isFunction = f, n.isWindow = m, n.camelCase = Ke, n.type = p, n.now = Date.now, n.isNumeric = function(e) {
        var t = n.type(e);
        return (t === "number" || t === "string") && !isNaN(e - parseFloat(e));
      }, n.trim = function(e) {
        return e == null ? "" : (e + "").replace(wr, "$1");
      };
      var Cr = g.jQuery, Tr = g.$;
      return n.noConflict = function(e) {
        return g.$ === n && (g.$ = Tr), e && g.jQuery === n && (g.jQuery = Cr), n;
      }, typeof u > "u" && (g.jQuery = g.$ = n), n;
    });
  }(Pn)), Pn.exports;
}
var On = an(), Ei = { exports: {} };
/*!
 * typeahead.js 1.3.1
 * https://github.com/corejavascript/typeahead.js
 * Copyright 2013-2020 Twitter, Inc. and other contributors; Licensed MIT
 */
(function(s) {
  (function(g, u) {
    s.exports ? s.exports = u(an()) : g.Bloodhound = u(g.jQuery);
  })(sn, function(g) {
    var u = function() {
      return {
        isMsie: function() {
          return /(msie|trident)/i.test(navigator.userAgent) ? navigator.userAgent.match(/(msie |rv:)(\d+(.\d+)?)/i)[2] : !1;
        },
        isBlankString: function(v) {
          return !v || /^\s*$/.test(v);
        },
        escapeRegExChars: function(v) {
          return v.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        },
        isString: function(v) {
          return typeof v == "string";
        },
        isNumber: function(v) {
          return typeof v == "number";
        },
        isArray: g.isArray,
        isFunction: g.isFunction,
        isObject: g.isPlainObject,
        isUndefined: function(v) {
          return typeof v > "u";
        },
        isElement: function(v) {
          return !!(v && v.nodeType === 1);
        },
        isJQuery: function(v) {
          return v instanceof g;
        },
        toStr: function(b) {
          return u.isUndefined(b) || b === null ? "" : b + "";
        },
        bind: g.proxy,
        each: function(v, b) {
          g.each(v, f);
          function f(m, h) {
            return b(h, m);
          }
        },
        map: g.map,
        filter: g.grep,
        every: function(v, b) {
          var f = !0;
          return v ? (g.each(v, function(m, h) {
            if (!(f = b.call(null, h, m, v)))
              return !1;
          }), !!f) : f;
        },
        some: function(v, b) {
          var f = !1;
          return v ? (g.each(v, function(m, h) {
            if (f = b.call(null, h, m, v))
              return !1;
          }), !!f) : f;
        },
        mixin: g.extend,
        identity: function(v) {
          return v;
        },
        clone: function(v) {
          return g.extend(!0, {}, v);
        },
        getIdGenerator: function() {
          var v = 0;
          return function() {
            return v++;
          };
        },
        templatify: function(b) {
          return g.isFunction(b) ? b : f;
          function f() {
            return String(b);
          }
        },
        defer: function(v) {
          setTimeout(v, 0);
        },
        debounce: function(v, b, f) {
          var m, h;
          return function() {
            var c = this, o = arguments, p, k;
            return p = function() {
              m = null, f || (h = v.apply(c, o));
            }, k = f && !m, clearTimeout(m), m = setTimeout(p, b), k && (h = v.apply(c, o)), h;
          };
        },
        throttle: function(v, b) {
          var f, m, h, c, o, p;
          return o = 0, p = function() {
            o = new Date(), h = null, c = v.apply(f, m);
          }, function() {
            var k = new Date(), n = b - (k - o);
            return f = this, m = arguments, n <= 0 ? (clearTimeout(h), h = null, o = k, c = v.apply(f, m)) : h || (h = setTimeout(p, n)), c;
          };
        },
        stringify: function(v) {
          return u.isString(v) ? v : JSON.stringify(v);
        },
        guid: function() {
          function v(b) {
            var f = (Math.random().toString(16) + "000000000").substr(2, 8);
            return b ? "-" + f.substr(0, 4) + "-" + f.substr(4, 4) : f;
          }
          return "tt-" + v() + v(!0) + v(!0) + v();
        },
        noop: function() {
        }
      };
    }(), K = "1.3.1", U = function() {
      return {
        nonword: b,
        whitespace: v,
        ngram: f,
        obj: {
          nonword: m(b),
          whitespace: m(v),
          ngram: m(f)
        }
      };
      function v(h) {
        return h = u.toStr(h), h ? h.split(/\s+/) : [];
      }
      function b(h) {
        return h = u.toStr(h), h ? h.split(/\W+/) : [];
      }
      function f(h) {
        h = u.toStr(h);
        var c = [], o = "";
        return u.each(h.split(""), function(p) {
          p.match(/\s+/) ? o = "" : (c.push(o + p), o += p);
        }), c;
      }
      function m(h) {
        return function(o) {
          return o = u.isArray(o) ? o : [].slice.call(arguments, 0), function(k) {
            var n = [];
            return u.each(o, function(_) {
              n = n.concat(h(u.toStr(k[_])));
            }), n;
          };
        };
      }
    }(), B = function() {
      function v(m) {
        this.maxSize = u.isNumber(m) ? m : 100, this.reset(), this.maxSize <= 0 && (this.set = this.get = g.noop);
      }
      u.mixin(v.prototype, {
        set: function(h, c) {
          var o = this.list.tail, p;
          this.size >= this.maxSize && (this.list.remove(o), delete this.hash[o.key], this.size--), (p = this.hash[h]) ? (p.val = c, this.list.moveToFront(p)) : (p = new f(h, c), this.list.add(p), this.hash[h] = p, this.size++);
        },
        get: function(h) {
          var c = this.hash[h];
          if (c)
            return this.list.moveToFront(c), c.val;
        },
        reset: function() {
          this.size = 0, this.hash = {}, this.list = new b();
        }
      });
      function b() {
        this.head = this.tail = null;
      }
      u.mixin(b.prototype, {
        add: function(h) {
          this.head && (h.next = this.head, this.head.prev = h), this.head = h, this.tail = this.tail || h;
        },
        remove: function(h) {
          h.prev ? h.prev.next = h.next : this.head = h.next, h.next ? h.next.prev = h.prev : this.tail = h.prev;
        },
        moveToFront: function(m) {
          this.remove(m), this.add(m);
        }
      });
      function f(m, h) {
        this.key = m, this.val = h, this.prev = this.next = null;
      }
      return v;
    }(), M = function() {
      var v;
      try {
        v = window.localStorage, v.setItem("~~~", "!"), v.removeItem("~~~");
      } catch {
        v = null;
      }
      function b(o, p) {
        this.prefix = ["__", o, "__"].join(""), this.ttlKey = "__ttl__", this.keyMatcher = new RegExp("^" + u.escapeRegExChars(this.prefix)), this.ls = p || v, !this.ls && this._noop();
      }
      return u.mixin(b.prototype, {
        _prefix: function(o) {
          return this.prefix + o;
        },
        _ttlKey: function(o) {
          return this._prefix(o) + this.ttlKey;
        },
        _noop: function() {
          this.get = this.set = this.remove = this.clear = this.isExpired = u.noop;
        },
        _safeSet: function(o, p) {
          try {
            this.ls.setItem(o, p);
          } catch (k) {
            k.name === "QuotaExceededError" && (this.clear(), this._noop());
          }
        },
        get: function(o) {
          return this.isExpired(o) && this.remove(o), h(this.ls.getItem(this._prefix(o)));
        },
        set: function(o, p, k) {
          return u.isNumber(k) ? this._safeSet(this._ttlKey(o), m(f() + k)) : this.ls.removeItem(this._ttlKey(o)), this._safeSet(this._prefix(o), m(p));
        },
        remove: function(o) {
          return this.ls.removeItem(this._ttlKey(o)), this.ls.removeItem(this._prefix(o)), this;
        },
        clear: function() {
          var o, p = c(this.keyMatcher);
          for (o = p.length; o--; )
            this.remove(p[o]);
          return this;
        },
        isExpired: function(o) {
          var p = h(this.ls.getItem(this._ttlKey(o)));
          return !!(u.isNumber(p) && f() > p);
        }
      }), b;
      function f() {
        return new Date().getTime();
      }
      function m(o) {
        return JSON.stringify(u.isUndefined(o) ? null : o);
      }
      function h(o) {
        return g.parseJSON(o);
      }
      function c(o) {
        var p, k, n = [], _ = v.length;
        for (p = 0; p < _; p++)
          (k = v.key(p)).match(o) && n.push(k.replace(o, ""));
        return n;
      }
    }(), R = function() {
      var v = 0, b = {}, f = new B(10);
      function m(h) {
        h = h || {}, this.maxPendingRequests = h.maxPendingRequests || 6, this.cancelled = !1, this.lastReq = null, this._send = h.transport, this._get = h.limiter ? h.limiter(this._get) : this._get, this._cache = h.cache === !1 ? new B(0) : f;
      }
      return m.setMaxPendingRequests = function(c) {
        this.maxPendingRequests = c;
      }, m.resetCache = function() {
        f.reset();
      }, u.mixin(m.prototype, {
        _fingerprint: function(c) {
          return c = c || {}, c.url + c.type + g.param(c.data || {});
        },
        _get: function(h, c) {
          var o = this, p, k;
          if (p = this._fingerprint(h), this.cancelled || p !== this.lastReq)
            return;
          (k = b[p]) ? k.done(n).fail(_) : v < this.maxPendingRequests ? (v++, b[p] = this._send(h).done(n).fail(_).always(A)) : this.onDeckRequestArgs = [].slice.call(arguments, 0);
          function n(F) {
            c(null, F), o._cache.set(p, F);
          }
          function _() {
            c(!0);
          }
          function A() {
            v--, delete b[p], o.onDeckRequestArgs && (o._get.apply(o, o.onDeckRequestArgs), o.onDeckRequestArgs = null);
          }
        },
        get: function(h, c) {
          var o, p;
          c = c || g.noop, h = u.isString(h) ? {
            url: h
          } : h || {}, p = this._fingerprint(h), this.cancelled = !1, this.lastReq = p, (o = this._cache.get(p)) ? c(null, o) : this._get(h, c);
        },
        cancel: function() {
          this.cancelled = !0;
        }
      }), m;
    }(), re = window.SearchIndex = function() {
      var v = "c", b = "i";
      function f(p) {
        p = p || {}, (!p.datumTokenizer || !p.queryTokenizer) && g.error("datumTokenizer and queryTokenizer are both required"), this.identify = p.identify || u.stringify, this.datumTokenizer = p.datumTokenizer, this.queryTokenizer = p.queryTokenizer, this.matchAnyQueryToken = p.matchAnyQueryToken, this.reset();
      }
      return u.mixin(f.prototype, {
        bootstrap: function(k) {
          this.datums = k.datums, this.trie = k.trie;
        },
        add: function(p) {
          var k = this;
          p = u.isArray(p) ? p : [p], u.each(p, function(n) {
            var _, A;
            k.datums[_ = k.identify(n)] = n, A = m(k.datumTokenizer(n)), u.each(A, function(F) {
              var $, G, oe;
              for ($ = k.trie, G = F.split(""); oe = G.shift(); )
                $ = $[v][oe] || ($[v][oe] = h()), $[b].push(_);
            });
          });
        },
        get: function(k) {
          var n = this;
          return u.map(k, function(_) {
            return n.datums[_];
          });
        },
        search: function(k) {
          var n = this, _, A;
          return _ = m(this.queryTokenizer(k)), u.each(_, function(F) {
            var $, G, oe, be;
            if (A && A.length === 0 && !n.matchAnyQueryToken)
              return !1;
            for ($ = n.trie, G = F.split(""); $ && (oe = G.shift()); )
              $ = $[v][oe];
            if ($ && G.length === 0)
              be = $[b].slice(0), A = A ? o(A, be) : be;
            else if (!n.matchAnyQueryToken)
              return A = [], !1;
          }), A ? u.map(c(A), function(F) {
            return n.datums[F];
          }) : [];
        },
        all: function() {
          var k = [];
          for (var n in this.datums)
            k.push(this.datums[n]);
          return k;
        },
        reset: function() {
          this.datums = {}, this.trie = h();
        },
        serialize: function() {
          return {
            datums: this.datums,
            trie: this.trie
          };
        }
      }), f;
      function m(p) {
        return p = u.filter(p, function(k) {
          return !!k;
        }), p = u.map(p, function(k) {
          return k.toLowerCase();
        }), p;
      }
      function h() {
        var p = {};
        return p[b] = [], p[v] = {}, p;
      }
      function c(p) {
        for (var k = {}, n = [], _ = 0, A = p.length; _ < A; _++)
          k[p[_]] || (k[p[_]] = !0, n.push(p[_]));
        return n;
      }
      function o(p, k) {
        var n = 0, _ = 0, A = [];
        p = p.sort(), k = k.sort();
        for (var F = p.length, $ = k.length; n < F && _ < $; )
          p[n] < k[_] ? n++ : (p[n] > k[_] || (A.push(p[n]), n++), _++);
        return A;
      }
    }(), ue = function() {
      var v;
      v = {
        data: "data",
        protocol: "protocol",
        thumbprint: "thumbprint"
      };
      function b(f) {
        this.url = f.url, this.ttl = f.ttl, this.cache = f.cache, this.prepare = f.prepare, this.transform = f.transform, this.transport = f.transport, this.thumbprint = f.thumbprint, this.storage = new M(f.cacheKey);
      }
      return u.mixin(b.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        store: function(m) {
          !this.cache || (this.storage.set(v.data, m, this.ttl), this.storage.set(v.protocol, location.protocol, this.ttl), this.storage.set(v.thumbprint, this.thumbprint, this.ttl));
        },
        fromCache: function() {
          var m = {}, h;
          return this.cache ? (m.data = this.storage.get(v.data), m.protocol = this.storage.get(v.protocol), m.thumbprint = this.storage.get(v.thumbprint), h = m.thumbprint !== this.thumbprint || m.protocol !== location.protocol, m.data && !h ? m.data : null) : null;
        },
        fromNetwork: function(f) {
          var m = this, h;
          if (!f)
            return;
          h = this.prepare(this._settings()), this.transport(h).fail(c).done(o);
          function c() {
            f(!0);
          }
          function o(p) {
            f(null, m.transform(p));
          }
        },
        clear: function() {
          return this.storage.clear(), this;
        }
      }), b;
    }(), tt = function() {
      function v(b) {
        this.url = b.url, this.prepare = b.prepare, this.transform = b.transform, this.indexResponse = b.indexResponse, this.transport = new R({
          cache: b.cache,
          limiter: b.limiter,
          transport: b.transport,
          maxPendingRequests: b.maxPendingRequests
        });
      }
      return u.mixin(v.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        get: function(f, m) {
          var h = this, c;
          if (!m)
            return;
          return f = f || "", c = this.prepare(f, this._settings()), this.transport.get(c, o);
          function o(p, k) {
            m(p ? [] : h.transform(k));
          }
        },
        cancelLastRequest: function() {
          this.transport.cancel();
        }
      }), v;
    }(), We = function() {
      return function(o) {
        var p, k;
        return p = {
          initialize: !0,
          identify: u.stringify,
          datumTokenizer: null,
          queryTokenizer: null,
          matchAnyQueryToken: !1,
          sufficient: 5,
          indexRemote: !1,
          sorter: null,
          local: [],
          prefetch: null,
          remote: null
        }, o = u.mixin(p, o || {}), !o.datumTokenizer && g.error("datumTokenizer is required"), !o.queryTokenizer && g.error("queryTokenizer is required"), k = o.sorter, o.sorter = k ? function(n) {
          return n.sort(k);
        } : u.identity, o.local = u.isFunction(o.local) ? o.local() : o.local, o.prefetch = v(o.prefetch), o.remote = b(o.remote), o;
      };
      function v(c) {
        var o;
        return c ? (o = {
          url: null,
          ttl: 24 * 60 * 60 * 1e3,
          cache: !0,
          cacheKey: null,
          thumbprint: "",
          prepare: u.identity,
          transform: u.identity,
          transport: null
        }, c = u.isString(c) ? {
          url: c
        } : c, c = u.mixin(o, c), !c.url && g.error("prefetch requires url to be set"), c.transform = c.filter || c.transform, c.cacheKey = c.cacheKey || c.url, c.thumbprint = K + c.thumbprint, c.transport = c.transport ? h(c.transport) : g.ajax, c) : null;
      }
      function b(c) {
        var o;
        if (!!c)
          return o = {
            url: null,
            cache: !0,
            prepare: null,
            replace: null,
            wildcard: null,
            limiter: null,
            rateLimitBy: "debounce",
            rateLimitWait: 300,
            transform: u.identity,
            transport: null
          }, c = u.isString(c) ? {
            url: c
          } : c, c = u.mixin(o, c), !c.url && g.error("remote requires url to be set"), c.transform = c.filter || c.transform, c.prepare = f(c), c.limiter = m(c), c.transport = c.transport ? h(c.transport) : g.ajax, delete c.replace, delete c.wildcard, delete c.rateLimitBy, delete c.rateLimitWait, c;
      }
      function f(c) {
        var o, p, k;
        if (o = c.prepare, p = c.replace, k = c.wildcard, o)
          return o;
        return p ? o = n : c.wildcard ? o = _ : o = A, o;
        function n(F, $) {
          return $.url = p($.url, F), $;
        }
        function _(F, $) {
          return $.url = $.url.replace(k, encodeURIComponent(F)), $;
        }
        function A(F, $) {
          return $;
        }
      }
      function m(c) {
        var o, p, k;
        return o = c.limiter, p = c.rateLimitBy, k = c.rateLimitWait, o || (o = /^throttle$/i.test(p) ? _(k) : n(k)), o;
        function n(A) {
          return function($) {
            return u.debounce($, A);
          };
        }
        function _(A) {
          return function($) {
            return u.throttle($, A);
          };
        }
      }
      function h(c) {
        return function(p) {
          var k = g.Deferred();
          return c(p, n, _), k;
          function n(A) {
            u.defer(function() {
              k.resolve(A);
            });
          }
          function _(A) {
            u.defer(function() {
              k.reject(A);
            });
          }
        };
      }
    }(), nt = function() {
      var v;
      v = window && window.Bloodhound;
      function b(f) {
        f = We(f), this.sorter = f.sorter, this.identify = f.identify, this.sufficient = f.sufficient, this.indexRemote = f.indexRemote, this.local = f.local, this.remote = f.remote ? new tt(f.remote) : null, this.prefetch = f.prefetch ? new ue(f.prefetch) : null, this.index = new re({
          identify: this.identify,
          datumTokenizer: f.datumTokenizer,
          queryTokenizer: f.queryTokenizer
        }), f.initialize !== !1 && this.initialize();
      }
      return b.noConflict = function() {
        return window && (window.Bloodhound = v), b;
      }, b.tokenizers = U, u.mixin(b.prototype, {
        __ttAdapter: function() {
          var m = this;
          return this.remote ? h : c;
          function h(o, p, k) {
            return m.search(o, p, k);
          }
          function c(o, p) {
            return m.search(o, p);
          }
        },
        _loadPrefetch: function() {
          var m = this, h, c;
          return h = g.Deferred(), this.prefetch ? (c = this.prefetch.fromCache()) ? (this.index.bootstrap(c), h.resolve()) : this.prefetch.fromNetwork(o) : h.resolve(), h.promise();
          function o(p, k) {
            if (p)
              return h.reject();
            m.add(k), m.prefetch.store(m.index.serialize()), h.resolve();
          }
        },
        _initialize: function() {
          var m = this;
          return this.clear(), (this.initPromise = this._loadPrefetch()).done(h), this.initPromise;
          function h() {
            m.add(m.local);
          }
        },
        initialize: function(m) {
          return !this.initPromise || m ? this._initialize() : this.initPromise;
        },
        add: function(m) {
          return this.index.add(m), this;
        },
        get: function(m) {
          return m = u.isArray(m) ? m : [].slice.call(arguments), this.index.get(m);
        },
        search: function(m, h, c) {
          var o = this, p;
          return h = h || u.noop, c = c || u.noop, p = this.sorter(this.index.search(m)), h(this.remote ? p.slice() : p), this.remote && p.length < this.sufficient ? this.remote.get(m, k) : this.remote && this.remote.cancelLastRequest(), this;
          function k(n) {
            var _ = [];
            u.each(n, function(A) {
              !u.some(p, function(F) {
                return o.identify(A) === o.identify(F);
              }) && _.push(A);
            }), o.indexRemote && o.add(_), c(_);
          }
        },
        all: function() {
          return this.index.all();
        },
        clear: function() {
          return this.index.reset(), this;
        },
        clearPrefetchCache: function() {
          return this.prefetch && this.prefetch.clear(), this;
        },
        clearRemoteCache: function() {
          return R.resetCache(), this;
        },
        ttAdapter: function() {
          return this.__ttAdapter();
        }
      }), b;
    }();
    return nt;
  });
})(Ei);
const _t = Ei.exports;
const vo = {
  name: "harness-vue-bootstrap-input",
  mixins: [Ue, et],
  components: { InputPartial: mo },
  props: {
    type: {
      required: !1,
      type: String,
      default: "text",
      validator: function(s) {
        return [
          "date",
          "datetime-local",
          "email",
          "month",
          "number",
          "password",
          "search",
          "tel",
          "text",
          "time",
          "url",
          "week"
        ].includes(s);
      }
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    },
    strict: {
      type: Boolean,
      required: !1,
      default: !0
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    }
  },
  data() {
    return {
      bloodhound: null,
      subscription: null,
      strictError: !1
    };
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        !this.strict || this.evaluateStrict ? (this.strictError = !1, this.setFilterLoadData(this.filter.key, s)) : this.strict && !this.evaluateStrict && (this.strictError = !0);
      }
    }
  },
  methods: {
    evaluateStrict(s) {
      return this.getOptionsForFilter(this.filter.key).map((g) => g.key).includes(s);
    },
    initTypeahead() {
      this.bloodhound = new _t({
        datumTokenizer: _t.tokenizers.ngram,
        queryTokenizer: _t.tokenizers.ngram,
        local: this.getOptionsForFilter(this.filter.key).map((g) => g.key)
      });
      const s = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((g, u) => (g[u] = `harness-vue-bootstrap-typeahead-${u}`, g), {});
      console.log(On(`#${this.filter.key}-${this.type}-input`)), On(`#${this.filter.key}-${this.type}-input`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: s
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (g, u) => {
        this.setFilter(this.filter.key, u);
      }).bind("typeahead:autocomplete", (g, u) => {
        this.setFilter(this.filter.key, u);
      });
    }
  },
  mounted() {
    this.typeahead && this.initTypeahead();
  },
  beforeUnmount() {
    this.typeahead && this.bloodhound.clear();
  }
}, bo = { class: "row form-row" }, ko = ["for", "id", "innerHTML"], wo = ["innerHTML"], Co = ["for", "id", "innerHTML"], To = ["innerHTML"], _o = ["innerHTML"];
function So(s, g, u, K, U, B) {
  const M = Ze("InputPartial");
  return N(), O("div", null, [
    s.labelPosition == "horizontal" ? (N(), O("div", {
      key: 0,
      class: Q(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      E("div", bo, [
        E("div", {
          class: Q(
            "col-" + s.labelColumnSize + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label-wrapper" : "")
          )
        }, [
          E("label", {
            for: s.filter.key,
            class: Q(
              "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, ko)
        ], 2),
        E("div", {
          class: Q(
            "col-" + (12 - s.labelColumnSize) + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-input-wrapper" : "")
          )
        }, [
          xe(M, Re(Ve({ ...s.$props, ...s.$attrs, strictError: U.strictError })), null, 16),
          s.helperText ? (N(), O("small", {
            key: 0,
            innerHTML: s.helperText,
            class: Q(
              "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
            )
          }, null, 10, wo)) : Y("", !0)
        ], 2)
      ])
    ], 2)) : Y("", !0),
    s.labelPosition == "vertical" ? (N(), O("div", {
      key: 1,
      class: Q(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      E("label", {
        for: s.filter.key,
        class: Q(
          "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, Co),
      xe(M, Re(Ve({ ...s.$props, ...s.$attrs, strictError: U.strictError })), null, 16),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
        )
      }, null, 10, To)) : Y("", !0)
    ], 2)) : Y("", !0),
    s.labelPosition == "none" ? (N(), O("div", {
      key: 2,
      class: Q(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      xe(M, Re(Ve({ ...s.$props, ...s.$attrs, strictError: U.strictError })), null, 16),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
        )
      }, null, 10, _o)) : Y("", !0)
    ], 2)) : Y("", !0)
  ]);
}
const xo = /* @__PURE__ */ _e(vo, [["render", So]]), Do = {
  name: "SelectPartial",
  mixins: [Ue, et],
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Ao = ["multiple", "id", "aria-labelledby"], Lo = ["value", "disabled", "hidden", "title", "innerHTML"];
function qo(s, g, u, K, U, B) {
  return $e((N(), O("select", {
    multiple: u.multiple,
    class: Q(
      "form-control harness-vue-bootstrap-select " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-select" : "")
    ),
    "onUpdate:modelValue": g[0] || (g[0] = (M) => s.boundValue = M),
    id: s.filter.key + "-select",
    "aria-labelledby": s.filter.key + "-label"
  }, [
    (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (M) => (N(), O("option", {
      key: M.key,
      value: M.key,
      disabled: M.disabled,
      hidden: M.hidden,
      title: M.label,
      innerHTML: M.label
    }, null, 8, Lo))), 128))
  ], 10, Ao)), [
    [rn, s.boundValue]
  ]);
}
const Eo = /* @__PURE__ */ _e(Do, [["render", qo]]), No = {
  name: "harness-vue-bootstrap-select",
  mixins: [Ue, et],
  components: { SelectPartial: Eo },
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Po = { class: "row form-row" }, Oo = ["for", "id", "innerHTML"], Ho = ["innerHTML"], Fo = ["for", "id", "innerHTML"], Ro = ["innerHTML"], Io = ["innerHTML"];
function Mo(s, g, u, K, U, B) {
  const M = Ze("SelectPartial");
  return N(), O("div", null, [
    s.labelPosition == "horizontal" ? (N(), O("div", {
      key: 0,
      class: Q(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      E("div", Po, [
        E("div", {
          class: Q("col-" + s.labelColumnSize)
        }, [
          E("label", {
            for: s.filter.key,
            class: Q(
              "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, Oo)
        ], 2),
        E("div", {
          class: Q("col-" + (12 - s.labelColumnSize))
        }, [
          xe(M, Re(Ve({ ...s.$props, ...s.$attrs })), null, 16),
          s.helperText ? (N(), O("small", {
            key: 0,
            innerHTML: s.helperText,
            class: Q(
              "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
            )
          }, null, 10, Ho)) : Y("", !0)
        ], 2)
      ])
    ], 2)) : Y("", !0),
    s.labelPosition == "vertical" ? (N(), O("div", {
      key: 1,
      class: Q(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      E("label", {
        for: s.filter.key,
        class: Q(
          "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, Fo),
      xe(M, Re(Ve({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
        )
      }, null, 10, Ro)) : Y("", !0)
    ], 2)) : Y("", !0),
    s.labelPosition == "none" ? (N(), O("div", {
      key: 2,
      class: Q(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      xe(M, Re(Ve({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
        )
      }, null, 10, Io)) : Y("", !0)
    ], 2)) : Y("", !0)
  ]);
}
const Bo = /* @__PURE__ */ _e(No, [["render", Mo]]), jo = {
  name: "CheckboxPartial",
  mixins: [Ue, et],
  props: {
    option: {
      type: Object,
      required: !0
    }
  }
}, zo = ["name", "id", "value", "disabled", "aria-labelledby"];
function $o(s, g, u, K, U, B) {
  return $e((N(), O("input", {
    class: "form-check-input harness-vue-bootstrap-radiogroup-input",
    type: "radio",
    name: s.filter.key,
    id: s.filter.key + u.option.key,
    value: u.option.key,
    disabled: u.option.disabled,
    "onUpdate:modelValue": g[0] || (g[0] = (M) => s.boundValue = M),
    "aria-labelledby": s.filter.key + u.option.key + "-label"
  }, null, 8, zo)), [
    [Mr, s.boundValue]
  ]);
}
const Vo = /* @__PURE__ */ _e(jo, [["render", $o]]), Wo = {
  name: "harness-vue-bootstrap-radiogroup",
  components: { RadioGroupPartial: Vo },
  mixins: [Ue, et],
  props: {
    inline: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Qo = { key: 0 }, Ko = ["for", "innerHTML"], Uo = ["id", "for", "disabled", "innerHTML"], Go = ["innerHTML"], Xo = { key: 1 }, Jo = { class: "row form-row" }, Yo = ["for", "innerHTML"], Zo = ["id", "for", "disabled", "innerHTML"], el = ["innerHTML"];
function tl(s, g, u, K, U, B) {
  const M = Ze("RadioGroupPartial");
  return N(), O("div", null, [
    s.labelPosition === "vertical" ? (N(), O("fieldset", Qo, [
      E("legend", {
        class: "col-form-label harness-vue-bootstrap-radiogroup-legend",
        for: s.filter.key,
        innerHTML: s.filter.label
      }, null, 8, Ko),
      (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (R, re) => (N(), O("div", {
        class: Q("form-check" + (u.inline ? " form-check-inline" : "")),
        key: re
      }, [
        xe(M, Re(Ve({ ...s.$props, ...s.$attrs, option: R })), null, 16),
        E("label", {
          class: "form-check-label harness-vue-bootstrap-radiogroup-label",
          id: s.filter.key + R.key + "-label",
          for: s.filter.key + R.key,
          disabled: R.disabled,
          innerHTML: R.label
        }, null, 8, Uo)
      ], 2))), 128)),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-radiogroup-helper-text " + s.helperTextClass
        )
      }, null, 10, Go)) : Y("", !0)
    ])) : Y("", !0),
    s.labelPosition === "horizontal" ? (N(), O("fieldset", Xo, [
      E("div", Jo, [
        E("div", {
          class: Q("col-" + s.labelColumnSize)
        }, [
          E("legend", {
            class: "col-form-label harness-vue-bootstrap-radiogroup-legend",
            for: s.filter.key,
            innerHTML: s.filter.label
          }, null, 8, Yo)
        ], 2),
        E("div", {
          class: Q("col-" + (12 - s.labelColumnSize))
        }, [
          (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (R, re) => (N(), O("div", {
            class: Q("form-check" + (u.inline ? " form-check-inline" : "")),
            key: re
          }, [
            xe(M, Re(Ve({ ...s.$props, ...s.$attrs, option: R })), null, 16),
            E("label", {
              class: "form-check-label harness-vue-bootstrap-radiogroup-label",
              id: s.filter.key + R.key + "-label",
              for: s.filter.key + R.key,
              disabled: R.disabled,
              innerHTML: R.label
            }, null, 8, Zo)
          ], 2))), 128)),
          s.helperText ? (N(), O("small", {
            key: 0,
            innerHTML: s.helperText,
            class: Q(
              "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-radiogroup-helper-text " + s.helperTextClass
            )
          }, null, 10, el)) : Y("", !0)
        ], 2)
      ])
    ])) : Y("", !0)
  ]);
}
const nl = /* @__PURE__ */ _e(Wo, [["render", tl]]), il = {
  name: "CheckboxPartial",
  mixins: [Ue, et],
  props: {
    inline: {
      type: Boolean,
      required: !0
    },
    collapse: {
      type: Boolean,
      required: !0
    },
    collapsed: {
      type: Boolean,
      required: !0
    },
    option: {
      type: Object,
      required: !0
    }
  }
}, rl = ["name", "id", "value", "aria-labelledby"];
function sl(s, g, u, K, U, B) {
  return $e((N(), O("input", {
    class: "form-check-input harness-vue-bootstrap-checkboxgroup-input",
    type: "checkbox",
    name: s.filter.key + u.option.key,
    id: s.filter.key + u.option.key,
    value: u.option.key,
    "onUpdate:modelValue": g[0] || (g[0] = (M) => s.boundValue = M),
    "aria-labelledby": s.filter.key + u.option.key + "-label"
  }, null, 8, rl)), [
    [Br, s.boundValue]
  ]);
}
const al = /* @__PURE__ */ _e(il, [["render", sl]]);
const ol = {
  name: "harness-vue-bootstrap-checkboxgroup",
  mixins: [Ue, et],
  components: { CheckboxPartial: al },
  data: () => ({ collapsed: !0 }),
  props: {
    inline: {
      type: Boolean,
      docstring: "asdasdasd",
      required: !1,
      default: !1
    },
    collapse: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, ll = { key: 0 }, ul = ["for", "data-toggle", "href", "role"], cl = ["innerHTML"], fl = ["data-toggle", "href", "role"], hl = {
  key: 0,
  class: "bi-chevron-down"
}, dl = {
  key: 1,
  class: "bi-chevron-up"
}, pl = ["href"], gl = { key: 0 }, yl = { key: 1 }, ml = ["id"], vl = ["id", "for", "innerHTML"], bl = ["innerHTML"], kl = { key: 1 }, wl = { class: "row form-row" }, Cl = ["data-toggle", "href", "role", "for"], Tl = ["innerHTML"], _l = ["data-toggle", "href", "role"], Sl = {
  key: 0,
  class: "bi-chevron-down"
}, xl = {
  key: 1,
  class: "bi-chevron-up"
}, Dl = ["href"], Al = { key: 0 }, Ll = { key: 1 }, ql = ["id"], El = ["id", "for", "innerHTML"], Nl = ["innerHTML"], Pl = { key: 2 }, Ol = ["id", "for", "innerHTML"], Hl = ["innerHTML"];
function Fl(s, g, u, K, U, B) {
  const M = Ze("CheckboxPartial");
  return N(), O("div", null, [
    s.labelPosition === "vertical" ? (N(), O("fieldset", ll, [
      E("legend", {
        class: "col-form-label harness-vue-bootstrap-checkboxgroup-legend",
        for: s.filter.key,
        "data-toggle": u.collapse ? "collapse" : "",
        href: u.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
        role: u.collapse ? "button" : "",
        onClick: g[1] || (g[1] = (R) => s.collapsed = !s.collapsed)
      }, [
        E("span", {
          innerHTML: s.filter.label
        }, null, 8, cl),
        u.collapse ? (N(), O("button", {
          key: 0,
          class: "harness-vue-bootstrap-collapse-toggle-button",
          "data-toggle": u.collapse ? "collapse" : "",
          href: u.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
          role: u.collapse ? "button" : "",
          onClick: g[0] || (g[0] = (R) => s.collapsed = !s.collapsed),
          "aria-expanded": "false",
          "aria-label": "Collapse Toggle"
        }, [
          u.collapse && s.collapsed ? (N(), O("i", hl)) : Y("", !0),
          u.collapse && !s.collapsed ? (N(), O("i", dl)) : Y("", !0)
        ], 8, fl)) : Y("", !0)
      ], 8, ul),
      u.collapse ? (N(), O("div", {
        key: 0,
        "data-toggle": "collapse",
        href: u.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
        role: "button",
        class: "harness-vue-bootstrap-checkboxgroup-collapse-label",
        onClick: g[2] || (g[2] = (R) => s.collapsed = !s.collapsed)
      }, [
        u.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (N(), O("span", gl, " (All Selected) ")) : u.collapse ? (N(), O("span", yl, " (" + Te(s.getFilter(s.filter.key).length) + " of " + Te(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : Y("", !0)
      ], 8, pl)) : Y("", !0),
      E("div", {
        class: Q(u.collapse ? "collapse" : ""),
        id: u.collapse ? "harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : ""
      }, [
        (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (R, re) => (N(), O("div", {
          class: Q("form-check" + (u.inline ? " form-check-inline" : "")),
          key: re
        }, [
          xe(M, Re(Ve({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: R })), null, 16),
          E("label", {
            class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
            id: s.filter.key + R.key + "-label",
            for: s.filter.key + R.key,
            innerHTML: R.label
          }, null, 8, vl)
        ], 2))), 128)),
        s.helperText ? (N(), O("small", {
          key: 0,
          innerHTML: s.helperText,
          class: Q(
            "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
          )
        }, null, 10, bl)) : Y("", !0)
      ], 10, ml)
    ])) : Y("", !0),
    s.labelPosition === "horizontal" ? (N(), O("fieldset", kl, [
      E("div", wl, [
        E("div", {
          class: Q("col-" + s.labelColumnSize)
        }, [
          E("legend", {
            class: "col-form-label harness-vue-bootstrap-checkboxgroup-legend",
            "data-toggle": u.collapse ? "collapse" : "",
            href: u.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
            role: u.collapse ? "button" : "",
            for: s.filter.key,
            onClick: g[4] || (g[4] = (R) => s.collapsed = !s.collapsed)
          }, [
            E("span", {
              innerHTML: s.filter.label
            }, null, 8, Tl),
            u.collapse ? (N(), O("button", {
              key: 0,
              class: "harness-vue-bootstrap-collapse-toggle-button",
              "data-toggle": u.collapse ? "collapse" : "",
              href: u.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
              role: u.collapse ? "button" : "",
              onClick: g[3] || (g[3] = (R) => s.collapsed = !s.collapsed),
              "aria-expanded": "false",
              "aria-label": "Collapse Toggle"
            }, [
              u.collapse && s.collapsed ? (N(), O("i", Sl)) : Y("", !0),
              u.collapse && !s.collapsed ? (N(), O("i", xl)) : Y("", !0)
            ], 8, _l)) : Y("", !0)
          ], 8, Cl)
        ], 2),
        E("div", {
          class: Q("col-" + (12 - s.labelColumnSize))
        }, [
          u.collapse ? (N(), O("div", {
            key: 0,
            class: "col-form-label harness-vue-bootstrap-checkboxgroup-collapse-label",
            "data-toggle": "collapse",
            href: "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key,
            role: "button",
            onClick: g[5] || (g[5] = (R) => s.collapsed = !s.collapsed)
          }, [
            u.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (N(), O("span", Al, " (All Selected) ")) : u.collapse ? (N(), O("span", Ll, " (" + Te(s.getFilter(s.filter.key).length) + " of " + Te(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : Y("", !0)
          ], 8, Dl)) : Y("", !0),
          E("div", {
            class: Q(u.collapse ? "collapse" : ""),
            id: u.collapse ? "harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : ""
          }, [
            (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (R, re) => (N(), O("div", {
              class: Q("form-check" + (u.inline ? " form-check-inline" : "")),
              key: re
            }, [
              xe(M, Re(Ve({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: R })), null, 16),
              E("label", {
                class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
                id: s.filter.key + R.key + "-label",
                for: s.filter.key + R.key,
                innerHTML: R.label
              }, null, 8, El)
            ], 2))), 128)),
            s.helperText ? (N(), O("small", {
              key: 0,
              innerHTML: s.helperText,
              class: Q(
                "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
              )
            }, null, 10, Nl)) : Y("", !0)
          ], 10, ql)
        ], 2)
      ])
    ])) : Y("", !0),
    s.labelPosition === "none" ? (N(), O("fieldset", Pl, [
      (N(!0), O(ge, null, ve(s.getOptionsForFilter(s.filter.key), (R, re) => (N(), O("div", {
        class: Q("form-check" + (u.inline ? " form-check-inline" : "")),
        key: re
      }, [
        xe(M, Re(Ve({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: R })), null, 16),
        E("label", {
          class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
          id: s.filter.key + R.key + "-label",
          for: s.filter.key + R.key,
          innerHTML: R.label
        }, null, 8, Ol)
      ], 2))), 128)),
      s.helperText ? (N(), O("small", {
        key: 0,
        innerHTML: s.helperText,
        class: Q(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
        )
      }, null, 10, Hl)) : Y("", !0)
    ])) : Y("", !0)
  ]);
}
const Rl = /* @__PURE__ */ _e(ol, [["render", Fl]]);
const Il = {
  name: "HarnessVueBootstrapMultiselectListbox",
  mixins: [Ue, et],
  props: {
    searchable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  data() {
    return {
      bloodhound: null,
      leftBox: [],
      rightBox: [],
      search: "",
      searchDisabled: !1
    };
  },
  computed: {
    leftBoxOptions() {
      return this.unselectedOptions.filter(
        (s) => this.search === "" || s.label.toLowerCase().includes(this.search.toLowerCase())
      );
    },
    rightBoxOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => this.getFilter(this.filter.key).includes(s.key)
      );
    },
    unselectedOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => !this.getFilter(this.filter.key).includes(s.key)
      );
    }
  },
  methods: {
    leftToRight() {
      const s = this.getFilter(this.filter.key).concat(this.leftBox);
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    rightToLeft() {
      const s = this.getFilter(this.filter.key).filter(
        (g) => !this.rightBox.includes(g)
      );
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    lifecycleBloodhound() {
      this.bloodhound && (this.bloodhound.clear(), this.unselectedOptions.length ? (this.searchDisabled = !1, this.bloodhound.add(this.unselectedOptions.map((s) => s.label))) : this.searchDisabled = !0);
    },
    initTypeahead() {
      this.bloodhound = new _t({
        datumTokenizer: _t.tokenizers.ngram,
        queryTokenizer: _t.tokenizers.ngram,
        local: this.leftBoxOptions.map((g) => g.label)
      });
      const s = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((g, u) => (g[u] = `harness-vue-bootstrap-multiselect-listbox-typeahead-${u}`, g), {});
      On(`#harness-vue-bootstrap-multiselect-listbox-search-${this.filter.key}`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: s
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (g, u) => {
        this.search = u;
      }).bind("typeahead:autocomplete", (g, u) => {
        this.search = u;
      });
    }
  },
  mounted() {
    this.searchable && this.typeahead && this.initTypeahead();
  }
}, Ml = { class: "harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-top-label" }, Bl = {
  key: 0,
  class: "row"
}, jl = { class: "col" }, zl = ["id", "disabled"], $l = { class: "row align-items-center" }, Vl = { class: "col-5" }, Wl = /* @__PURE__ */ E("label", { class: "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-select-label harness-vue-bootstrap-select-label-vertical" }, "Options", -1), Ql = ["value", "title"], Kl = { class: "col-2" }, Ul = { class: "text-center" }, Gl = /* @__PURE__ */ E("i", { class: "bi bi-caret-left-fill" }, null, -1), Xl = [
  Gl
], Jl = /* @__PURE__ */ E("i", { class: "bi bi-caret-right-fill" }, null, -1), Yl = [
  Jl
], Zl = { class: "col-5" }, eu = /* @__PURE__ */ E("label", { class: "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-select-label harness-vue-bootstrap-select-label-vertical" }, "Selected", -1), tu = ["value", "title"];
function nu(s, g, u, K, U, B) {
  return N(), O("div", null, [
    E("label", Ml, Te(this.filter.label), 1),
    u.searchable ? (N(), O("div", Bl, [
      E("div", jl, [
        $e(E("input", {
          type: "text",
          id: `harness-vue-bootstrap-multiselect-listbox-search-${s.filter.key}`,
          class: "form-control harness-vue-bootstrap-input harness-vue-bootstrap-multiselect-listbox-search-input",
          disabled: U.searchDisabled,
          "onUpdate:modelValue": g[0] || (g[0] = (M) => U.search = M)
        }, null, 8, zl), [
          [Ai, U.search]
        ])
      ])
    ])) : Y("", !0),
    E("div", $l, [
      E("div", Vl, [
        Wl,
        $e(E("select", {
          class: "form-control harness-vue-bootstrap-select harness-vue-bootstrap-multiselect-listbox-select harness-vue-bootstrap-multiselect-listbox-select-left",
          multiple: "true",
          "onUpdate:modelValue": g[1] || (g[1] = (M) => U.leftBox = M)
        }, [
          (N(!0), O(ge, null, ve(B.leftBoxOptions, (M) => (N(), O("option", {
            key: M.key,
            value: M.key,
            title: M.label
          }, Te(M.label), 9, Ql))), 128))
        ], 512), [
          [rn, U.leftBox]
        ])
      ]),
      E("div", Kl, [
        E("div", Ul, [
          E("button", {
            class: "btn btn-xs",
            onClick: g[2] || (g[2] = (...M) => B.rightToLeft && B.rightToLeft(...M))
          }, Xl),
          E("button", {
            class: "btn btn-xs",
            onClick: g[3] || (g[3] = (...M) => B.leftToRight && B.leftToRight(...M))
          }, Yl)
        ])
      ]),
      E("div", Zl, [
        eu,
        $e(E("select", {
          class: "form-control harness-vue-bootstrap-select harness-vue-bootstrap-multiselect-listbox-select harness-vue-bootstrap-multiselect-listbox-select-right",
          multiple: "true",
          "onUpdate:modelValue": g[4] || (g[4] = (M) => U.rightBox = M)
        }, [
          (N(!0), O(ge, null, ve(B.rightBoxOptions, (M) => (N(), O("option", {
            key: M.key,
            value: M.key,
            title: M.label
          }, Te(M.label), 9, tu))), 128))
        ], 512), [
          [rn, U.rightBox]
        ])
      ])
    ])
  ]);
}
const iu = /* @__PURE__ */ _e(Il, [["render", nu]]), Si = {
  FilterGrid: Kr,
  ChartGrid: Xr,
  GridWithFilters: ss,
  DataTable508: hs,
  ChartWithTable: $s,
  InteractiveTable: Ca,
  FilterPicker: Ia,
  FilterAccordion: so,
  HarnessVueBootstrapInput: xo,
  HarnessVueBootstrapSelect: Bo,
  HarnessVueBootstrapRadioGroup: nl,
  HarnessVueBootstrapCheckboxGroup: Rl,
  HarnessVueBootstrapMultiselectListbox: iu
};
var ru = { exports: {} };
/*!
 * typeahead.js 1.3.1
 * https://github.com/corejavascript/typeahead.js
 * Copyright 2013-2020 Twitter, Inc. and other contributors; Licensed MIT
 */
(function(s) {
  (function(g, u) {
    s.exports ? s.exports = u(an()) : g.Bloodhound = u(g.jQuery);
  })(sn, function(g) {
    var u = function() {
      return {
        isMsie: function() {
          return /(msie|trident)/i.test(navigator.userAgent) ? navigator.userAgent.match(/(msie |rv:)(\d+(.\d+)?)/i)[2] : !1;
        },
        isBlankString: function(v) {
          return !v || /^\s*$/.test(v);
        },
        escapeRegExChars: function(v) {
          return v.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        },
        isString: function(v) {
          return typeof v == "string";
        },
        isNumber: function(v) {
          return typeof v == "number";
        },
        isArray: g.isArray,
        isFunction: g.isFunction,
        isObject: g.isPlainObject,
        isUndefined: function(v) {
          return typeof v > "u";
        },
        isElement: function(v) {
          return !!(v && v.nodeType === 1);
        },
        isJQuery: function(v) {
          return v instanceof g;
        },
        toStr: function(b) {
          return u.isUndefined(b) || b === null ? "" : b + "";
        },
        bind: g.proxy,
        each: function(v, b) {
          g.each(v, f);
          function f(m, h) {
            return b(h, m);
          }
        },
        map: g.map,
        filter: g.grep,
        every: function(v, b) {
          var f = !0;
          return v ? (g.each(v, function(m, h) {
            if (!(f = b.call(null, h, m, v)))
              return !1;
          }), !!f) : f;
        },
        some: function(v, b) {
          var f = !1;
          return v ? (g.each(v, function(m, h) {
            if (f = b.call(null, h, m, v))
              return !1;
          }), !!f) : f;
        },
        mixin: g.extend,
        identity: function(v) {
          return v;
        },
        clone: function(v) {
          return g.extend(!0, {}, v);
        },
        getIdGenerator: function() {
          var v = 0;
          return function() {
            return v++;
          };
        },
        templatify: function(b) {
          return g.isFunction(b) ? b : f;
          function f() {
            return String(b);
          }
        },
        defer: function(v) {
          setTimeout(v, 0);
        },
        debounce: function(v, b, f) {
          var m, h;
          return function() {
            var c = this, o = arguments, p, k;
            return p = function() {
              m = null, f || (h = v.apply(c, o));
            }, k = f && !m, clearTimeout(m), m = setTimeout(p, b), k && (h = v.apply(c, o)), h;
          };
        },
        throttle: function(v, b) {
          var f, m, h, c, o, p;
          return o = 0, p = function() {
            o = new Date(), h = null, c = v.apply(f, m);
          }, function() {
            var k = new Date(), n = b - (k - o);
            return f = this, m = arguments, n <= 0 ? (clearTimeout(h), h = null, o = k, c = v.apply(f, m)) : h || (h = setTimeout(p, n)), c;
          };
        },
        stringify: function(v) {
          return u.isString(v) ? v : JSON.stringify(v);
        },
        guid: function() {
          function v(b) {
            var f = (Math.random().toString(16) + "000000000").substr(2, 8);
            return b ? "-" + f.substr(0, 4) + "-" + f.substr(4, 4) : f;
          }
          return "tt-" + v() + v(!0) + v(!0) + v();
        },
        noop: function() {
        }
      };
    }(), K = "1.3.1", U = function() {
      return {
        nonword: b,
        whitespace: v,
        ngram: f,
        obj: {
          nonword: m(b),
          whitespace: m(v),
          ngram: m(f)
        }
      };
      function v(h) {
        return h = u.toStr(h), h ? h.split(/\s+/) : [];
      }
      function b(h) {
        return h = u.toStr(h), h ? h.split(/\W+/) : [];
      }
      function f(h) {
        h = u.toStr(h);
        var c = [], o = "";
        return u.each(h.split(""), function(p) {
          p.match(/\s+/) ? o = "" : (c.push(o + p), o += p);
        }), c;
      }
      function m(h) {
        return function(o) {
          return o = u.isArray(o) ? o : [].slice.call(arguments, 0), function(k) {
            var n = [];
            return u.each(o, function(_) {
              n = n.concat(h(u.toStr(k[_])));
            }), n;
          };
        };
      }
    }(), B = function() {
      function v(m) {
        this.maxSize = u.isNumber(m) ? m : 100, this.reset(), this.maxSize <= 0 && (this.set = this.get = g.noop);
      }
      u.mixin(v.prototype, {
        set: function(h, c) {
          var o = this.list.tail, p;
          this.size >= this.maxSize && (this.list.remove(o), delete this.hash[o.key], this.size--), (p = this.hash[h]) ? (p.val = c, this.list.moveToFront(p)) : (p = new f(h, c), this.list.add(p), this.hash[h] = p, this.size++);
        },
        get: function(h) {
          var c = this.hash[h];
          if (c)
            return this.list.moveToFront(c), c.val;
        },
        reset: function() {
          this.size = 0, this.hash = {}, this.list = new b();
        }
      });
      function b() {
        this.head = this.tail = null;
      }
      u.mixin(b.prototype, {
        add: function(h) {
          this.head && (h.next = this.head, this.head.prev = h), this.head = h, this.tail = this.tail || h;
        },
        remove: function(h) {
          h.prev ? h.prev.next = h.next : this.head = h.next, h.next ? h.next.prev = h.prev : this.tail = h.prev;
        },
        moveToFront: function(m) {
          this.remove(m), this.add(m);
        }
      });
      function f(m, h) {
        this.key = m, this.val = h, this.prev = this.next = null;
      }
      return v;
    }(), M = function() {
      var v;
      try {
        v = window.localStorage, v.setItem("~~~", "!"), v.removeItem("~~~");
      } catch {
        v = null;
      }
      function b(o, p) {
        this.prefix = ["__", o, "__"].join(""), this.ttlKey = "__ttl__", this.keyMatcher = new RegExp("^" + u.escapeRegExChars(this.prefix)), this.ls = p || v, !this.ls && this._noop();
      }
      return u.mixin(b.prototype, {
        _prefix: function(o) {
          return this.prefix + o;
        },
        _ttlKey: function(o) {
          return this._prefix(o) + this.ttlKey;
        },
        _noop: function() {
          this.get = this.set = this.remove = this.clear = this.isExpired = u.noop;
        },
        _safeSet: function(o, p) {
          try {
            this.ls.setItem(o, p);
          } catch (k) {
            k.name === "QuotaExceededError" && (this.clear(), this._noop());
          }
        },
        get: function(o) {
          return this.isExpired(o) && this.remove(o), h(this.ls.getItem(this._prefix(o)));
        },
        set: function(o, p, k) {
          return u.isNumber(k) ? this._safeSet(this._ttlKey(o), m(f() + k)) : this.ls.removeItem(this._ttlKey(o)), this._safeSet(this._prefix(o), m(p));
        },
        remove: function(o) {
          return this.ls.removeItem(this._ttlKey(o)), this.ls.removeItem(this._prefix(o)), this;
        },
        clear: function() {
          var o, p = c(this.keyMatcher);
          for (o = p.length; o--; )
            this.remove(p[o]);
          return this;
        },
        isExpired: function(o) {
          var p = h(this.ls.getItem(this._ttlKey(o)));
          return !!(u.isNumber(p) && f() > p);
        }
      }), b;
      function f() {
        return new Date().getTime();
      }
      function m(o) {
        return JSON.stringify(u.isUndefined(o) ? null : o);
      }
      function h(o) {
        return g.parseJSON(o);
      }
      function c(o) {
        var p, k, n = [], _ = v.length;
        for (p = 0; p < _; p++)
          (k = v.key(p)).match(o) && n.push(k.replace(o, ""));
        return n;
      }
    }(), R = function() {
      var v = 0, b = {}, f = new B(10);
      function m(h) {
        h = h || {}, this.maxPendingRequests = h.maxPendingRequests || 6, this.cancelled = !1, this.lastReq = null, this._send = h.transport, this._get = h.limiter ? h.limiter(this._get) : this._get, this._cache = h.cache === !1 ? new B(0) : f;
      }
      return m.setMaxPendingRequests = function(c) {
        this.maxPendingRequests = c;
      }, m.resetCache = function() {
        f.reset();
      }, u.mixin(m.prototype, {
        _fingerprint: function(c) {
          return c = c || {}, c.url + c.type + g.param(c.data || {});
        },
        _get: function(h, c) {
          var o = this, p, k;
          if (p = this._fingerprint(h), this.cancelled || p !== this.lastReq)
            return;
          (k = b[p]) ? k.done(n).fail(_) : v < this.maxPendingRequests ? (v++, b[p] = this._send(h).done(n).fail(_).always(A)) : this.onDeckRequestArgs = [].slice.call(arguments, 0);
          function n(F) {
            c(null, F), o._cache.set(p, F);
          }
          function _() {
            c(!0);
          }
          function A() {
            v--, delete b[p], o.onDeckRequestArgs && (o._get.apply(o, o.onDeckRequestArgs), o.onDeckRequestArgs = null);
          }
        },
        get: function(h, c) {
          var o, p;
          c = c || g.noop, h = u.isString(h) ? {
            url: h
          } : h || {}, p = this._fingerprint(h), this.cancelled = !1, this.lastReq = p, (o = this._cache.get(p)) ? c(null, o) : this._get(h, c);
        },
        cancel: function() {
          this.cancelled = !0;
        }
      }), m;
    }(), re = window.SearchIndex = function() {
      var v = "c", b = "i";
      function f(p) {
        p = p || {}, (!p.datumTokenizer || !p.queryTokenizer) && g.error("datumTokenizer and queryTokenizer are both required"), this.identify = p.identify || u.stringify, this.datumTokenizer = p.datumTokenizer, this.queryTokenizer = p.queryTokenizer, this.matchAnyQueryToken = p.matchAnyQueryToken, this.reset();
      }
      return u.mixin(f.prototype, {
        bootstrap: function(k) {
          this.datums = k.datums, this.trie = k.trie;
        },
        add: function(p) {
          var k = this;
          p = u.isArray(p) ? p : [p], u.each(p, function(n) {
            var _, A;
            k.datums[_ = k.identify(n)] = n, A = m(k.datumTokenizer(n)), u.each(A, function(F) {
              var $, G, oe;
              for ($ = k.trie, G = F.split(""); oe = G.shift(); )
                $ = $[v][oe] || ($[v][oe] = h()), $[b].push(_);
            });
          });
        },
        get: function(k) {
          var n = this;
          return u.map(k, function(_) {
            return n.datums[_];
          });
        },
        search: function(k) {
          var n = this, _, A;
          return _ = m(this.queryTokenizer(k)), u.each(_, function(F) {
            var $, G, oe, be;
            if (A && A.length === 0 && !n.matchAnyQueryToken)
              return !1;
            for ($ = n.trie, G = F.split(""); $ && (oe = G.shift()); )
              $ = $[v][oe];
            if ($ && G.length === 0)
              be = $[b].slice(0), A = A ? o(A, be) : be;
            else if (!n.matchAnyQueryToken)
              return A = [], !1;
          }), A ? u.map(c(A), function(F) {
            return n.datums[F];
          }) : [];
        },
        all: function() {
          var k = [];
          for (var n in this.datums)
            k.push(this.datums[n]);
          return k;
        },
        reset: function() {
          this.datums = {}, this.trie = h();
        },
        serialize: function() {
          return {
            datums: this.datums,
            trie: this.trie
          };
        }
      }), f;
      function m(p) {
        return p = u.filter(p, function(k) {
          return !!k;
        }), p = u.map(p, function(k) {
          return k.toLowerCase();
        }), p;
      }
      function h() {
        var p = {};
        return p[b] = [], p[v] = {}, p;
      }
      function c(p) {
        for (var k = {}, n = [], _ = 0, A = p.length; _ < A; _++)
          k[p[_]] || (k[p[_]] = !0, n.push(p[_]));
        return n;
      }
      function o(p, k) {
        var n = 0, _ = 0, A = [];
        p = p.sort(), k = k.sort();
        for (var F = p.length, $ = k.length; n < F && _ < $; )
          p[n] < k[_] ? n++ : (p[n] > k[_] || (A.push(p[n]), n++), _++);
        return A;
      }
    }(), ue = function() {
      var v;
      v = {
        data: "data",
        protocol: "protocol",
        thumbprint: "thumbprint"
      };
      function b(f) {
        this.url = f.url, this.ttl = f.ttl, this.cache = f.cache, this.prepare = f.prepare, this.transform = f.transform, this.transport = f.transport, this.thumbprint = f.thumbprint, this.storage = new M(f.cacheKey);
      }
      return u.mixin(b.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        store: function(m) {
          !this.cache || (this.storage.set(v.data, m, this.ttl), this.storage.set(v.protocol, location.protocol, this.ttl), this.storage.set(v.thumbprint, this.thumbprint, this.ttl));
        },
        fromCache: function() {
          var m = {}, h;
          return this.cache ? (m.data = this.storage.get(v.data), m.protocol = this.storage.get(v.protocol), m.thumbprint = this.storage.get(v.thumbprint), h = m.thumbprint !== this.thumbprint || m.protocol !== location.protocol, m.data && !h ? m.data : null) : null;
        },
        fromNetwork: function(f) {
          var m = this, h;
          if (!f)
            return;
          h = this.prepare(this._settings()), this.transport(h).fail(c).done(o);
          function c() {
            f(!0);
          }
          function o(p) {
            f(null, m.transform(p));
          }
        },
        clear: function() {
          return this.storage.clear(), this;
        }
      }), b;
    }(), tt = function() {
      function v(b) {
        this.url = b.url, this.prepare = b.prepare, this.transform = b.transform, this.indexResponse = b.indexResponse, this.transport = new R({
          cache: b.cache,
          limiter: b.limiter,
          transport: b.transport,
          maxPendingRequests: b.maxPendingRequests
        });
      }
      return u.mixin(v.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        get: function(f, m) {
          var h = this, c;
          if (!m)
            return;
          return f = f || "", c = this.prepare(f, this._settings()), this.transport.get(c, o);
          function o(p, k) {
            m(p ? [] : h.transform(k));
          }
        },
        cancelLastRequest: function() {
          this.transport.cancel();
        }
      }), v;
    }(), We = function() {
      return function(o) {
        var p, k;
        return p = {
          initialize: !0,
          identify: u.stringify,
          datumTokenizer: null,
          queryTokenizer: null,
          matchAnyQueryToken: !1,
          sufficient: 5,
          indexRemote: !1,
          sorter: null,
          local: [],
          prefetch: null,
          remote: null
        }, o = u.mixin(p, o || {}), !o.datumTokenizer && g.error("datumTokenizer is required"), !o.queryTokenizer && g.error("queryTokenizer is required"), k = o.sorter, o.sorter = k ? function(n) {
          return n.sort(k);
        } : u.identity, o.local = u.isFunction(o.local) ? o.local() : o.local, o.prefetch = v(o.prefetch), o.remote = b(o.remote), o;
      };
      function v(c) {
        var o;
        return c ? (o = {
          url: null,
          ttl: 24 * 60 * 60 * 1e3,
          cache: !0,
          cacheKey: null,
          thumbprint: "",
          prepare: u.identity,
          transform: u.identity,
          transport: null
        }, c = u.isString(c) ? {
          url: c
        } : c, c = u.mixin(o, c), !c.url && g.error("prefetch requires url to be set"), c.transform = c.filter || c.transform, c.cacheKey = c.cacheKey || c.url, c.thumbprint = K + c.thumbprint, c.transport = c.transport ? h(c.transport) : g.ajax, c) : null;
      }
      function b(c) {
        var o;
        if (!!c)
          return o = {
            url: null,
            cache: !0,
            prepare: null,
            replace: null,
            wildcard: null,
            limiter: null,
            rateLimitBy: "debounce",
            rateLimitWait: 300,
            transform: u.identity,
            transport: null
          }, c = u.isString(c) ? {
            url: c
          } : c, c = u.mixin(o, c), !c.url && g.error("remote requires url to be set"), c.transform = c.filter || c.transform, c.prepare = f(c), c.limiter = m(c), c.transport = c.transport ? h(c.transport) : g.ajax, delete c.replace, delete c.wildcard, delete c.rateLimitBy, delete c.rateLimitWait, c;
      }
      function f(c) {
        var o, p, k;
        if (o = c.prepare, p = c.replace, k = c.wildcard, o)
          return o;
        return p ? o = n : c.wildcard ? o = _ : o = A, o;
        function n(F, $) {
          return $.url = p($.url, F), $;
        }
        function _(F, $) {
          return $.url = $.url.replace(k, encodeURIComponent(F)), $;
        }
        function A(F, $) {
          return $;
        }
      }
      function m(c) {
        var o, p, k;
        return o = c.limiter, p = c.rateLimitBy, k = c.rateLimitWait, o || (o = /^throttle$/i.test(p) ? _(k) : n(k)), o;
        function n(A) {
          return function($) {
            return u.debounce($, A);
          };
        }
        function _(A) {
          return function($) {
            return u.throttle($, A);
          };
        }
      }
      function h(c) {
        return function(p) {
          var k = g.Deferred();
          return c(p, n, _), k;
          function n(A) {
            u.defer(function() {
              k.resolve(A);
            });
          }
          function _(A) {
            u.defer(function() {
              k.reject(A);
            });
          }
        };
      }
    }(), nt = function() {
      var v;
      v = window && window.Bloodhound;
      function b(f) {
        f = We(f), this.sorter = f.sorter, this.identify = f.identify, this.sufficient = f.sufficient, this.indexRemote = f.indexRemote, this.local = f.local, this.remote = f.remote ? new tt(f.remote) : null, this.prefetch = f.prefetch ? new ue(f.prefetch) : null, this.index = new re({
          identify: this.identify,
          datumTokenizer: f.datumTokenizer,
          queryTokenizer: f.queryTokenizer
        }), f.initialize !== !1 && this.initialize();
      }
      return b.noConflict = function() {
        return window && (window.Bloodhound = v), b;
      }, b.tokenizers = U, u.mixin(b.prototype, {
        __ttAdapter: function() {
          var m = this;
          return this.remote ? h : c;
          function h(o, p, k) {
            return m.search(o, p, k);
          }
          function c(o, p) {
            return m.search(o, p);
          }
        },
        _loadPrefetch: function() {
          var m = this, h, c;
          return h = g.Deferred(), this.prefetch ? (c = this.prefetch.fromCache()) ? (this.index.bootstrap(c), h.resolve()) : this.prefetch.fromNetwork(o) : h.resolve(), h.promise();
          function o(p, k) {
            if (p)
              return h.reject();
            m.add(k), m.prefetch.store(m.index.serialize()), h.resolve();
          }
        },
        _initialize: function() {
          var m = this;
          return this.clear(), (this.initPromise = this._loadPrefetch()).done(h), this.initPromise;
          function h() {
            m.add(m.local);
          }
        },
        initialize: function(m) {
          return !this.initPromise || m ? this._initialize() : this.initPromise;
        },
        add: function(m) {
          return this.index.add(m), this;
        },
        get: function(m) {
          return m = u.isArray(m) ? m : [].slice.call(arguments), this.index.get(m);
        },
        search: function(m, h, c) {
          var o = this, p;
          return h = h || u.noop, c = c || u.noop, p = this.sorter(this.index.search(m)), h(this.remote ? p.slice() : p), this.remote && p.length < this.sufficient ? this.remote.get(m, k) : this.remote && this.remote.cancelLastRequest(), this;
          function k(n) {
            var _ = [];
            u.each(n, function(A) {
              !u.some(p, function(F) {
                return o.identify(A) === o.identify(F);
              }) && _.push(A);
            }), o.indexRemote && o.add(_), c(_);
          }
        },
        all: function() {
          return this.index.all();
        },
        clear: function() {
          return this.index.reset(), this;
        },
        clearPrefetchCache: function() {
          return this.prefetch && this.prefetch.clear(), this;
        },
        clearRemoteCache: function() {
          return R.resetCache(), this;
        },
        ttAdapter: function() {
          return this.__ttAdapter();
        }
      }), b;
    }();
    return nt;
  }), function(g, u) {
    s.exports ? s.exports = u(an()) : u(g.jQuery);
  }(sn, function(g) {
    var u = function() {
      return {
        isMsie: function() {
          return /(msie|trident)/i.test(navigator.userAgent) ? navigator.userAgent.match(/(msie |rv:)(\d+(.\d+)?)/i)[2] : !1;
        },
        isBlankString: function(v) {
          return !v || /^\s*$/.test(v);
        },
        escapeRegExChars: function(v) {
          return v.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        },
        isString: function(v) {
          return typeof v == "string";
        },
        isNumber: function(v) {
          return typeof v == "number";
        },
        isArray: g.isArray,
        isFunction: g.isFunction,
        isObject: g.isPlainObject,
        isUndefined: function(v) {
          return typeof v > "u";
        },
        isElement: function(v) {
          return !!(v && v.nodeType === 1);
        },
        isJQuery: function(v) {
          return v instanceof g;
        },
        toStr: function(b) {
          return u.isUndefined(b) || b === null ? "" : b + "";
        },
        bind: g.proxy,
        each: function(v, b) {
          g.each(v, f);
          function f(m, h) {
            return b(h, m);
          }
        },
        map: g.map,
        filter: g.grep,
        every: function(v, b) {
          var f = !0;
          return v ? (g.each(v, function(m, h) {
            if (!(f = b.call(null, h, m, v)))
              return !1;
          }), !!f) : f;
        },
        some: function(v, b) {
          var f = !1;
          return v ? (g.each(v, function(m, h) {
            if (f = b.call(null, h, m, v))
              return !1;
          }), !!f) : f;
        },
        mixin: g.extend,
        identity: function(v) {
          return v;
        },
        clone: function(v) {
          return g.extend(!0, {}, v);
        },
        getIdGenerator: function() {
          var v = 0;
          return function() {
            return v++;
          };
        },
        templatify: function(b) {
          return g.isFunction(b) ? b : f;
          function f() {
            return String(b);
          }
        },
        defer: function(v) {
          setTimeout(v, 0);
        },
        debounce: function(v, b, f) {
          var m, h;
          return function() {
            var c = this, o = arguments, p, k;
            return p = function() {
              m = null, f || (h = v.apply(c, o));
            }, k = f && !m, clearTimeout(m), m = setTimeout(p, b), k && (h = v.apply(c, o)), h;
          };
        },
        throttle: function(v, b) {
          var f, m, h, c, o, p;
          return o = 0, p = function() {
            o = new Date(), h = null, c = v.apply(f, m);
          }, function() {
            var k = new Date(), n = b - (k - o);
            return f = this, m = arguments, n <= 0 ? (clearTimeout(h), h = null, o = k, c = v.apply(f, m)) : h || (h = setTimeout(p, n)), c;
          };
        },
        stringify: function(v) {
          return u.isString(v) ? v : JSON.stringify(v);
        },
        guid: function() {
          function v(b) {
            var f = (Math.random().toString(16) + "000000000").substr(2, 8);
            return b ? "-" + f.substr(0, 4) + "-" + f.substr(4, 4) : f;
          }
          return "tt-" + v() + v(!0) + v(!0) + v();
        },
        noop: function() {
        }
      };
    }(), K = function() {
      var v = {
        wrapper: "twitter-typeahead",
        input: "tt-input",
        hint: "tt-hint",
        menu: "tt-menu",
        dataset: "tt-dataset",
        suggestion: "tt-suggestion",
        selectable: "tt-selectable",
        empty: "tt-empty",
        open: "tt-open",
        cursor: "tt-cursor",
        highlight: "tt-highlight"
      };
      return b;
      function b(c) {
        var o, p;
        return p = u.mixin({}, v, c), o = {
          css: h(),
          classes: p,
          html: f(p),
          selectors: m(p)
        }, {
          css: o.css,
          html: o.html,
          classes: o.classes,
          selectors: o.selectors,
          mixin: function(k) {
            u.mixin(k, o);
          }
        };
      }
      function f(c) {
        return {
          wrapper: '<span class="' + c.wrapper + '"></span>',
          menu: '<div role="listbox" class="' + c.menu + '"></div>'
        };
      }
      function m(c) {
        var o = {};
        return u.each(c, function(p, k) {
          o[k] = "." + p;
        }), o;
      }
      function h() {
        var c = {
          wrapper: {
            position: "relative",
            display: "inline-block"
          },
          hint: {
            position: "absolute",
            top: "0",
            left: "0",
            borderColor: "transparent",
            boxShadow: "none",
            opacity: "1"
          },
          input: {
            position: "relative",
            verticalAlign: "top",
            backgroundColor: "transparent"
          },
          inputWithNoHint: {
            position: "relative",
            verticalAlign: "top"
          },
          menu: {
            position: "absolute",
            top: "100%",
            left: "0",
            zIndex: "100",
            display: "none"
          },
          ltr: {
            left: "0",
            right: "auto"
          },
          rtl: {
            left: "auto",
            right: " 0"
          }
        };
        return u.isMsie() && u.mixin(c.input, {
          backgroundImage: "url(data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7)"
        }), c;
      }
    }(), U = function() {
      var v, b;
      v = "typeahead:", b = {
        render: "rendered",
        cursorchange: "cursorchanged",
        select: "selected",
        autocomplete: "autocompleted"
      };
      function f(m) {
        (!m || !m.el) && g.error("EventBus initialized without el"), this.$el = g(m.el);
      }
      return u.mixin(f.prototype, {
        _trigger: function(m, h) {
          var c = g.Event(v + m);
          return this.$el.trigger.call(this.$el, c, h || []), c;
        },
        before: function(m) {
          var h, c;
          return h = [].slice.call(arguments, 1), c = this._trigger("before" + m, h), c.isDefaultPrevented();
        },
        trigger: function(m) {
          var h;
          this._trigger(m, [].slice.call(arguments, 1)), (h = b[m]) && this._trigger(h, [].slice.call(arguments, 1));
        }
      }), f;
    }(), B = function() {
      var v = /\s+/, b = k();
      return {
        onSync: h,
        onAsync: m,
        off: c,
        trigger: o
      };
      function f(_, A, F, $) {
        var G;
        if (!F)
          return this;
        for (A = A.split(v), F = $ ? n(F, $) : F, this._callbacks = this._callbacks || {}; G = A.shift(); )
          this._callbacks[G] = this._callbacks[G] || {
            sync: [],
            async: []
          }, this._callbacks[G][_].push(F);
        return this;
      }
      function m(_, A, F) {
        return f.call(this, "async", _, A, F);
      }
      function h(_, A, F) {
        return f.call(this, "sync", _, A, F);
      }
      function c(_) {
        var A;
        if (!this._callbacks)
          return this;
        for (_ = _.split(v); A = _.shift(); )
          delete this._callbacks[A];
        return this;
      }
      function o(_) {
        var A, F, $, G, oe;
        if (!this._callbacks)
          return this;
        for (_ = _.split(v), $ = [].slice.call(arguments, 1); (A = _.shift()) && (F = this._callbacks[A]); )
          G = p(F.sync, this, [A].concat($)), oe = p(F.async, this, [A].concat($)), G() && b(oe);
        return this;
      }
      function p(_, A, F) {
        return $;
        function $() {
          for (var G, oe = 0, be = _.length; !G && oe < be; oe += 1)
            G = _[oe].apply(A, F) === !1;
          return !G;
        }
      }
      function k() {
        var _;
        return window.setImmediate ? _ = function(F) {
          setImmediate(function() {
            F();
          });
        } : _ = function(F) {
          setTimeout(function() {
            F();
          }, 0);
        }, _;
      }
      function n(_, A) {
        return _.bind ? _.bind(A) : function() {
          _.apply(A, [].slice.call(arguments, 0));
        };
      }
    }(), M = function(v) {
      var b = {
        node: null,
        pattern: null,
        tagName: "strong",
        className: null,
        wordsOnly: !1,
        caseSensitive: !1,
        diacriticInsensitive: !1
      }, f = {
        A: "[Aa\xAA\xC0-\xC5\xE0-\xE5\u0100-\u0105\u01CD\u01CE\u0200-\u0203\u0226\u0227\u1D2C\u1D43\u1E00\u1E01\u1E9A\u1EA0-\u1EA3\u2090\u2100\u2101\u213B\u249C\u24B6\u24D0\u3371-\u3374\u3380-\u3384\u3388\u3389\u33A9-\u33AF\u33C2\u33CA\u33DF\u33FF\uFF21\uFF41]",
        B: "[Bb\u1D2E\u1D47\u1E02-\u1E07\u212C\u249D\u24B7\u24D1\u3374\u3385-\u3387\u33C3\u33C8\u33D4\u33DD\uFF22\uFF42]",
        C: "[Cc\xC7\xE7\u0106-\u010D\u1D9C\u2100\u2102\u2103\u2105\u2106\u212D\u216D\u217D\u249E\u24B8\u24D2\u3376\u3388\u3389\u339D\u33A0\u33A4\u33C4-\u33C7\uFF23\uFF43]",
        D: "[Dd\u010E\u010F\u01C4-\u01C6\u01F1-\u01F3\u1D30\u1D48\u1E0A-\u1E13\u2145\u2146\u216E\u217E\u249F\u24B9\u24D3\u32CF\u3372\u3377-\u3379\u3397\u33AD-\u33AF\u33C5\u33C8\uFF24\uFF44]",
        E: "[Ee\xC8-\xCB\xE8-\xEB\u0112-\u011B\u0204-\u0207\u0228\u0229\u1D31\u1D49\u1E18-\u1E1B\u1EB8-\u1EBD\u2091\u2121\u212F\u2130\u2147\u24A0\u24BA\u24D4\u3250\u32CD\u32CE\uFF25\uFF45]",
        F: "[Ff\u1DA0\u1E1E\u1E1F\u2109\u2131\u213B\u24A1\u24BB\u24D5\u338A-\u338C\u3399\uFB00-\uFB04\uFF26\uFF46]",
        G: "[Gg\u011C-\u0123\u01E6\u01E7\u01F4\u01F5\u1D33\u1D4D\u1E20\u1E21\u210A\u24A2\u24BC\u24D6\u32CC\u32CD\u3387\u338D-\u338F\u3393\u33AC\u33C6\u33C9\u33D2\u33FF\uFF27\uFF47]",
        H: "[Hh\u0124\u0125\u021E\u021F\u02B0\u1D34\u1E22-\u1E2B\u1E96\u210B-\u210E\u24A3\u24BD\u24D7\u32CC\u3371\u3390-\u3394\u33CA\u33CB\u33D7\uFF28\uFF48]",
        I: "[Ii\xCC-\xCF\xEC-\xEF\u0128-\u0130\u0132\u0133\u01CF\u01D0\u0208-\u020B\u1D35\u1D62\u1E2C\u1E2D\u1EC8-\u1ECB\u2071\u2110\u2111\u2139\u2148\u2160-\u2163\u2165-\u2168\u216A\u216B\u2170-\u2173\u2175-\u2178\u217A\u217B\u24A4\u24BE\u24D8\u337A\u33CC\u33D5\uFB01\uFB03\uFF29\uFF49]",
        J: "[Jj\u0132-\u0135\u01C7-\u01CC\u01F0\u02B2\u1D36\u2149\u24A5\u24BF\u24D9\u2C7C\uFF2A\uFF4A]",
        K: "[Kk\u0136\u0137\u01E8\u01E9\u1D37\u1D4F\u1E30-\u1E35\u212A\u24A6\u24C0\u24DA\u3384\u3385\u3389\u338F\u3391\u3398\u339E\u33A2\u33A6\u33AA\u33B8\u33BE\u33C0\u33C6\u33CD-\u33CF\uFF2B\uFF4B]",
        L: "[Ll\u0139-\u0140\u01C7-\u01C9\u02E1\u1D38\u1E36\u1E37\u1E3A-\u1E3D\u2112\u2113\u2121\u216C\u217C\u24A7\u24C1\u24DB\u32CF\u3388\u3389\u33D0-\u33D3\u33D5\u33D6\u33FF\uFB02\uFB04\uFF2C\uFF4C]",
        M: "[Mm\u1D39\u1D50\u1E3E-\u1E43\u2120\u2122\u2133\u216F\u217F\u24A8\u24C2\u24DC\u3377-\u3379\u3383\u3386\u338E\u3392\u3396\u3399-\u33A8\u33AB\u33B3\u33B7\u33B9\u33BD\u33BF\u33C1\u33C2\u33CE\u33D0\u33D4-\u33D6\u33D8\u33D9\u33DE\u33DF\uFF2D\uFF4D]",
        N: "[Nn\xD1\xF1\u0143-\u0149\u01CA-\u01CC\u01F8\u01F9\u1D3A\u1E44-\u1E4B\u207F\u2115\u2116\u24A9\u24C3\u24DD\u3381\u338B\u339A\u33B1\u33B5\u33BB\u33CC\u33D1\uFF2E\uFF4E]",
        O: "[Oo\xBA\xD2-\xD6\xF2-\xF6\u014C-\u0151\u01A0\u01A1\u01D1\u01D2\u01EA\u01EB\u020C-\u020F\u022E\u022F\u1D3C\u1D52\u1ECC-\u1ECF\u2092\u2105\u2116\u2134\u24AA\u24C4\u24DE\u3375\u33C7\u33D2\u33D6\uFF2F\uFF4F]",
        P: "[Pp\u1D3E\u1D56\u1E54-\u1E57\u2119\u24AB\u24C5\u24DF\u3250\u3371\u3376\u3380\u338A\u33A9-\u33AC\u33B0\u33B4\u33BA\u33CB\u33D7-\u33DA\uFF30\uFF50]",
        Q: "[Qq\u211A\u24AC\u24C6\u24E0\u33C3\uFF31\uFF51]",
        R: "[Rr\u0154-\u0159\u0210-\u0213\u02B3\u1D3F\u1D63\u1E58-\u1E5B\u1E5E\u1E5F\u20A8\u211B-\u211D\u24AD\u24C7\u24E1\u32CD\u3374\u33AD-\u33AF\u33DA\u33DB\uFF32\uFF52]",
        S: "[Ss\u015A-\u0161\u017F\u0218\u0219\u02E2\u1E60-\u1E63\u20A8\u2101\u2120\u24AE\u24C8\u24E2\u33A7\u33A8\u33AE-\u33B3\u33DB\u33DC\uFB06\uFF33\uFF53]",
        T: "[Tt\u0162-\u0165\u021A\u021B\u1D40\u1D57\u1E6A-\u1E71\u1E97\u2121\u2122\u24AF\u24C9\u24E3\u3250\u32CF\u3394\u33CF\uFB05\uFB06\uFF34\uFF54]",
        U: "[Uu\xD9-\xDC\xF9-\xFC\u0168-\u0173\u01AF\u01B0\u01D3\u01D4\u0214-\u0217\u1D41\u1D58\u1D64\u1E72-\u1E77\u1EE4-\u1EE7\u2106\u24B0\u24CA\u24E4\u3373\u337A\uFF35\uFF55]",
        V: "[Vv\u1D5B\u1D65\u1E7C-\u1E7F\u2163-\u2167\u2173-\u2177\u24B1\u24CB\u24E5\u2C7D\u32CE\u3375\u33B4-\u33B9\u33DC\u33DE\uFF36\uFF56]",
        W: "[Ww\u0174\u0175\u02B7\u1D42\u1E80-\u1E89\u1E98\u24B2\u24CC\u24E6\u33BA-\u33BF\u33DD\uFF37\uFF57]",
        X: "[Xx\u02E3\u1E8A-\u1E8D\u2093\u213B\u2168-\u216B\u2178-\u217B\u24B3\u24CD\u24E7\u33D3\uFF38\uFF58]",
        Y: "[Yy\xDD\xFD\xFF\u0176-\u0178\u0232\u0233\u02B8\u1E8E\u1E8F\u1E99\u1EF2-\u1EF9\u24B4\u24CE\u24E8\u33C9\uFF39\uFF59]",
        Z: "[Zz\u0179-\u017E\u01F1-\u01F3\u1DBB\u1E90-\u1E95\u2124\u2128\u24B5\u24CF\u24E9\u3390-\u3394\uFF3A\uFF5A]"
      };
      return function(o) {
        var p;
        if (o = u.mixin({}, b, o), !o.node || !o.pattern)
          return;
        o.pattern = u.isArray(o.pattern) ? o.pattern : [o.pattern], p = h(o.pattern, o.caseSensitive, o.wordsOnly, o.diacriticInsensitive), n(o.node, k);
        function k(_) {
          var A, F, $;
          return (A = p.exec(_.data)) && ($ = v.createElement(o.tagName), o.className && ($.className = o.className), F = _.splitText(A.index), F.splitText(A[0].length), $.appendChild(F.cloneNode(!0)), _.parentNode.replaceChild($, F)), !!A;
        }
        function n(_, A) {
          for (var F, $ = 3, G = 0; G < _.childNodes.length; G++)
            F = _.childNodes[G], F.nodeType === $ ? G += A(F) ? 1 : 0 : n(F, A);
        }
      };
      function m(c) {
        return f[c.toUpperCase()] || c;
      }
      function h(c, o, p, k) {
        for (var n = [], _, A = 0, F = c.length; A < F; A++) {
          var $ = u.escapeRegExChars(c[A]);
          k && ($ = $.replace(/\S/g, m)), n.push($);
        }
        return _ = p ? "\\b(" + n.join("|") + ")\\b" : "(" + n.join("|") + ")", o ? new RegExp(_) : new RegExp(_, "i");
      }
    }(window.document), R = function() {
      var v;
      v = {
        9: "tab",
        27: "esc",
        37: "left",
        39: "right",
        13: "enter",
        38: "up",
        40: "down"
      };
      function b(c, o) {
        var p;
        c = c || {}, c.input || g.error("input is missing"), o.mixin(this), this.$hint = g(c.hint), this.$input = g(c.input), this.$menu = g(c.menu), p = this.$input.attr("id") || u.guid(), this.$menu.attr("id", p + "_listbox"), this.$hint.attr({
          "aria-hidden": !0
        }), this.$input.attr({
          "aria-owns": p + "_listbox",
          role: "combobox",
          "aria-autocomplete": "list",
          "aria-expanded": !1
        }), this.query = this.$input.val(), this.queryWhenFocused = this.hasFocus() ? this.query : null, this.$overflowHelper = f(this.$input), this._checkLanguageDirection(), this.$hint.length === 0 && (this.setHint = this.getHint = this.clearHint = this.clearHintIfInvalid = u.noop), this.onSync("cursorchange", this._updateDescendent);
      }
      return b.normalizeQuery = function(c) {
        return u.toStr(c).replace(/^\s*/g, "").replace(/\s{2,}/g, " ");
      }, u.mixin(b.prototype, B, {
        _onBlur: function() {
          this.resetInputValue(), this.trigger("blurred");
        },
        _onFocus: function() {
          this.queryWhenFocused = this.query, this.trigger("focused");
        },
        _onKeydown: function(o) {
          var p = v[o.which || o.keyCode];
          this._managePreventDefault(p, o), p && this._shouldTrigger(p, o) && this.trigger(p + "Keyed", o);
        },
        _onInput: function() {
          this._setQuery(this.getInputValue()), this.clearHintIfInvalid(), this._checkLanguageDirection();
        },
        _managePreventDefault: function(o, p) {
          var k;
          switch (o) {
            case "up":
            case "down":
              k = !h(p);
              break;
            default:
              k = !1;
          }
          k && p.preventDefault();
        },
        _shouldTrigger: function(o, p) {
          var k;
          switch (o) {
            case "tab":
              k = !h(p);
              break;
            default:
              k = !0;
          }
          return k;
        },
        _checkLanguageDirection: function() {
          var o = (this.$input.css("direction") || "ltr").toLowerCase();
          this.dir !== o && (this.dir = o, this.$hint.attr("dir", o), this.trigger("langDirChanged", o));
        },
        _setQuery: function(o, p) {
          var k, n;
          k = m(o, this.query), n = k ? this.query.length !== o.length : !1, this.query = o, !p && !k ? this.trigger("queryChanged", this.query) : !p && n && this.trigger("whitespaceChanged", this.query);
        },
        _updateDescendent: function(o, p) {
          this.$input.attr("aria-activedescendant", p);
        },
        bind: function() {
          var c = this, o, p, k, n;
          return o = u.bind(this._onBlur, this), p = u.bind(this._onFocus, this), k = u.bind(this._onKeydown, this), n = u.bind(this._onInput, this), this.$input.on("blur.tt", o).on("focus.tt", p).on("keydown.tt", k), !u.isMsie() || u.isMsie() > 9 ? this.$input.on("input.tt", n) : this.$input.on("keydown.tt keypress.tt cut.tt paste.tt", function(_) {
            v[_.which || _.keyCode] || u.defer(u.bind(c._onInput, c, _));
          }), this;
        },
        focus: function() {
          this.$input.focus();
        },
        blur: function() {
          this.$input.blur();
        },
        getLangDir: function() {
          return this.dir;
        },
        getQuery: function() {
          return this.query || "";
        },
        setQuery: function(o, p) {
          this.setInputValue(o), this._setQuery(o, p);
        },
        hasQueryChangedSinceLastFocus: function() {
          return this.query !== this.queryWhenFocused;
        },
        getInputValue: function() {
          return this.$input.val();
        },
        setInputValue: function(o) {
          this.$input.val(o), this.clearHintIfInvalid(), this._checkLanguageDirection();
        },
        resetInputValue: function() {
          this.setInputValue(this.query);
        },
        getHint: function() {
          return this.$hint.val();
        },
        setHint: function(o) {
          this.$hint.val(o);
        },
        clearHint: function() {
          this.setHint("");
        },
        clearHintIfInvalid: function() {
          var o, p, k, n;
          o = this.getInputValue(), p = this.getHint(), k = o !== p && p.indexOf(o) === 0, n = o !== "" && k && !this.hasOverflow(), !n && this.clearHint();
        },
        hasFocus: function() {
          return this.$input.is(":focus");
        },
        hasOverflow: function() {
          var o = this.$input.width() - 2;
          return this.$overflowHelper.text(this.getInputValue()), this.$overflowHelper.width() >= o;
        },
        isCursorAtEnd: function() {
          var c, o, p;
          return c = this.$input.val().length, o = this.$input[0].selectionStart, u.isNumber(o) ? o === c : document.selection ? (p = document.selection.createRange(), p.moveStart("character", -c), c === p.text.length) : !0;
        },
        destroy: function() {
          this.$hint.off(".tt"), this.$input.off(".tt"), this.$overflowHelper.remove(), this.$hint = this.$input = this.$overflowHelper = g("<div>");
        },
        setAriaExpanded: function(o) {
          this.$input.attr("aria-expanded", o);
        }
      }), b;
      function f(c) {
        return g('<pre aria-hidden="true"></pre>').css({
          position: "absolute",
          visibility: "hidden",
          whiteSpace: "pre",
          fontFamily: c.css("font-family"),
          fontSize: c.css("font-size"),
          fontStyle: c.css("font-style"),
          fontVariant: c.css("font-variant"),
          fontWeight: c.css("font-weight"),
          wordSpacing: c.css("word-spacing"),
          letterSpacing: c.css("letter-spacing"),
          textIndent: c.css("text-indent"),
          textRendering: c.css("text-rendering"),
          textTransform: c.css("text-transform")
        }).insertAfter(c);
      }
      function m(c, o) {
        return b.normalizeQuery(c) === b.normalizeQuery(o);
      }
      function h(c) {
        return c.altKey || c.ctrlKey || c.metaKey || c.shiftKey;
      }
    }(), re = function() {
      var v, b;
      v = {
        dataset: "tt-selectable-dataset",
        val: "tt-selectable-display",
        obj: "tt-selectable-object"
      }, b = u.getIdGenerator();
      function f(o, p) {
        o = o || {}, o.templates = o.templates || {}, o.templates.notFound = o.templates.notFound || o.templates.empty, o.source || g.error("missing source"), o.node || g.error("missing node"), o.name && !c(o.name) && g.error("invalid dataset name: " + o.name), p.mixin(this), this.highlight = !!o.highlight, this.name = u.toStr(o.name || b()), this.limit = o.limit || 5, this.displayFn = m(o.display || o.displayKey), this.templates = h(o.templates, this.displayFn), this.source = o.source.__ttAdapter ? o.source.__ttAdapter() : o.source, this.async = u.isUndefined(o.async) ? this.source.length > 2 : !!o.async, this._resetLastSuggestion(), this.$el = g(o.node).attr("role", "presentation").addClass(this.classes.dataset).addClass(this.classes.dataset + "-" + this.name);
      }
      return f.extractData = function(p) {
        var k = g(p);
        return k.data(v.obj) ? {
          dataset: k.data(v.dataset) || "",
          val: k.data(v.val) || "",
          obj: k.data(v.obj) || null
        } : null;
      }, u.mixin(f.prototype, B, {
        _overwrite: function(p, k) {
          k = k || [], k.length ? this._renderSuggestions(p, k) : this.async && this.templates.pending ? this._renderPending(p) : !this.async && this.templates.notFound ? this._renderNotFound(p) : this._empty(), this.trigger("rendered", k, !1, this.name);
        },
        _append: function(p, k) {
          k = k || [], k.length && this.$lastSuggestion.length ? this._appendSuggestions(p, k) : k.length ? this._renderSuggestions(p, k) : !this.$lastSuggestion.length && this.templates.notFound && this._renderNotFound(p), this.trigger("rendered", k, !0, this.name);
        },
        _renderSuggestions: function(p, k) {
          var n;
          n = this._getSuggestionsFragment(p, k), this.$lastSuggestion = n.children().last(), this.$el.html(n).prepend(this._getHeader(p, k)).append(this._getFooter(p, k));
        },
        _appendSuggestions: function(p, k) {
          var n, _;
          n = this._getSuggestionsFragment(p, k), _ = n.children().last(), this.$lastSuggestion.after(n), this.$lastSuggestion = _;
        },
        _renderPending: function(p) {
          var k = this.templates.pending;
          this._resetLastSuggestion(), k && this.$el.html(k({
            query: p,
            dataset: this.name
          }));
        },
        _renderNotFound: function(p) {
          var k = this.templates.notFound;
          this._resetLastSuggestion(), k && this.$el.html(k({
            query: p,
            dataset: this.name
          }));
        },
        _empty: function() {
          this.$el.empty(), this._resetLastSuggestion();
        },
        _getSuggestionsFragment: function(p, k) {
          var n = this, _;
          return _ = document.createDocumentFragment(), u.each(k, function(F) {
            var $, G;
            G = n._injectQuery(p, F), $ = g(n.templates.suggestion(G)).data(v.dataset, n.name).data(v.obj, F).data(v.val, n.displayFn(F)).addClass(n.classes.suggestion + " " + n.classes.selectable), _.appendChild($[0]);
          }), this.highlight && M({
            className: this.classes.highlight,
            node: _,
            pattern: p
          }), g(_);
        },
        _getFooter: function(p, k) {
          return this.templates.footer ? this.templates.footer({
            query: p,
            suggestions: k,
            dataset: this.name
          }) : null;
        },
        _getHeader: function(p, k) {
          return this.templates.header ? this.templates.header({
            query: p,
            suggestions: k,
            dataset: this.name
          }) : null;
        },
        _resetLastSuggestion: function() {
          this.$lastSuggestion = g();
        },
        _injectQuery: function(p, k) {
          return u.isObject(k) ? u.mixin({
            _query: p
          }, k) : k;
        },
        update: function(p) {
          var k = this, n = !1, _ = !1, A = 0;
          this.cancel(), this.cancel = function() {
            n = !0, k.cancel = g.noop, k.async && k.trigger("asyncCanceled", p, k.name);
          }, this.source(p, F, $), !_ && F([]);
          function F(G) {
            _ || (_ = !0, G = (G || []).slice(0, k.limit), A = G.length, k._overwrite(p, G), A < k.limit && k.async && k.trigger("asyncRequested", p, k.name));
          }
          function $(G) {
            if (G = G || [], !n && A < k.limit) {
              k.cancel = g.noop;
              var oe = Math.abs(A - k.limit);
              A += oe, k._append(p, G.slice(0, oe)), k.async && k.trigger("asyncReceived", p, k.name);
            }
          }
        },
        cancel: g.noop,
        clear: function() {
          this._empty(), this.cancel(), this.trigger("cleared");
        },
        isEmpty: function() {
          return this.$el.is(":empty");
        },
        destroy: function() {
          this.$el = g("<div>");
        }
      }), f;
      function m(o) {
        return o = o || u.stringify, u.isFunction(o) ? o : p;
        function p(k) {
          return k[o];
        }
      }
      function h(o, p) {
        return {
          notFound: o.notFound && u.templatify(o.notFound),
          pending: o.pending && u.templatify(o.pending),
          header: o.header && u.templatify(o.header),
          footer: o.footer && u.templatify(o.footer),
          suggestion: o.suggestion ? k : n
        };
        function k(_) {
          var A = o.suggestion;
          return g(A(_)).attr("id", u.guid());
        }
        function n(_) {
          return g('<div role="option">').attr("id", u.guid()).text(p(_));
        }
      }
      function c(o) {
        return /^[_a-zA-Z0-9-]+$/.test(o);
      }
    }(), ue = function() {
      function v(b, f) {
        var m = this;
        b = b || {}, b.node || g.error("node is required"), f.mixin(this), this.$node = g(b.node), this.query = null, this.datasets = u.map(b.datasets, h);
        function h(c) {
          var o = m.$node.find(c.node).first();
          return c.node = o.length ? o : g("<div>").appendTo(m.$node), new re(c, f);
        }
      }
      return u.mixin(v.prototype, B, {
        _onSelectableClick: function(f) {
          this.trigger("selectableClicked", g(f.currentTarget));
        },
        _onRendered: function(f, m, h, c) {
          this.$node.toggleClass(this.classes.empty, this._allDatasetsEmpty()), this.trigger("datasetRendered", m, h, c);
        },
        _onCleared: function() {
          this.$node.toggleClass(this.classes.empty, this._allDatasetsEmpty()), this.trigger("datasetCleared");
        },
        _propagate: function() {
          this.trigger.apply(this, arguments);
        },
        _allDatasetsEmpty: function() {
          return u.every(this.datasets, u.bind(function(m) {
            var h = m.isEmpty();
            return this.$node.attr("aria-expanded", !h), h;
          }, this));
        },
        _getSelectables: function() {
          return this.$node.find(this.selectors.selectable);
        },
        _removeCursor: function() {
          var f = this.getActiveSelectable();
          f && f.removeClass(this.classes.cursor);
        },
        _ensureVisible: function(f) {
          var m, h, c, o;
          m = f.position().top, h = m + f.outerHeight(!0), c = this.$node.scrollTop(), o = this.$node.height() + parseInt(this.$node.css("paddingTop"), 10) + parseInt(this.$node.css("paddingBottom"), 10), m < 0 ? this.$node.scrollTop(c + m) : o < h && this.$node.scrollTop(c + (h - o));
        },
        bind: function() {
          var b = this, f;
          return f = u.bind(this._onSelectableClick, this), this.$node.on("click.tt", this.selectors.selectable, f), this.$node.on("mouseover", this.selectors.selectable, function() {
            b.setCursor(g(this));
          }), this.$node.on("mouseleave", function() {
            b._removeCursor();
          }), u.each(this.datasets, function(m) {
            m.onSync("asyncRequested", b._propagate, b).onSync("asyncCanceled", b._propagate, b).onSync("asyncReceived", b._propagate, b).onSync("rendered", b._onRendered, b).onSync("cleared", b._onCleared, b);
          }), this;
        },
        isOpen: function() {
          return this.$node.hasClass(this.classes.open);
        },
        open: function() {
          this.$node.scrollTop(0), this.$node.addClass(this.classes.open);
        },
        close: function() {
          this.$node.attr("aria-expanded", !1), this.$node.removeClass(this.classes.open), this._removeCursor();
        },
        setLanguageDirection: function(f) {
          this.$node.attr("dir", f);
        },
        selectableRelativeToCursor: function(f) {
          var m, h, c, o;
          return h = this.getActiveSelectable(), m = this._getSelectables(), c = h ? m.index(h) : -1, o = c + f, o = (o + 1) % (m.length + 1) - 1, o = o < -1 ? m.length - 1 : o, o === -1 ? null : m.eq(o);
        },
        setCursor: function(f) {
          this._removeCursor(), (f = f && f.first()) && (f.addClass(this.classes.cursor), this._ensureVisible(f));
        },
        getSelectableData: function(f) {
          return f && f.length ? re.extractData(f) : null;
        },
        getActiveSelectable: function() {
          var f = this._getSelectables().filter(this.selectors.cursor).first();
          return f.length ? f : null;
        },
        getTopSelectable: function() {
          var f = this._getSelectables().first();
          return f.length ? f : null;
        },
        update: function(f) {
          var m = f !== this.query;
          return m && (this.query = f, u.each(this.datasets, h)), m;
          function h(c) {
            c.update(f);
          }
        },
        empty: function() {
          u.each(this.datasets, f), this.query = null, this.$node.addClass(this.classes.empty);
          function f(m) {
            m.clear();
          }
        },
        destroy: function() {
          this.$node.off(".tt"), this.$node = g("<div>"), u.each(this.datasets, f);
          function f(m) {
            m.destroy();
          }
        }
      }), v;
    }(), tt = function() {
      function v(b) {
        this.$el = g("<span></span>", {
          role: "status",
          "aria-live": "polite"
        }).css({
          position: "absolute",
          padding: "0",
          border: "0",
          height: "1px",
          width: "1px",
          "margin-bottom": "-1px",
          "margin-right": "-1px",
          overflow: "hidden",
          clip: "rect(0 0 0 0)",
          "white-space": "nowrap"
        }), b.$input.after(this.$el), u.each(b.menu.datasets, u.bind(function(f) {
          f.onSync && (f.onSync("rendered", u.bind(this.update, this)), f.onSync("cleared", u.bind(this.cleared, this)));
        }, this));
      }
      return u.mixin(v.prototype, {
        update: function(f, m) {
          var h = m.length, c;
          h === 1 ? c = {
            result: "result",
            is: "is"
          } : c = {
            result: "results",
            is: "are"
          }, this.$el.text(h + " " + c.result + " " + c.is + " available, use up and down arrow keys to navigate.");
        },
        cleared: function() {
          this.$el.text("");
        }
      }), v;
    }(), We = function() {
      var v = ue.prototype;
      function b() {
        ue.apply(this, [].slice.call(arguments, 0));
      }
      return u.mixin(b.prototype, ue.prototype, {
        open: function() {
          return !this._allDatasetsEmpty() && this._show(), v.open.apply(this, [].slice.call(arguments, 0));
        },
        close: function() {
          return this._hide(), v.close.apply(this, [].slice.call(arguments, 0));
        },
        _onRendered: function() {
          return this._allDatasetsEmpty() ? this._hide() : this.isOpen() && this._show(), v._onRendered.apply(this, [].slice.call(arguments, 0));
        },
        _onCleared: function() {
          return this._allDatasetsEmpty() ? this._hide() : this.isOpen() && this._show(), v._onCleared.apply(this, [].slice.call(arguments, 0));
        },
        setLanguageDirection: function(m) {
          return this.$node.css(m === "ltr" ? this.css.ltr : this.css.rtl), v.setLanguageDirection.apply(this, [].slice.call(arguments, 0));
        },
        _hide: function() {
          this.$node.hide();
        },
        _show: function() {
          this.$node.css("display", "block");
        }
      }), b;
    }(), nt = function() {
      function v(f, m) {
        var h, c, o, p, k, n, _, A, F, $, G;
        f = f || {}, f.input || g.error("missing input"), f.menu || g.error("missing menu"), f.eventBus || g.error("missing event bus"), m.mixin(this), this.eventBus = f.eventBus, this.minLength = u.isNumber(f.minLength) ? f.minLength : 1, this.input = f.input, this.menu = f.menu, this.enabled = !0, this.autoselect = !!f.autoselect, this.active = !1, this.input.hasFocus() && this.activate(), this.dir = this.input.getLangDir(), this._hacks(), this.menu.bind().onSync("selectableClicked", this._onSelectableClicked, this).onSync("asyncRequested", this._onAsyncRequested, this).onSync("asyncCanceled", this._onAsyncCanceled, this).onSync("asyncReceived", this._onAsyncReceived, this).onSync("datasetRendered", this._onDatasetRendered, this).onSync("datasetCleared", this._onDatasetCleared, this), h = b(this, "activate", "open", "_onFocused"), c = b(this, "deactivate", "_onBlurred"), o = b(this, "isActive", "isOpen", "_onEnterKeyed"), p = b(this, "isActive", "isOpen", "_onTabKeyed"), k = b(this, "isActive", "_onEscKeyed"), n = b(this, "isActive", "open", "_onUpKeyed"), _ = b(this, "isActive", "open", "_onDownKeyed"), A = b(this, "isActive", "isOpen", "_onLeftKeyed"), F = b(this, "isActive", "isOpen", "_onRightKeyed"), $ = b(this, "_openIfActive", "_onQueryChanged"), G = b(this, "_openIfActive", "_onWhitespaceChanged"), this.input.bind().onSync("focused", h, this).onSync("blurred", c, this).onSync("enterKeyed", o, this).onSync("tabKeyed", p, this).onSync("escKeyed", k, this).onSync("upKeyed", n, this).onSync("downKeyed", _, this).onSync("leftKeyed", A, this).onSync("rightKeyed", F, this).onSync("queryChanged", $, this).onSync("whitespaceChanged", G, this).onSync("langDirChanged", this._onLangDirChanged, this);
      }
      return u.mixin(v.prototype, {
        _hacks: function() {
          var m, h;
          m = this.input.$input || g("<div>"), h = this.menu.$node || g("<div>"), m.on("blur.tt", function(c) {
            var o, p, k;
            o = document.activeElement, p = h.is(o), k = h.has(o).length > 0, u.isMsie() && (p || k) && (c.preventDefault(), c.stopImmediatePropagation(), u.defer(function() {
              m.focus();
            }));
          }), h.on("mousedown.tt", function(c) {
            c.preventDefault();
          });
        },
        _onSelectableClicked: function(m, h) {
          this.select(h);
        },
        _onDatasetCleared: function() {
          this._updateHint();
        },
        _onDatasetRendered: function(m, h, c, o) {
          if (this._updateHint(), this.autoselect) {
            var p = this.selectors.cursor.substr(1);
            this.menu.$node.find(this.selectors.suggestion).first().addClass(p);
          }
          this.eventBus.trigger("render", h, c, o);
        },
        _onAsyncRequested: function(m, h, c) {
          this.eventBus.trigger("asyncrequest", c, h);
        },
        _onAsyncCanceled: function(m, h, c) {
          this.eventBus.trigger("asynccancel", c, h);
        },
        _onAsyncReceived: function(m, h, c) {
          this.eventBus.trigger("asyncreceive", c, h);
        },
        _onFocused: function() {
          this._minLengthMet() && this.menu.update(this.input.getQuery());
        },
        _onBlurred: function() {
          this.input.hasQueryChangedSinceLastFocus() && this.eventBus.trigger("change", this.input.getQuery());
        },
        _onEnterKeyed: function(m, h) {
          var c;
          (c = this.menu.getActiveSelectable()) ? this.select(c) && (h.preventDefault(), h.stopPropagation()) : this.autoselect && this.select(this.menu.getTopSelectable()) && (h.preventDefault(), h.stopPropagation());
        },
        _onTabKeyed: function(m, h) {
          var c;
          (c = this.menu.getActiveSelectable()) ? this.select(c) && h.preventDefault() : this.autoselect && (c = this.menu.getTopSelectable()) && this.autocomplete(c) && h.preventDefault();
        },
        _onEscKeyed: function() {
          this.close();
        },
        _onUpKeyed: function() {
          this.moveCursor(-1);
        },
        _onDownKeyed: function() {
          this.moveCursor(1);
        },
        _onLeftKeyed: function() {
          this.dir === "rtl" && this.input.isCursorAtEnd() && this.autocomplete(this.menu.getActiveSelectable() || this.menu.getTopSelectable());
        },
        _onRightKeyed: function() {
          this.dir === "ltr" && this.input.isCursorAtEnd() && this.autocomplete(this.menu.getActiveSelectable() || this.menu.getTopSelectable());
        },
        _onQueryChanged: function(m, h) {
          this._minLengthMet(h) ? this.menu.update(h) : this.menu.empty();
        },
        _onWhitespaceChanged: function() {
          this._updateHint();
        },
        _onLangDirChanged: function(m, h) {
          this.dir !== h && (this.dir = h, this.menu.setLanguageDirection(h));
        },
        _openIfActive: function() {
          this.isActive() && this.open();
        },
        _minLengthMet: function(m) {
          return m = u.isString(m) ? m : this.input.getQuery() || "", m.length >= this.minLength;
        },
        _updateHint: function() {
          var m, h, c, o, p, k, n;
          m = this.menu.getTopSelectable(), h = this.menu.getSelectableData(m), c = this.input.getInputValue(), h && !u.isBlankString(c) && !this.input.hasOverflow() ? (o = R.normalizeQuery(c), p = u.escapeRegExChars(o), k = new RegExp("^(?:" + p + ")(.+$)", "i"), n = k.exec(h.val), n && this.input.setHint(c + n[1])) : this.input.clearHint();
        },
        isEnabled: function() {
          return this.enabled;
        },
        enable: function() {
          this.enabled = !0;
        },
        disable: function() {
          this.enabled = !1;
        },
        isActive: function() {
          return this.active;
        },
        activate: function() {
          return this.isActive() ? !0 : !this.isEnabled() || this.eventBus.before("active") ? !1 : (this.active = !0, this.eventBus.trigger("active"), !0);
        },
        deactivate: function() {
          return this.isActive() ? this.eventBus.before("idle") ? !1 : (this.active = !1, this.close(), this.eventBus.trigger("idle"), !0) : !0;
        },
        isOpen: function() {
          return this.menu.isOpen();
        },
        open: function() {
          return !this.isOpen() && !this.eventBus.before("open") && (this.input.setAriaExpanded(!0), this.menu.open(), this._updateHint(), this.eventBus.trigger("open")), this.isOpen();
        },
        close: function() {
          return this.isOpen() && !this.eventBus.before("close") && (this.input.setAriaExpanded(!1), this.menu.close(), this.input.clearHint(), this.input.resetInputValue(), this.eventBus.trigger("close")), !this.isOpen();
        },
        setVal: function(m) {
          this.input.setQuery(u.toStr(m));
        },
        getVal: function() {
          return this.input.getQuery();
        },
        select: function(m) {
          var h = this.menu.getSelectableData(m);
          return h && !this.eventBus.before("select", h.obj, h.dataset) ? (this.input.setQuery(h.val, !0), this.eventBus.trigger("select", h.obj, h.dataset), this.close(), !0) : !1;
        },
        autocomplete: function(m) {
          var h, c, o;
          return h = this.input.getQuery(), c = this.menu.getSelectableData(m), o = c && h !== c.val, o && !this.eventBus.before("autocomplete", c.obj, c.dataset) ? (this.input.setQuery(c.val), this.eventBus.trigger("autocomplete", c.obj, c.dataset), !0) : !1;
        },
        moveCursor: function(m) {
          var h, c, o, p, k, n, _;
          return h = this.input.getQuery(), c = this.menu.selectableRelativeToCursor(m), o = this.menu.getSelectableData(c), p = o ? o.obj : null, k = o ? o.dataset : null, _ = c ? c.attr("id") : null, this.input.trigger("cursorchange", _), n = this._minLengthMet() && this.menu.update(h), !n && !this.eventBus.before("cursorchange", p, k) ? (this.menu.setCursor(c), o ? typeof o.val == "string" && this.input.setInputValue(o.val) : (this.input.resetInputValue(), this._updateHint()), this.eventBus.trigger("cursorchange", p, k), !0) : !1;
        },
        destroy: function() {
          this.input.destroy(), this.menu.destroy();
        }
      }), v;
      function b(f) {
        var m = [].slice.call(arguments, 1);
        return function() {
          var h = [].slice.call(arguments);
          u.each(m, function(c) {
            return f[c].apply(f, h);
          });
        };
      }
    }();
    (function() {
      var v, b, f;
      v = g.fn.typeahead, b = {
        www: "tt-www",
        attrs: "tt-attrs",
        typeahead: "tt-typeahead"
      }, f = {
        initialize: function(_, A) {
          var F;
          return A = u.isArray(A) ? A : [].slice.call(arguments, 1), _ = _ || {}, F = K(_.classNames), this.each($);
          function $() {
            var G, oe, be, Qe, it, ot, jt, zt, xt, Dt, Ne;
            u.each(A, function(un) {
              un.highlight = !!_.highlight;
            }), G = g(this), oe = g(F.html.wrapper), be = k(_.hint), Qe = k(_.menu), it = _.hint !== !1 && !be, ot = _.menu !== !1 && !Qe, it && (be = h(G, F)), ot && (Qe = g(F.html.menu).css(F.css.menu)), be && be.val(""), G = c(G, F), (it || ot) && (oe.css(F.css.wrapper), G.css(it ? F.css.input : F.css.inputWithNoHint), G.wrap(oe).parent().prepend(it ? be : null).append(ot ? Qe : null)), Ne = ot ? We : ue, jt = new U({
              el: G
            }), zt = new R({
              hint: be,
              input: G,
              menu: Qe
            }, F), xt = new Ne({
              node: Qe,
              datasets: A
            }, F), new tt({
              $input: G,
              menu: xt
            }), Dt = new nt({
              input: zt,
              menu: xt,
              eventBus: jt,
              minLength: _.minLength,
              autoselect: _.autoselect
            }, F), G.data(b.www, F), G.data(b.typeahead, Dt);
          }
        },
        isEnabled: function() {
          var _;
          return m(this.first(), function(A) {
            _ = A.isEnabled();
          }), _;
        },
        enable: function() {
          return m(this, function(_) {
            _.enable();
          }), this;
        },
        disable: function() {
          return m(this, function(_) {
            _.disable();
          }), this;
        },
        isActive: function() {
          var _;
          return m(this.first(), function(A) {
            _ = A.isActive();
          }), _;
        },
        activate: function() {
          return m(this, function(_) {
            _.activate();
          }), this;
        },
        deactivate: function() {
          return m(this, function(_) {
            _.deactivate();
          }), this;
        },
        isOpen: function() {
          var _;
          return m(this.first(), function(A) {
            _ = A.isOpen();
          }), _;
        },
        open: function() {
          return m(this, function(_) {
            _.open();
          }), this;
        },
        close: function() {
          return m(this, function(_) {
            _.close();
          }), this;
        },
        select: function(_) {
          var A = !1, F = g(_);
          return m(this.first(), function($) {
            A = $.select(F);
          }), A;
        },
        autocomplete: function(_) {
          var A = !1, F = g(_);
          return m(this.first(), function($) {
            A = $.autocomplete(F);
          }), A;
        },
        moveCursor: function(_) {
          var A = !1;
          return m(this.first(), function(F) {
            A = F.moveCursor(_);
          }), A;
        },
        val: function(_) {
          var A;
          return arguments.length ? (m(this, function(F) {
            F.setVal(u.toStr(_));
          }), this) : (m(this.first(), function(F) {
            A = F.getVal();
          }), A);
        },
        destroy: function() {
          return m(this, function(_, A) {
            p(A), _.destroy();
          }), this;
        }
      }, g.fn.typeahead = function(n) {
        return f[n] ? f[n].apply(this, [].slice.call(arguments, 1)) : f.initialize.apply(this, arguments);
      }, g.fn.typeahead.noConflict = function() {
        return g.fn.typeahead = v, this;
      };
      function m(n, _) {
        n.each(function() {
          var A = g(this), F;
          (F = A.data(b.typeahead)) && _(F, A);
        });
      }
      function h(n, _) {
        return n.clone().addClass(_.classes.hint).removeData().css(_.css.hint).css(o(n)).prop({
          readonly: !0,
          required: !1
        }).removeAttr("id name placeholder").removeClass("required").attr({
          spellcheck: "false",
          tabindex: -1
        });
      }
      function c(n, _) {
        n.data(b.attrs, {
          dir: n.attr("dir"),
          autocomplete: n.attr("autocomplete"),
          spellcheck: n.attr("spellcheck"),
          style: n.attr("style")
        }), n.addClass(_.classes.input).attr({
          spellcheck: !1
        });
        try {
          !n.attr("dir") && n.attr("dir", "auto");
        } catch {
        }
        return n;
      }
      function o(n) {
        return {
          backgroundAttachment: n.css("background-attachment"),
          backgroundClip: n.css("background-clip"),
          backgroundColor: n.css("background-color"),
          backgroundImage: n.css("background-image"),
          backgroundOrigin: n.css("background-origin"),
          backgroundPosition: n.css("background-position"),
          backgroundRepeat: n.css("background-repeat"),
          backgroundSize: n.css("background-size")
        };
      }
      function p(n) {
        var _, A;
        _ = n.data(b.www), A = n.parent().filter(_.selectors.wrapper), u.each(n.data(b.attrs), function(F, $) {
          u.isUndefined(F) ? n.removeAttr($) : n.attr($, F);
        }), n.removeData(b.typeahead).removeData(b.www).removeData(b.attr).removeClass(_.classes.input), A.length && (n.detach().insertAfter(A), A.remove());
      }
      function k(n) {
        var _, A;
        return _ = u.isJQuery(n) || u.isElement(n), A = _ ? g(n).first() : [], A.length ? A : null;
      }
    })();
  });
})(ru);
const au = {
  install(s, g) {
    Object.keys(Si).forEach((u) => {
      s.component(u, Si[u]);
    });
  }
};
export {
  Si as components,
  au as harnessVueBootstrap
};
